//{{AVR_IO_DESIGNER_INIT
	// C:\Develop\AVR\AnalogPwm\AnalogPwm.aid

	//
	// Project Options - AnalogPwm
	//
	// Device Name = ATtiny84
	// CPU Frequency (F_CPU) = 1.0 MHz
	// IC Package = SOIC
	// Sort Pins by = Port Function
	// Output Code File = AnalogPwmInit.c
	// Output Header File = AnalogPwmInit.h
	// Assume Default State = True
	// Write Unmodified Bits = True
	// Set Unused PORT Pins = Input with Pullup

	//
	// PORTA variable initializations
	//
	// PORTA0 for 1: ainSteering as Input - Analog input for steering
	// PORTA1 for 1: ainThrottle as Input - Analog input for throttle
	// PORTA2 for 1: ainBrake as Input - Analog input for brake
	// PORTA3 for 1: reserved1 as Input with pullups - Reserved for pin PCINT3
	// PORTA4 for 1: reserved2 as Input with pullups - 
	// PORTA5 for 1: __OC1B as Output - Reserved for pin OC1B
	// PORTA6 for 1: __OC1A as Output - Reserved for pin OC1A
	// PORTA7 for 1: inAux as Input - 1-bit input from steering
	PORTA = 0x18;
	DDRA = 0x60;

	//
	// PORTB variable initializations
	//
	// PORTB0 for 1: inConfig0 as Input with pullups - 
	// PORTB1 for 1: inConfig1 as Input with pullups - 
	// PORTB2 for 1: inConfig2 as Input with pullups - 
	// PORTB3 for 1: reset as Input with pullups - 
	PORTB = 0x0F;

	//
	// TIMER_COUNTER_1 - PWM_Gen - 
	//
	// Name = PWM_Gen
	// Waveform Generation Mode = Fast PWM TOP=ICR
	// Clock Select = clk (No prescaling)
	// Input Capture Register = 16666
	// Compare Output Mode A = Clear on match, set at TOP
	// Output Compare Register A = 1500
	// Reserve Output Compare Pin A = True
	// Compare Output Mode B = Clear on match, set at TOP
	// Output Compare Register B = 1500
	// Reserve Output Compare Pin B = True
	// Counter Frequency = 59.999 Hz
	// Counter Period = 16.667 msec
	// Seconds per Count = 1.0 usec
	// Counts per Second = 1.0 MHz
	// Input Capture Register Time = 16.666 msec
	// Output Compare Register A Time = 1.5 msec
	// Output Compare Register B Time = 1.5 msec
	// Output Compare Register A Name = cntLeft
	// Output Compare Register A Comment = Counts for left motor PWM
	// Output Compare Register B Name = cntRight
	// Output Compare Register B Comment = Counts for right motor PWM
	TCCR1A = 0xA2;	// (1<<COM1A1)|(0<<COM1A0)|(1<<COM1B1)|(0<<COM1B0)|(1<<WGM11)|(0<<WGM10)
	TCCR1B = 0x19;	// (1<<WGM13)|(1<<WGM12)|(0<<CS12)|(0<<CS11)|(1<<CS10)
	OCR1A = 0x5DC;
	OCR1B = 0x5DC;
	ICR1 = 0x411A;
//}}AVR_IO_DESIGNER_INIT
