//{{AVR_IO_DESIGNER_HDR
// C:\Develop\AVR\AnalogPwm\AnalogPwm.aid

//
// PORTA variable definitions
//
typedef struct
{
	unsigned char	_ainSteering     : 1;	// Analog input for steering
	unsigned char	_ainThrottle     : 1;	// Analog input for throttle
	unsigned char	_ainBrake        : 1;	// Analog input for brake
	unsigned char	_reserved1       : 1;	// Reserved for pin PCINT3
	unsigned char	_reserved2       : 1;	// 
	unsigned char	___OC1B          : 1;	// Reserved for pin OC1B
	unsigned char	___OC1A          : 1;	// Reserved for pin OC1A
	unsigned char	_inAux           : 1;	// 1-bit input from steering
} PORTA_STRUCT;

// PORTA0 for 1: ainSteering as Input - Analog input for steering
#define	ainSteering_PORT        ((volatile PORTA_STRUCT*)&PORTA)        // PORT register
#define	ainSteering_PIN         ((volatile PORTA_STRUCT*)&PINA)         // PIN register
#define	ainSteering_DDR         ((volatile PORTA_STRUCT*)&DDRA)         // DDR register
#define	ainSteering             ainSteering_PIN->_ainSteering           // input
#define	ainSteering_PULLUP      ainSteering_PORT->_ainSteering          // pullup control
#define	ainSteering_DIR         ainSteering_DDR->_ainSteering           // direction control
#define	ainSteering_MASK        0x01                                    // mask
#define	ainSteering_SHIFT       0x00                                    // shift count

// PORTA1 for 1: ainThrottle as Input - Analog input for throttle
#define	ainThrottle_PORT        ((volatile PORTA_STRUCT*)&PORTA)        // PORT register
#define	ainThrottle_PIN         ((volatile PORTA_STRUCT*)&PINA)         // PIN register
#define	ainThrottle_DDR         ((volatile PORTA_STRUCT*)&DDRA)         // DDR register
#define	ainThrottle             ainThrottle_PIN->_ainThrottle           // input
#define	ainThrottle_PULLUP      ainThrottle_PORT->_ainThrottle          // pullup control
#define	ainThrottle_DIR         ainThrottle_DDR->_ainThrottle           // direction control
#define	ainThrottle_MASK        0x02                                    // mask
#define	ainThrottle_SHIFT       0x01                                    // shift count

// PORTA2 for 1: ainBrake as Input - Analog input for brake
#define	ainBrake_PORT           ((volatile PORTA_STRUCT*)&PORTA)        // PORT register
#define	ainBrake_PIN            ((volatile PORTA_STRUCT*)&PINA)         // PIN register
#define	ainBrake_DDR            ((volatile PORTA_STRUCT*)&DDRA)         // DDR register
#define	ainBrake                ainBrake_PIN->_ainBrake                 // input
#define	ainBrake_PULLUP         ainBrake_PORT->_ainBrake                // pullup control
#define	ainBrake_DIR            ainBrake_DDR->_ainBrake                 // direction control
#define	ainBrake_MASK           0x04                                    // mask
#define	ainBrake_SHIFT          0x02                                    // shift count

// PORTA3 for 1: reserved1 as Input with pullups - Reserved for pin PCINT3
#define	reserved1_PORT          ((volatile PORTA_STRUCT*)&PORTA)        // PORT register
#define	reserved1_PIN           ((volatile PORTA_STRUCT*)&PINA)         // PIN register
#define	reserved1_DDR           ((volatile PORTA_STRUCT*)&DDRA)         // DDR register
#define	reserved1               reserved1_PIN->_reserved1               // input
#define	reserved1_PULLUP        reserved1_PORT->_reserved1              // pullup control
#define	reserved1_DIR           reserved1_DDR->_reserved1               // direction control
#define	reserved1_MASK          0x08                                    // mask
#define	reserved1_SHIFT         0x03                                    // shift count

// PORTA4 for 1: reserved2 as Input with pullups - 
#define	reserved2_PORT          ((volatile PORTA_STRUCT*)&PORTA)        // PORT register
#define	reserved2_PIN           ((volatile PORTA_STRUCT*)&PINA)         // PIN register
#define	reserved2_DDR           ((volatile PORTA_STRUCT*)&DDRA)         // DDR register
#define	reserved2               reserved2_PIN->_reserved2               // input
#define	reserved2_PULLUP        reserved2_PORT->_reserved2              // pullup control
#define	reserved2_DIR           reserved2_DDR->_reserved2               // direction control
#define	reserved2_MASK          0x10                                    // mask
#define	reserved2_SHIFT         0x04                                    // shift count

// PORTA5 for 1: __OC1B as Output - Reserved for pin OC1B
#define	__OC1B_PORT             ((volatile PORTA_STRUCT*)&PORTA)        // PORT register
#define	__OC1B_PIN              ((volatile PORTA_STRUCT*)&PINA)         // PIN register
#define	__OC1B_DDR              ((volatile PORTA_STRUCT*)&DDRA)         // DDR register
#define	__OC1B                  __OC1B_PORT->___OC1B                    // output
#define	__OC1B_TOGGLE           __OC1B_PIN->___OC1B                     // output toggle
#define	__OC1B_DIR              __OC1B_DDR->___OC1B                     // direction control
#define	__OC1B_MASK             0x20                                    // mask
#define	__OC1B_SHIFT            0x05                                    // shift count

// PORTA6 for 1: __OC1A as Output - Reserved for pin OC1A
#define	__OC1A_PORT             ((volatile PORTA_STRUCT*)&PORTA)        // PORT register
#define	__OC1A_PIN              ((volatile PORTA_STRUCT*)&PINA)         // PIN register
#define	__OC1A_DDR              ((volatile PORTA_STRUCT*)&DDRA)         // DDR register
#define	__OC1A                  __OC1A_PORT->___OC1A                    // output
#define	__OC1A_TOGGLE           __OC1A_PIN->___OC1A                     // output toggle
#define	__OC1A_DIR              __OC1A_DDR->___OC1A                     // direction control
#define	__OC1A_MASK             0x40                                    // mask
#define	__OC1A_SHIFT            0x06                                    // shift count

// PORTA7 for 1: inAux as Input - 1-bit input from steering
#define	inAux_PORT              ((volatile PORTA_STRUCT*)&PORTA)        // PORT register
#define	inAux_PIN               ((volatile PORTA_STRUCT*)&PINA)         // PIN register
#define	inAux_DDR               ((volatile PORTA_STRUCT*)&DDRA)         // DDR register
#define	inAux                   inAux_PIN->_inAux                       // input
#define	inAux_PULLUP            inAux_PORT->_inAux                      // pullup control
#define	inAux_DIR               inAux_DDR->_inAux                       // direction control
#define	inAux_MASK              0x80                                    // mask
#define	inAux_SHIFT             0x07                                    // shift count

//
// PORTB variable definitions
//
typedef struct
{
	unsigned char	_inConfig0       : 1;	// 
	unsigned char	_inConfig1       : 1;	// 
	unsigned char	_inConfig2       : 1;	// 
	unsigned char	_reset           : 1;	// 
} PORTB_STRUCT;

// PORTB0 for 1: inConfig0 as Input with pullups - 
#define	inConfig0_PORT          ((volatile PORTB_STRUCT*)&PORTB)        // PORT register
#define	inConfig0_PIN           ((volatile PORTB_STRUCT*)&PINB)         // PIN register
#define	inConfig0_DDR           ((volatile PORTB_STRUCT*)&DDRB)         // DDR register
#define	inConfig0               inConfig0_PIN->_inConfig0               // input
#define	inConfig0_PULLUP        inConfig0_PORT->_inConfig0              // pullup control
#define	inConfig0_DIR           inConfig0_DDR->_inConfig0               // direction control
#define	inConfig0_MASK          0x01                                    // mask
#define	inConfig0_SHIFT         0x00                                    // shift count

// PORTB1 for 1: inConfig1 as Input with pullups - 
#define	inConfig1_PORT          ((volatile PORTB_STRUCT*)&PORTB)        // PORT register
#define	inConfig1_PIN           ((volatile PORTB_STRUCT*)&PINB)         // PIN register
#define	inConfig1_DDR           ((volatile PORTB_STRUCT*)&DDRB)         // DDR register
#define	inConfig1               inConfig1_PIN->_inConfig1               // input
#define	inConfig1_PULLUP        inConfig1_PORT->_inConfig1              // pullup control
#define	inConfig1_DIR           inConfig1_DDR->_inConfig1               // direction control
#define	inConfig1_MASK          0x02                                    // mask
#define	inConfig1_SHIFT         0x01                                    // shift count

// PORTB2 for 1: inConfig2 as Input with pullups - 
#define	inConfig2_PORT          ((volatile PORTB_STRUCT*)&PORTB)        // PORT register
#define	inConfig2_PIN           ((volatile PORTB_STRUCT*)&PINB)         // PIN register
#define	inConfig2_DDR           ((volatile PORTB_STRUCT*)&DDRB)         // DDR register
#define	inConfig2               inConfig2_PIN->_inConfig2               // input
#define	inConfig2_PULLUP        inConfig2_PORT->_inConfig2              // pullup control
#define	inConfig2_DIR           inConfig2_DDR->_inConfig2               // direction control
#define	inConfig2_MASK          0x04                                    // mask
#define	inConfig2_SHIFT         0x02                                    // shift count

// PORTB3 for 1: reset as Input with pullups - 
#define	reset_PORT              ((volatile PORTB_STRUCT*)&PORTB)        // PORT register
#define	reset_PIN               ((volatile PORTB_STRUCT*)&PINB)         // PIN register
#define	reset_DDR               ((volatile PORTB_STRUCT*)&DDRB)         // DDR register
#define	reset                   reset_PIN->_reset                       // input
#define	reset_PULLUP            reset_PORT->_reset                      // pullup control
#define	reset_DIR               reset_DDR->_reset                       // direction control
#define	reset_MASK              0x08                                    // mask
#define	reset_SHIFT             0x03                                    // shift count

// TIMER_COUNTER_1 - PWM_Gen - 
#define	PWM_Gen_Divisor	1
#define	PWM_Gen_CountsPerSecond	1000000
#define	PWM_Gen_usPerCount	1               // (1)
#define	PWM_Gen_nsPerCount	1000            // (1000)
#define	PWM_Gen_msPeriod	17              // (16.667)
#define	PWM_Gen_usPeriod	16667           // (16667)
#define	PWM_Gen_nsPeriod	16667002        // (1.6667E+07)

// OCR1A - cntLeft - Counts for left motor PWM
#define cntLeft      OCR1A

// OCR1B - cntRight - Counts for right motor PWM
#define cntRight     OCR1B
//}}AVR_IO_DESIGNER_HDR
