/* 
* PwmScale.cpp
*
* Created: 11/13/2014 10:49:01 AM
* Author: Tim
*/


#include <standard.h>
#include "PwmScale.h"

const DWORD PWM_TARGET = (DWORD)PWM_PULSE_RANGE << PWM_CALC_SCALE;

int PwmScale::Scale(int iVal)
{
	DWORD_BYTES	dwb;

	iVal -= m_offset;
	
	// The following extracts the middle 16 bits from a 32-bit product.
	// Much more efficient than dw >>= 8.
	dwb.dw = (long)iVal * m_scale;
	dwb.bLo = dwb.bMidLo;
	dwb.bMidLo = dwb.bMidHi;
	
	iVal = dwb.wLo;
	iVal >>= PWM_CALC_SCALE - 8 - 1;	// Keep an extra bit
	iVal = (iVal >> 1) + (iVal & 1);	// Use the extra bit to round
	if (iVal > PWM_PULSE_RANGE)
		iVal = PWM_PULSE_RANGE;
	else if (iVal < -PWM_PULSE_RANGE)
		iVal = -PWM_PULSE_RANGE;
	return iVal;
}

void PwmScale::ComputeScale(WORD iVal)
{
	iVal -= m_offset;
	m_scale = (PWM_TARGET + iVal / 2) / iVal;
}
