#ifndef _AID_AT90PWM316_DEFINED_

typedef enum
{
	Enabling_Disabled,                  	// Disabled
	Enabling_Enabled,                   	// Enabled
} Enabling_ENUM;

typedef enum
{
	ACIntModeSelect_OutputToggle,       	// Comparator Interrupt on Output Toggle
	ACIntModeSelect_Reserved,           	// Reserved
	ACIntModeSelect_FallingOutputEdge,  	// Comparator Interrupt on Falling Output Edge
	ACIntModeSelect_RisingOutputEdge,   	// Comparator Interrupt on Rising Output Edge
} ACIntModeSelect_ENUM;

typedef enum
{
	ACNegInputMux_Vref6,                	// Vref / 6.40
	ACNegInputMux_Vref3,                	// Vref / 3.20
	ACNegInputMux_Vref2,                	// Vref / 2.13
	ACNegInputMux_Vref1,                	// Vref / 1.60
	ACNegInputMux_ACMPM,                	// Analog Comparator Negative Input (ACMPM pin)
	ACNegInputMux_DAC,                  	// DAC result
	ACNegInputMux_Reserved1,            	// Reserved
	ACNegInputMux_Reserved2,            	// Reserved
} ACNegInputMux_ENUM;

typedef enum
{
	SenseA_LowLevel,                    	// Low Level Generates Interrupt
	SenseA_AnyChange,                   	// Any Change Generates Interrupt
	SenseA_FallingEdge,                 	// Falling Edge Generates Interrupt
	SenseA_RisingEdge,                  	// Rising Edge Generates Interrupt
} SenseA_ENUM;

typedef enum
{
	SPIMaster_Slave,                    	// Slave Mode
	SPIMaster_Master,                   	// Master Mode
} SPIMaster_ENUM;

typedef enum
{
	SPR_DIV_4,                          	// clk / 4
	SPR_DIV_16,                         	// clk / 16
	SPR_DIV_64,                         	// clk / 64
	SPR_DIV_128,                        	// clk / 128
	SPR_DIV_2,                          	// clk / 2
	SPR_DIV_8,                          	// clk / 8
	SPR_DIV_32,                         	// clk / 32
	SPR_DIV_64b,                        	// clk / 64
} SPR_ENUM;

typedef enum
{
	SPIMode_Mode0,                      	// 0 - Leading (Rising) Edge Sample, Trailing (Falling) Edge Setup
	SPIMode_Mode1,                      	// 1 - Leading (Rising) Edge Setup, Trailing (Falling) Edge Sample
	SPIMode_Mode2,                      	// 2 - Leading (Falling) Edge Sample, Trailing (Rising) Edge Setup
	SPIMode_Mode3,                      	// 3 - Leading (Falling) Edge Setup, Trailing (Rising) Edge Sample
} SPIMode_ENUM;

typedef enum
{
	SPIDataOrder_MSBFirst,              	// Most Significant Bit First
	SPIDataOrder_LSBFirst,              	// Least Significant Bit First
} SPIDataOrder_ENUM;

typedef enum
{
	Trigger_Falling,                    	// Falling Edge Trigger
	Trigger_Rising,                     	// Rising Edge Trigger
} Trigger_ENUM;

typedef enum
{
	UsartCharacterSize_FiveBits,        	// 5 bits
	UsartCharacterSize_SixBits,         	// 6 bits
	UsartCharacterSize_SevenBits,       	// 7 bits
	UsartCharacterSize_EightBits,       	// 8 bits
	UsartCharacterSize_Reserved,        	// Reserved
	UsartCharacterSize_Reserved2,       	// Reserved
	UsartCharacterSize_Reserved3,       	// Reserved
	UsartCharacterSize_NineBits,        	// 9 bits
} UsartCharacterSize_ENUM;

typedef enum
{
	UsartStopBitSelect_OneStopBit,      	// 1 stop bit
	UsartStopBitSelect_TwoStopBits,     	// 2 stop bits
} UsartStopBitSelect_ENUM;

typedef enum
{
	UsartParityMode_Disabled,           	// Disabled
	UsartParityMode_Reserved,           	// Reserved
	UsartParityMode_EvenParity,         	// Even Parity
	UsartParityMode_OddParity,          	// Odd Parity
} UsartParityMode_ENUM;

typedef enum
{
	UsartClockPolarity_Normal,          	// TX Changed on Rising Edge, RX Sampled on Falling Edge
	UsartClockPolarity_Inverted,        	// TX Changed on Falling Edge, RX Sampled on Rising Edge
} UsartClockPolarity_ENUM;

typedef enum
{
	WdtPrescale_WDTO_16MS,              	// Typical Time-out 16 ms
	WdtPrescale_WDTO_32MS,              	// Typical Time-out 32 ms
	WdtPrescale_WDTO_64MS,              	// Typical Time-out 64 ms
	WdtPrescale_WDTO_125MS,             	// Typical Time-out 125 ms
	WdtPrescale_WDTO_250MS,             	// Typical Time-out 250 ms
	WdtPrescale_WDTO_500MS,             	// Typical Time-out 500 ms
	WdtPrescale_WDTO_1S,                	// Typical Time-out 1 sec
	WdtPrescale_WDTO_2S,                	// Typical Time-out 2 sec
	WdtPrescale_WDTO_4S,                	// Typical Time-out 4 sec
	WdtPrescale_WDTO_8S,                	// Typical Time-out 8 sec
	WdtPrescale_WDTO_Invalid1,          	// Invalid
	WdtPrescale_WDTO_Invalid2,          	// Invalid
	WdtPrescale_WDTO_Invalid3,          	// Invalid
	WdtPrescale_WDTO_Invalid4,          	// Invalid
	WdtPrescale_WDTO_Invalid5,          	// Invalid
	WdtPrescale_WDTO_Invalid6,          	// Invalid
} WdtPrescale_ENUM;

typedef enum
{
	WdtMode_Disabled,                   	// Disabled
	WdtMode_Interrupt,                  	// Interrupt on timeout
	WdtMode_SystemReset,                	// System reset on timeout
	WdtMode_InterruptAndSystemReset,    	// Interrupt on first timeout, system reset on next
} WdtMode_ENUM;

//
// AD_CONVERTER variable definitions
//
#define	_REFS1                  ((volatile BYTE_STRUCT*)&ADMUX)->bit7
#define	_REFS0                  ((volatile BYTE_STRUCT*)&ADMUX)->bit6
#define	_ADLAR                  ((volatile BYTE_STRUCT*)&ADMUX)->bit5
#define	_MUX3                   ((volatile BYTE_STRUCT*)&ADMUX)->bit3
#define	_MUX2                   ((volatile BYTE_STRUCT*)&ADMUX)->bit2
#define	_MUX1                   ((volatile BYTE_STRUCT*)&ADMUX)->bit1
#define	_MUX0                   ((volatile BYTE_STRUCT*)&ADMUX)->bit0
#define	_ADEN                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit7
#define	_ADSC                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit6
#define	_ADATE                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit5
#define	_ADIF                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit4
#define	_ADIE                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit3
#define	_ADPS2                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit2
#define	_ADPS1                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit1
#define	_ADPS0                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit0
#define	_ADASCR                 ((volatile BYTE_STRUCT*)&ADCSRB)->bit4
#define	_ADHSM                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit7
#define	_ADTS0                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit0
#define	_ADTS1                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit1
#define	_ADTS2                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit2
#define	_ADTS3                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit3
#define	_ADC0D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit0
#define	_ADC1D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit1
#define	_ADC2D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit2
#define	_ADC3D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit3
#define	_ADC4D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit4
#define	_ADC5D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit5
#define	_ADC6D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit6
#define	_ADC7D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit7
#define	_ACMP0D                 ((volatile BYTE_STRUCT*)&DIDR1)->bit5
#define	_ADC10D                 ((volatile BYTE_STRUCT*)&DIDR1)->bit2
#define	_ADC8D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit0
#define	_ADC9D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit1
#define	_AMP0ND                 ((volatile BYTE_STRUCT*)&DIDR1)->bit3
#define	_AMP0PD                 ((volatile BYTE_STRUCT*)&DIDR1)->bit4
#define	_AMP0EN                 ((volatile BYTE_STRUCT*)&AMP0CSR)->bit7
#define	_AMP0IS                 ((volatile BYTE_STRUCT*)&AMP0CSR)->bit6
#define	_AMP0G1                 ((volatile BYTE_STRUCT*)&AMP0CSR)->bit5
#define	_AMP0G0                 ((volatile BYTE_STRUCT*)&AMP0CSR)->bit4
#define	_AMP0TS1                ((volatile BYTE_STRUCT*)&AMP0CSR)->bit1
#define	_AMP0TS0                ((volatile BYTE_STRUCT*)&AMP0CSR)->bit0
#define	_AMP1EN                 ((volatile BYTE_STRUCT*)&AMP1CSR)->bit7
#define	_AMP1IS                 ((volatile BYTE_STRUCT*)&AMP1CSR)->bit6
#define	_AMP1G1                 ((volatile BYTE_STRUCT*)&AMP1CSR)->bit5
#define	_AMP1G0                 ((volatile BYTE_STRUCT*)&AMP1CSR)->bit4
#define	_AMP1TS1                ((volatile BYTE_STRUCT*)&AMP1CSR)->bit1
#define	_AMP1TS0                ((volatile BYTE_STRUCT*)&AMP1CSR)->bit0

//
// ANALOG_COMPARATOR variable definitions
//
// Comparator Enable 0 - Enabling_ENUM - [bit AC0CON.AC0EN] Enables the comparator.
#define	_AC0EN                  ((volatile BYTE_STRUCT*)&AC0CON)->bit7
// Interrupt Enable 0 - Enabling_ENUM - [bit AC0CON.AC0IE] Enables the comparator interrupt.
#define	_AC0IE                  ((volatile BYTE_STRUCT*)&AC0CON)->bit6
// Interrupt Mode Select 0 - ACIntModeSelect_ENUM - [bit field "AC0IS" AC0CON.(AC0IS0 | AC0IS1)] Determine which comparator events trigger the comparator interrupt.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__AC0IS           : 2;
} AC0IS_STRUCT;

#define	_AC0IS                  ((volatile AC0IS_STRUCT*)&AC0CON)->__AC0IS
// Analog Comparator Multiplexer 0 - ACNegInputMux_ENUM - [bit field "AC0M" AC0CON.(AC0M0 | AC0M1 | AC0M2)] Determine which comparator events trigger the comparator interrupt.

typedef struct
{
	unsigned char	__AC0M            : 3;
} AC0M_STRUCT;

#define	_AC0M                   ((volatile AC0M_STRUCT*)&AC0CON)->__AC0M
// Comparator Enable 1 - Enabling_ENUM - [bit AC1CON.AC1EN] Enables the comparator.
#define	_AC1EN                  ((volatile BYTE_STRUCT*)&AC1CON)->bit7
// Interrupt Enable 1 - Enabling_ENUM - [bit AC1CON.AC1IE] Enables the comparator interrupt.
#define	_AC1IE                  ((volatile BYTE_STRUCT*)&AC1CON)->bit6
// Interrupt Mode Select 1 - ACIntModeSelect_ENUM - [bit field "AC1IS" AC1CON.(AC1IS0 | AC1IS1)] Determine which comparator events trigger the comparator interrupt.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__AC1IS           : 2;
} AC1IS_STRUCT;

#define	_AC1IS                  ((volatile AC1IS_STRUCT*)&AC1CON)->__AC1IS
// Analog Comparator Multiplexer 1 - ACNegInputMux_ENUM - [bit field "AC1M" AC1CON.(AC1M0 | AC1M1 | AC1M2)] Determine which comparator events trigger the comparator interrupt.

typedef struct
{
	unsigned char	__AC1M            : 3;
} AC1M_STRUCT;

#define	_AC1M                   ((volatile AC1M_STRUCT*)&AC1CON)->__AC1M
// Input Capture Enable 1 - Enabling_ENUM - [bit AC1CON.AC1ICE] Enables the input capture function in Timer/Counter1 to be triggered by the comparator.
#define	_AC1ICE                 ((volatile BYTE_STRUCT*)&AC1CON)->bit3
// Comparator Enable 2 - Enabling_ENUM - [bit AC2CON.AC2EN] Enables the comparator.
#define	_AC2EN                  ((volatile BYTE_STRUCT*)&AC2CON)->bit7
// Interrupt Enable 2 - Enabling_ENUM - [bit AC2CON.AC2IE] Enables the comparator interrupt.
#define	_AC2IE                  ((volatile BYTE_STRUCT*)&AC2CON)->bit6
// Interrupt Mode Select 2 - ACIntModeSelect_ENUM - [bit field "AC2IS" AC2CON.(AC2IS0 | AC2IS1)] Determine which comparator events trigger the comparator interrupt.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__AC2IS           : 2;
} AC2IS_STRUCT;

#define	_AC2IS                  ((volatile AC2IS_STRUCT*)&AC2CON)->__AC2IS
// Analog Comparator Multiplexer 2 - ACNegInputMux_ENUM - [bit field "AC2M" AC2CON.(AC2M0 | AC2M1 | AC2M2)] Determine which comparator events trigger the comparator interrupt.

typedef struct
{
	unsigned char	__AC2M            : 3;
} AC2M_STRUCT;

#define	_AC2M                   ((volatile AC2M_STRUCT*)&AC2CON)->__AC2M

// other ANALOG_COMPARATOR bit definitions
#define	_AC0IS1                 ((volatile BYTE_STRUCT*)&AC0CON)->bit5
#define	_AC0IS0                 ((volatile BYTE_STRUCT*)&AC0CON)->bit4
#define	_AC0M2                  ((volatile BYTE_STRUCT*)&AC0CON)->bit2
#define	_AC0M1                  ((volatile BYTE_STRUCT*)&AC0CON)->bit1
#define	_AC0M0                  ((volatile BYTE_STRUCT*)&AC0CON)->bit0
#define	_AC1IS1                 ((volatile BYTE_STRUCT*)&AC1CON)->bit5
#define	_AC1IS0                 ((volatile BYTE_STRUCT*)&AC1CON)->bit4
#define	_AC1M2                  ((volatile BYTE_STRUCT*)&AC1CON)->bit2
#define	_AC1M1                  ((volatile BYTE_STRUCT*)&AC1CON)->bit1
#define	_AC1M0                  ((volatile BYTE_STRUCT*)&AC1CON)->bit0
#define	_AC2IS1                 ((volatile BYTE_STRUCT*)&AC2CON)->bit5
#define	_AC2IS0                 ((volatile BYTE_STRUCT*)&AC2CON)->bit4
#define	_AC2M2                  ((volatile BYTE_STRUCT*)&AC2CON)->bit2
#define	_AC2M1                  ((volatile BYTE_STRUCT*)&AC2CON)->bit1
#define	_AC2M0                  ((volatile BYTE_STRUCT*)&AC2CON)->bit0
#define	_ACCKDIV                ((volatile BYTE_STRUCT*)&ACSR)->bit7
#define	_AC2IF                  ((volatile BYTE_STRUCT*)&ACSR)->bit6
#define	_AC1IF                  ((volatile BYTE_STRUCT*)&ACSR)->bit5
#define	_AC0IF                  ((volatile BYTE_STRUCT*)&ACSR)->bit4
#define	_AC2O                   ((volatile BYTE_STRUCT*)&ACSR)->bit2
#define	_AC1O                   ((volatile BYTE_STRUCT*)&ACSR)->bit1
#define	_AC0O                   ((volatile BYTE_STRUCT*)&ACSR)->bit0

//
// BOOT_LOAD variable definitions
//
#define	_SPMIE                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit7
#define	_RWWSB                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit6
#define	_RWWSRE                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit4
#define	_BLBSET                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit3
#define	_PGWRT                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit2
#define	_PGERS                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit1
#define	_SPMEN                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit0

//
// CPU variable definitions
//
#define	_SPIPS                  ((volatile BYTE_STRUCT*)&MCUCR)->bit7
#define	_PUD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit4
#define	_IVSEL                  ((volatile BYTE_STRUCT*)&MCUCR)->bit1
#define	_IVCE                   ((volatile BYTE_STRUCT*)&MCUCR)->bit0
#define	_WDRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit3
#define	_BORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit2
#define	_EXTRF                  ((volatile BYTE_STRUCT*)&MCUSR)->bit1
#define	_PORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit0
#define	_CLKPCE                 ((volatile BYTE_STRUCT*)&CLKPR)->bit7
#define	_CLKPS3                 ((volatile BYTE_STRUCT*)&CLKPR)->bit3
#define	_CLKPS2                 ((volatile BYTE_STRUCT*)&CLKPR)->bit2
#define	_CLKPS1                 ((volatile BYTE_STRUCT*)&CLKPR)->bit1
#define	_CLKPS0                 ((volatile BYTE_STRUCT*)&CLKPR)->bit0
#define	_SM2                    ((volatile BYTE_STRUCT*)&SMCR)->bit3
#define	_SM1                    ((volatile BYTE_STRUCT*)&SMCR)->bit2
#define	_SM0                    ((volatile BYTE_STRUCT*)&SMCR)->bit1
#define	_SE                     ((volatile BYTE_STRUCT*)&SMCR)->bit0
#define	_PLLF                   ((volatile BYTE_STRUCT*)&PLLCSR)->bit2
#define	_PLLE                   ((volatile BYTE_STRUCT*)&PLLCSR)->bit1
#define	_PLOCK                  ((volatile BYTE_STRUCT*)&PLLCSR)->bit0
#define	_PRPSC2                 ((volatile BYTE_STRUCT*)&PRR)->bit7
#define	_PRPSC1                 ((volatile BYTE_STRUCT*)&PRR)->bit6
#define	_PRPSC0                 ((volatile BYTE_STRUCT*)&PRR)->bit5
#define	_PRTIM1                 ((volatile BYTE_STRUCT*)&PRR)->bit4
#define	_PRTIM0                 ((volatile BYTE_STRUCT*)&PRR)->bit3
#define	_PRSPI                  ((volatile BYTE_STRUCT*)&PRR)->bit2
#define	_PRUSART0               ((volatile BYTE_STRUCT*)&PRR)->bit1
#define	_PRADC                  ((volatile BYTE_STRUCT*)&PRR)->bit0

//
// DA_CONVERTER variable definitions
//
#define	_DAATE                  ((volatile BYTE_STRUCT*)&DACON)->bit7
#define	_DATS2                  ((volatile BYTE_STRUCT*)&DACON)->bit6
#define	_DATS1                  ((volatile BYTE_STRUCT*)&DACON)->bit5
#define	_DATS0                  ((volatile BYTE_STRUCT*)&DACON)->bit4
#define	_DALA                   ((volatile BYTE_STRUCT*)&DACON)->bit2
#define	_DAEN                   ((volatile BYTE_STRUCT*)&DACON)->bit0

//
// EEPROM variable definitions
//
#define	_EERIE                  ((volatile BYTE_STRUCT*)&EECR)->bit3
#define	_EEMWE                  ((volatile BYTE_STRUCT*)&EECR)->bit2
#define	_EEWE                   ((volatile BYTE_STRUCT*)&EECR)->bit1
#define	_EERE                   ((volatile BYTE_STRUCT*)&EECR)->bit0

//
// EUSART variable definitions
//
#define	_UTxS3                  ((volatile BYTE_STRUCT*)&EUCSRA)->bit7
#define	_UTxS2                  ((volatile BYTE_STRUCT*)&EUCSRA)->bit6
#define	_UTxS1                  ((volatile BYTE_STRUCT*)&EUCSRA)->bit5
#define	_UTxS0                  ((volatile BYTE_STRUCT*)&EUCSRA)->bit4
#define	_URxS3                  ((volatile BYTE_STRUCT*)&EUCSRA)->bit3
#define	_URxS2                  ((volatile BYTE_STRUCT*)&EUCSRA)->bit2
#define	_URxS1                  ((volatile BYTE_STRUCT*)&EUCSRA)->bit1
#define	_URxS0                  ((volatile BYTE_STRUCT*)&EUCSRA)->bit0
#define	_EUSART                 ((volatile BYTE_STRUCT*)&EUCSRB)->bit4
#define	_EUSBS                  ((volatile BYTE_STRUCT*)&EUCSRB)->bit3
#define	_EMCH                   ((volatile BYTE_STRUCT*)&EUCSRB)->bit1
#define	_BODR                   ((volatile BYTE_STRUCT*)&EUCSRB)->bit0
#define	_FEM                    ((volatile BYTE_STRUCT*)&EUCSRC)->bit3
#define	_F1617                  ((volatile BYTE_STRUCT*)&EUCSRC)->bit2
#define	_STP1                   ((volatile BYTE_STRUCT*)&EUCSRC)->bit1
#define	_STP0                   ((volatile BYTE_STRUCT*)&EUCSRC)->bit0

//
// EXTERNAL_INTERRUPT variable definitions
//
// INT0 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT0] Enables the interrupt on the INT pin
#define	_INT0                   ((volatile BYTE_STRUCT*)&EIMSK)->bit0
// INT0 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC0" EICRA.(ISC00 | ISC01)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__ISC0            : 2;
} ISC0_STRUCT;

#define	_ISC0                   ((volatile ISC0_STRUCT*)&EICRA)->__ISC0
// INT1 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT1] Enables the interrupt on the INT pin
#define	_INT1                   ((volatile BYTE_STRUCT*)&EIMSK)->bit1
// INT1 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC1" EICRA.(ISC10 | ISC11)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__ISC1            : 2;
} ISC1_STRUCT;

#define	_ISC1                   ((volatile ISC1_STRUCT*)&EICRA)->__ISC1
// INT2 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT2] Enables the interrupt on the INT pin
#define	_INT2                   ((volatile BYTE_STRUCT*)&EIMSK)->bit2
// INT2 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC2" EICRA.(ISC20 | ISC21)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__ISC2            : 2;
} ISC2_STRUCT;

#define	_ISC2                   ((volatile ISC2_STRUCT*)&EICRA)->__ISC2
// INT3 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT3] Enables the interrupt on the INT pin
#define	_INT3                   ((volatile BYTE_STRUCT*)&EIMSK)->bit3
// INT3 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC3" EICRA.(ISC30 | ISC31)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__ISC3            : 2;
} ISC3_STRUCT;

#define	_ISC3                   ((volatile ISC3_STRUCT*)&EICRA)->__ISC3

// other EXTERNAL_INTERRUPT bit definitions
#define	_ISC31                  ((volatile BYTE_STRUCT*)&EICRA)->bit7
#define	_ISC30                  ((volatile BYTE_STRUCT*)&EICRA)->bit6
#define	_ISC21                  ((volatile BYTE_STRUCT*)&EICRA)->bit5
#define	_ISC20                  ((volatile BYTE_STRUCT*)&EICRA)->bit4
#define	_ISC11                  ((volatile BYTE_STRUCT*)&EICRA)->bit3
#define	_ISC10                  ((volatile BYTE_STRUCT*)&EICRA)->bit2
#define	_ISC01                  ((volatile BYTE_STRUCT*)&EICRA)->bit1
#define	_ISC00                  ((volatile BYTE_STRUCT*)&EICRA)->bit0
#define	_INTF3                  ((volatile BYTE_STRUCT*)&EIFR)->bit3
#define	_INTF2                  ((volatile BYTE_STRUCT*)&EIFR)->bit2
#define	_INTF1                  ((volatile BYTE_STRUCT*)&EIFR)->bit1
#define	_INTF0                  ((volatile BYTE_STRUCT*)&EIFR)->bit0

//
// PSC0 variable definitions
//
#define	_PCAE0B                 ((volatile BYTE_STRUCT*)&PFRC0B)->bit7
#define	_PISEL0B                ((volatile BYTE_STRUCT*)&PFRC0B)->bit6
#define	_PELEV0B                ((volatile BYTE_STRUCT*)&PFRC0B)->bit5
#define	_PFLTE0B                ((volatile BYTE_STRUCT*)&PFRC0B)->bit4
#define	_PRFM0B3                ((volatile BYTE_STRUCT*)&PFRC0B)->bit3
#define	_PRFM0B2                ((volatile BYTE_STRUCT*)&PFRC0B)->bit2
#define	_PRFM0B1                ((volatile BYTE_STRUCT*)&PFRC0B)->bit1
#define	_PRFM0B0                ((volatile BYTE_STRUCT*)&PFRC0B)->bit0
#define	_PCAE0A                 ((volatile BYTE_STRUCT*)&PFRC0A)->bit7
#define	_PISEL0A                ((volatile BYTE_STRUCT*)&PFRC0A)->bit6
#define	_PELEV0A                ((volatile BYTE_STRUCT*)&PFRC0A)->bit5
#define	_PFLTE0A                ((volatile BYTE_STRUCT*)&PFRC0A)->bit4
#define	_PRFM0A3                ((volatile BYTE_STRUCT*)&PFRC0A)->bit3
#define	_PRFM0A2                ((volatile BYTE_STRUCT*)&PFRC0A)->bit2
#define	_PRFM0A1                ((volatile BYTE_STRUCT*)&PFRC0A)->bit1
#define	_PRFM0A0                ((volatile BYTE_STRUCT*)&PFRC0A)->bit0
#define	_PPRE01                 ((volatile BYTE_STRUCT*)&PCTL0)->bit7
#define	_PPRE00                 ((volatile BYTE_STRUCT*)&PCTL0)->bit6
#define	_PBFM0                  ((volatile BYTE_STRUCT*)&PCTL0)->bit5
#define	_PAOC0B                 ((volatile BYTE_STRUCT*)&PCTL0)->bit4
#define	_PAOC0A                 ((volatile BYTE_STRUCT*)&PCTL0)->bit3
#define	_PARUN0                 ((volatile BYTE_STRUCT*)&PCTL0)->bit2
#define	_PCCYC0                 ((volatile BYTE_STRUCT*)&PCTL0)->bit1
#define	_PRUN0                  ((volatile BYTE_STRUCT*)&PCTL0)->bit0
#define	_PFIFTY0                ((volatile BYTE_STRUCT*)&PCNF0)->bit7
#define	_PALOCK0                ((volatile BYTE_STRUCT*)&PCNF0)->bit6
#define	_PLOCK0                 ((volatile BYTE_STRUCT*)&PCNF0)->bit5
#define	_PMODE01                ((volatile BYTE_STRUCT*)&PCNF0)->bit4
#define	_PMODE00                ((volatile BYTE_STRUCT*)&PCNF0)->bit3
#define	_POP0                   ((volatile BYTE_STRUCT*)&PCNF0)->bit2
#define	_PCLKSEL0               ((volatile BYTE_STRUCT*)&PCNF0)->bit1
#define	_PSYNC01                ((volatile BYTE_STRUCT*)&PSOC0)->bit5
#define	_PSYNC00                ((volatile BYTE_STRUCT*)&PSOC0)->bit4
#define	_POEN0B                 ((volatile BYTE_STRUCT*)&PSOC0)->bit2
#define	_POEN0A                 ((volatile BYTE_STRUCT*)&PSOC0)->bit0
#define	_PSEIE0                 ((volatile BYTE_STRUCT*)&PIM0)->bit5
#define	_PEVE0B                 ((volatile BYTE_STRUCT*)&PIM0)->bit4
#define	_PEVE0A                 ((volatile BYTE_STRUCT*)&PIM0)->bit3
#define	_PEOPE0                 ((volatile BYTE_STRUCT*)&PIM0)->bit0
#define	_POAC0B                 ((volatile BYTE_STRUCT*)&PIFR0)->bit7
#define	_POAC0A                 ((volatile BYTE_STRUCT*)&PIFR0)->bit6
#define	_PSEI0                  ((volatile BYTE_STRUCT*)&PIFR0)->bit5
#define	_PEV0B                  ((volatile BYTE_STRUCT*)&PIFR0)->bit4
#define	_PEV0A                  ((volatile BYTE_STRUCT*)&PIFR0)->bit3
#define	_PRN01                  ((volatile BYTE_STRUCT*)&PIFR0)->bit2
#define	_PRN00                  ((volatile BYTE_STRUCT*)&PIFR0)->bit1
#define	_PEOP0                  ((volatile BYTE_STRUCT*)&PIFR0)->bit0

//
// PSC1 variable definitions
//
#define	_PCAE1B                 ((volatile BYTE_STRUCT*)&PFRC1B)->bit7
#define	_PISEL1B                ((volatile BYTE_STRUCT*)&PFRC1B)->bit6
#define	_PELEV1B                ((volatile BYTE_STRUCT*)&PFRC1B)->bit5
#define	_PFLTE1B                ((volatile BYTE_STRUCT*)&PFRC1B)->bit4
#define	_PRFM1B3                ((volatile BYTE_STRUCT*)&PFRC1B)->bit3
#define	_PRFM1B2                ((volatile BYTE_STRUCT*)&PFRC1B)->bit2
#define	_PRFM1B1                ((volatile BYTE_STRUCT*)&PFRC1B)->bit1
#define	_PRFM1B0                ((volatile BYTE_STRUCT*)&PFRC1B)->bit0
#define	_PCAE1A                 ((volatile BYTE_STRUCT*)&PFRC1A)->bit7
#define	_PISEL1A                ((volatile BYTE_STRUCT*)&PFRC1A)->bit6
#define	_PELEV1A                ((volatile BYTE_STRUCT*)&PFRC1A)->bit5
#define	_PFLTE1A                ((volatile BYTE_STRUCT*)&PFRC1A)->bit4
#define	_PRFM1A3                ((volatile BYTE_STRUCT*)&PFRC1A)->bit3
#define	_PRFM1A2                ((volatile BYTE_STRUCT*)&PFRC1A)->bit2
#define	_PRFM1A1                ((volatile BYTE_STRUCT*)&PFRC1A)->bit1
#define	_PRFM1A0                ((volatile BYTE_STRUCT*)&PFRC1A)->bit0
#define	_PPRE11                 ((volatile BYTE_STRUCT*)&PCTL1)->bit7
#define	_PPRE10                 ((volatile BYTE_STRUCT*)&PCTL1)->bit6
#define	_PBFM1                  ((volatile BYTE_STRUCT*)&PCTL1)->bit5
#define	_PAOC1B                 ((volatile BYTE_STRUCT*)&PCTL1)->bit4
#define	_PAOC1A                 ((volatile BYTE_STRUCT*)&PCTL1)->bit3
#define	_PARUN1                 ((volatile BYTE_STRUCT*)&PCTL1)->bit2
#define	_PCCYC1                 ((volatile BYTE_STRUCT*)&PCTL1)->bit1
#define	_PRUN1                  ((volatile BYTE_STRUCT*)&PCTL1)->bit0
#define	_PFIFTY1                ((volatile BYTE_STRUCT*)&PCNF1)->bit7
#define	_PALOCK1                ((volatile BYTE_STRUCT*)&PCNF1)->bit6
#define	_PLOCK1                 ((volatile BYTE_STRUCT*)&PCNF1)->bit5
#define	_PMODE11                ((volatile BYTE_STRUCT*)&PCNF1)->bit4
#define	_PMODE10                ((volatile BYTE_STRUCT*)&PCNF1)->bit3
#define	_POP1                   ((volatile BYTE_STRUCT*)&PCNF1)->bit2
#define	_PCLKSEL1               ((volatile BYTE_STRUCT*)&PCNF1)->bit1
#define	_PSYNC1_1               ((volatile BYTE_STRUCT*)&PSOC1)->bit5
#define	_PSYNC1_0               ((volatile BYTE_STRUCT*)&PSOC1)->bit4
#define	_POEN1B                 ((volatile BYTE_STRUCT*)&PSOC1)->bit2
#define	_POEN1A                 ((volatile BYTE_STRUCT*)&PSOC1)->bit0
#define	_PSEIE1                 ((volatile BYTE_STRUCT*)&PIM1)->bit5
#define	_PEVE1B                 ((volatile BYTE_STRUCT*)&PIM1)->bit4
#define	_PEVE1A                 ((volatile BYTE_STRUCT*)&PIM1)->bit3
#define	_PEOPE1                 ((volatile BYTE_STRUCT*)&PIM1)->bit0
#define	_POAC1B                 ((volatile BYTE_STRUCT*)&PIFR1)->bit7
#define	_POAC1A                 ((volatile BYTE_STRUCT*)&PIFR1)->bit6
#define	_PSEI1                  ((volatile BYTE_STRUCT*)&PIFR1)->bit5
#define	_PEV1B                  ((volatile BYTE_STRUCT*)&PIFR1)->bit4
#define	_PEV1A                  ((volatile BYTE_STRUCT*)&PIFR1)->bit3
#define	_PRN11                  ((volatile BYTE_STRUCT*)&PIFR1)->bit2
#define	_PRN10                  ((volatile BYTE_STRUCT*)&PIFR1)->bit1
#define	_PEOP1                  ((volatile BYTE_STRUCT*)&PIFR1)->bit0

//
// PSC2 variable definitions
//
#define	_PCAE2B                 ((volatile BYTE_STRUCT*)&PFRC2B)->bit7
#define	_PISEL2B                ((volatile BYTE_STRUCT*)&PFRC2B)->bit6
#define	_PELEV2B                ((volatile BYTE_STRUCT*)&PFRC2B)->bit5
#define	_PFLTE2B                ((volatile BYTE_STRUCT*)&PFRC2B)->bit4
#define	_PRFM2B3                ((volatile BYTE_STRUCT*)&PFRC2B)->bit3
#define	_PRFM2B2                ((volatile BYTE_STRUCT*)&PFRC2B)->bit2
#define	_PRFM2B1                ((volatile BYTE_STRUCT*)&PFRC2B)->bit1
#define	_PRFM2B0                ((volatile BYTE_STRUCT*)&PFRC2B)->bit0
#define	_PCAE2A                 ((volatile BYTE_STRUCT*)&PFRC2A)->bit7
#define	_PISEL2A                ((volatile BYTE_STRUCT*)&PFRC2A)->bit6
#define	_PELEV2A                ((volatile BYTE_STRUCT*)&PFRC2A)->bit5
#define	_PFLTE2A                ((volatile BYTE_STRUCT*)&PFRC2A)->bit4
#define	_PRFM2A3                ((volatile BYTE_STRUCT*)&PFRC2A)->bit3
#define	_PRFM2A2                ((volatile BYTE_STRUCT*)&PFRC2A)->bit2
#define	_PRFM2A1                ((volatile BYTE_STRUCT*)&PFRC2A)->bit1
#define	_PRFM2A0                ((volatile BYTE_STRUCT*)&PFRC2A)->bit0
#define	_PPRE21                 ((volatile BYTE_STRUCT*)&PCTL2)->bit7
#define	_PPRE20                 ((volatile BYTE_STRUCT*)&PCTL2)->bit6
#define	_PBFM2                  ((volatile BYTE_STRUCT*)&PCTL2)->bit5
#define	_PAOC2B                 ((volatile BYTE_STRUCT*)&PCTL2)->bit4
#define	_PAOC2A                 ((volatile BYTE_STRUCT*)&PCTL2)->bit3
#define	_PARUN2                 ((volatile BYTE_STRUCT*)&PCTL2)->bit2
#define	_PCCYC2                 ((volatile BYTE_STRUCT*)&PCTL2)->bit1
#define	_PRUN2                  ((volatile BYTE_STRUCT*)&PCTL2)->bit0
#define	_PFIFTY2                ((volatile BYTE_STRUCT*)&PCNF2)->bit7
#define	_PALOCK2                ((volatile BYTE_STRUCT*)&PCNF2)->bit6
#define	_PLOCK2                 ((volatile BYTE_STRUCT*)&PCNF2)->bit5
#define	_PMODE21                ((volatile BYTE_STRUCT*)&PCNF2)->bit4
#define	_PMODE20                ((volatile BYTE_STRUCT*)&PCNF2)->bit3
#define	_POP2                   ((volatile BYTE_STRUCT*)&PCNF2)->bit2
#define	_PCLKSEL2               ((volatile BYTE_STRUCT*)&PCNF2)->bit1
#define	_POME2                  ((volatile BYTE_STRUCT*)&PCNF2)->bit0
#define	_POMV2B3                ((volatile BYTE_STRUCT*)&POM2)->bit7
#define	_POMV2B2                ((volatile BYTE_STRUCT*)&POM2)->bit6
#define	_POMV2B1                ((volatile BYTE_STRUCT*)&POM2)->bit5
#define	_POMV2B0                ((volatile BYTE_STRUCT*)&POM2)->bit4
#define	_POMV2A3                ((volatile BYTE_STRUCT*)&POM2)->bit3
#define	_POMV2A2                ((volatile BYTE_STRUCT*)&POM2)->bit2
#define	_POMV2A1                ((volatile BYTE_STRUCT*)&POM2)->bit1
#define	_POMV2A0                ((volatile BYTE_STRUCT*)&POM2)->bit0
#define	_POS23                  ((volatile BYTE_STRUCT*)&PSOC2)->bit7
#define	_POS22                  ((volatile BYTE_STRUCT*)&PSOC2)->bit6
#define	_PSYNC2_1               ((volatile BYTE_STRUCT*)&PSOC2)->bit5
#define	_PSYNC2_0               ((volatile BYTE_STRUCT*)&PSOC2)->bit4
#define	_POEN2D                 ((volatile BYTE_STRUCT*)&PSOC2)->bit3
#define	_POEN2B                 ((volatile BYTE_STRUCT*)&PSOC2)->bit2
#define	_POEN2C                 ((volatile BYTE_STRUCT*)&PSOC2)->bit1
#define	_POEN2A                 ((volatile BYTE_STRUCT*)&PSOC2)->bit0
#define	_PSEIE2                 ((volatile BYTE_STRUCT*)&PIM2)->bit5
#define	_PEVE2B                 ((volatile BYTE_STRUCT*)&PIM2)->bit4
#define	_PEVE2A                 ((volatile BYTE_STRUCT*)&PIM2)->bit3
#define	_PEOPE2                 ((volatile BYTE_STRUCT*)&PIM2)->bit0
#define	_POAC2B                 ((volatile BYTE_STRUCT*)&PIFR2)->bit7
#define	_POAC2A                 ((volatile BYTE_STRUCT*)&PIFR2)->bit6
#define	_PSEI2                  ((volatile BYTE_STRUCT*)&PIFR2)->bit5
#define	_PEV2B                  ((volatile BYTE_STRUCT*)&PIFR2)->bit4
#define	_PEV2A                  ((volatile BYTE_STRUCT*)&PIFR2)->bit3
#define	_PRN21                  ((volatile BYTE_STRUCT*)&PIFR2)->bit2
#define	_PRN20                  ((volatile BYTE_STRUCT*)&PIFR2)->bit1
#define	_PEOP2                  ((volatile BYTE_STRUCT*)&PIFR2)->bit0

//
// SPI variable definitions
//
// SPI Enable - Enabling_ENUM - [bit SPCR.SPE]
#define	_SPE                    ((volatile BYTE_STRUCT*)&SPCR)->bit6
// Master/Slave Mode - SPIMaster_ENUM - [bit SPCR.MSTR]
#define	_MSTR                   ((volatile BYTE_STRUCT*)&SPCR)->bit4
// Clock Rate Select - SPR_ENUM - [bit aggregate (SPCR.SPR0 | SPCR.SPR1 | SPSR.SPI2X)] Controls the SCK rate of the device configured as a Master.
#define	_SPR0                   ((volatile BYTE_STRUCT*)&SPCR)->bit0
#define	_SPR1                   ((volatile BYTE_STRUCT*)&SPCR)->bit1
#define	_SPI2X                  ((volatile BYTE_STRUCT*)&SPSR)->bit0
inline SPR_ENUM get_SPR(){ return (SPR_ENUM)(_SPR0|(_SPR1 << 1)|(_SPI2X << 2)); }
inline void set_SPR(SPR_ENUM v){ _SPR0 = v; _SPR1 = v >> 1; _SPI2X = v >> 2; }
// SPI Mode - SPIMode_ENUM - [bit field "MODE" SPCR.(CPHA | CPOL)] Sets the relationship between data output change and data input sample, and the synchronous clock (SCK).

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__MODE            : 2;
} MODE_STRUCT;

#define	_MODE                   ((volatile MODE_STRUCT*)&SPCR)->__MODE
// Data Order - SPIDataOrder_ENUM - [bit SPCR.DORD] Sets the order in which bits are transmitted.
#define	_DORD                   ((volatile BYTE_STRUCT*)&SPCR)->bit5
// SPI Interrupt Enable - Enabling_ENUM - [bit SPCR.SPIE]
#define	_SPIE                   ((volatile BYTE_STRUCT*)&SPCR)->bit7

// other SPI bit definitions
#define	_SPIF                   ((volatile BYTE_STRUCT*)&SPSR)->bit7
#define	_WCOL                   ((volatile BYTE_STRUCT*)&SPSR)->bit6
#define	_CPOL                   ((volatile BYTE_STRUCT*)&SPCR)->bit3
#define	_CPHA                   ((volatile BYTE_STRUCT*)&SPCR)->bit2

//
// TIMER_COUNTER_0 variable definitions
//
// Waveform Generation Mode - WGM0_WGM_ENUM - [bit aggregate (TCCR0A.WGM00 | TCCR0A.WGM01 | TCCR0B.WGM02)] Controls how the counter will cycle.
typedef enum
{
	WGM0_WGM_Normal,                    	// Normal
	WGM0_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM0_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM0_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM0_WGM_Reserved,                  	// Reserved
	WGM0_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM0_WGM_Reserved2,                 	// Reserved
	WGM0_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM0_WGM_ENUM;
#define	_WGM00                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit0
#define	_WGM01                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit1
#define	_WGM02                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit3
inline WGM0_WGM_ENUM get_WGM0(){ return (WGM0_WGM_ENUM)(_WGM00|(_WGM01 << 1)|(_WGM02 << 2)); }
inline void set_WGM0(WGM0_WGM_ENUM v){ _WGM00 = v; _WGM01 = v >> 1; _WGM02 = v >> 2; }
// Clock Select - CS0_CS_ENUM - [bit field "CS0" TCCR0B.(CS00 | CS01 | CS02)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS0_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS0_CS_DIV_1,                       	// clk (No prescaling)
	CS0_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS0_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS0_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS0_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS0_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS0_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS0_CS_ENUM;

typedef struct
{
	unsigned char	__CS0             : 3;
} CS0_STRUCT;

#define	_CS0                    ((volatile CS0_STRUCT*)&TCCR0B)->__CS0
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK0.TOIE0]
#define	_TOIE0                  ((volatile BYTE_STRUCT*)&TIMSK0)->bit0
// Compare Output Mode A - _ENUM - [bit field "COMA0" TCCR0A.(COM0A0 | COM0A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA0           : 2;
} COMA0_STRUCT;

#define	_COMA0                  ((volatile COMA0_STRUCT*)&TCCR0A)->__COMA0
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK0.OCIE0A]
#define	_OCIE0A                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB0" TCCR0A.(COM0B0 | COM0B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB0           : 2;
} COMB0_STRUCT;

#define	_COMB0                  ((volatile COMB0_STRUCT*)&TCCR0A)->__COMB0
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK0.OCIE0B]
#define	_OCIE0B                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit2

// other TIMER_COUNTER_0 bit definitions
#define	_OCF0B                  ((volatile BYTE_STRUCT*)&TIFR0)->bit2
#define	_OCF0A                  ((volatile BYTE_STRUCT*)&TIFR0)->bit1
#define	_TOV0                   ((volatile BYTE_STRUCT*)&TIFR0)->bit0
#define	_COM0A1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit7
#define	_COM0A0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit6
#define	_COM0B1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit5
#define	_COM0B0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit4
#define	_FOC0A                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit7
#define	_FOC0B                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit6
#define	_CS02                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit2
#define	_CS01                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit1
#define	_CS00                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit0
#define	_TSM                    ((volatile BYTE_STRUCT*)&GTCCR)->bit7
#define	_ICPSEL1                ((volatile BYTE_STRUCT*)&GTCCR)->bit6
#define	_PSRSYNC                ((volatile BYTE_STRUCT*)&GTCCR)->bit0

//
// TIMER_COUNTER_1 variable definitions
//
// Waveform Generation Mode - WGM1_WGM_ENUM - [bit aggregate (TCCR1A.WGM10 | TCCR1A.WGM11 | TCCR1B.WGM12 | TCCR1B.WGM13)] Controls how the counter will cycle.
typedef enum
{
	WGM1_WGM_Normal,                    	// Normal
	WGM1_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM1_WGM_PWMPhaseCorrect9bit,       	// PWM Phase Correct, 9-bit TOP=0x1FF
	WGM1_WGM_PWMPhaseCorrect10bit,      	// PWM Phase Correct, 10-bit TOP=0x3FF
	WGM1_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM1_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM1_WGM_FastPWM9bit,               	// Fast PWM, 9-bit TOP=0x1FF
	WGM1_WGM_FastPWM10bit,              	// Fast PWM, 10-bit TOP=0x3FF
	WGM1_WGM_PWMPhaseFreqCorrect_ICR,   	// PWM Phase and Freq Correct, TOP=ICR
	WGM1_WGM_PWMPhaseFreqCorrect_OCR,   	// PWM Phase and Freq Correct, TOP=OCRA
	WGM1_WGM_PWMPhaseCorrect_ICR,       	// PWM Phase Correct, TOP=ICR
	WGM1_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM1_WGM_CTC_ICR,                   	// Clear Timer on Compare Match TOP=ICR
	WGM1_WGM_Reserved,                  	// Reserved
	WGM1_WGM_FastPWM_ICR,               	// Fast PWM TOP=ICR
	WGM1_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM1_WGM_ENUM;
#define	_WGM10                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit0
#define	_WGM11                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit1
#define	_WGM12                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit3
#define	_WGM13                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit4
inline WGM1_WGM_ENUM get_WGM1(){ return (WGM1_WGM_ENUM)(_WGM10|(_WGM11 << 1)|(_WGM12 << 2)|(_WGM13 << 3)); }
inline void set_WGM1(WGM1_WGM_ENUM v){ _WGM10 = v; _WGM11 = v >> 1; _WGM12 = v >> 2; _WGM13 = v >> 3; }
// Clock Select - CS1_CS_ENUM - [bit field "CS1" TCCR1B.(CS10 | CS11 | CS12)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS1_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS1_CS_DIV_1,                       	// clk (No prescaling)
	CS1_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS1_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS1_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS1_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS1_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS1_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS1_CS_ENUM;

typedef struct
{
	unsigned char	__CS1             : 3;
} CS1_STRUCT;

#define	_CS1                    ((volatile CS1_STRUCT*)&TCCR1B)->__CS1
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK1.TOIE1]
#define	_TOIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit0
// Input Capture Noise Cancel - Enabling_ENUM - [bit TCCR1B.ICNC1]
#define	_ICNC1                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit7
// Input Capture Edge Select - Trigger_ENUM - [bit TCCR1B.ICES1]
#define	_ICES1                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit6
// Input Capture Interrupt Enable - Enabling_ENUM - [bit TIMSK1.ICIE1]
#define	_ICIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit5
// Compare Output Mode A - _ENUM - [bit field "COMA1" TCCR1A.(COM1A0 | COM1A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA1           : 2;
} COMA1_STRUCT;

#define	_COMA1                  ((volatile COMA1_STRUCT*)&TCCR1A)->__COMA1
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK1.OCIE1A]
#define	_OCIE1A                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB1" TCCR1A.(COM1B0 | COM1B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB1           : 2;
} COMB1_STRUCT;

#define	_COMB1                  ((volatile COMB1_STRUCT*)&TCCR1A)->__COMB1
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK1.OCIE1B]
#define	_OCIE1B                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit2

// other TIMER_COUNTER_1 bit definitions
#define	_ICF1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit5
#define	_OCF1B                  ((volatile BYTE_STRUCT*)&TIFR1)->bit2
#define	_OCF1A                  ((volatile BYTE_STRUCT*)&TIFR1)->bit1
#define	_TOV1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit0
#define	_COM1A1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit7
#define	_COM1A0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit6
#define	_COM1B1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit5
#define	_COM1B0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit4
#define	_CS12                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit2
#define	_CS11                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit1
#define	_CS10                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit0
#define	_FOC1A                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit7
#define	_FOC1B                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit6

//
// USART variable definitions
//
// Receiver Enable - Enabling_ENUM - [bit UCSRB.RXEN]
#define	_RXEN                   ((volatile BYTE_STRUCT*)&UCSRB)->bit4
// Transmitter Enable - Enabling_ENUM - [bit UCSRB.TXEN]
#define	_TXEN                   ((volatile BYTE_STRUCT*)&UCSRB)->bit3
// Mode Select - UMSEL_UsartModeSelect_ENUM - [bit UCSRC.UMSEL0] Select between Asynchronous and Synchronous mode of operation.
typedef enum
{
	UMSEL_UsartModeSelect_Async,        	// Asynchronous Operation
	UMSEL_UsartModeSelect_Sync,         	// Synchronous Operation
} UMSEL_UsartModeSelect_ENUM;
#define	_UMSEL0                 ((volatile BYTE_STRUCT*)&UCSRC)->bit6
// Character Size - UsartCharacterSize_ENUM - [bit aggregate (UCSRC.UCSZ0 | UCSRC.UCSZ1 | UCSRB.UCSZ2)] Set the number of data bits in a frame the Receiver and Transmitter use.
#define	_UCSZ0                  ((volatile BYTE_STRUCT*)&UCSRC)->bit1
#define	_UCSZ1                  ((volatile BYTE_STRUCT*)&UCSRC)->bit2
#define	_UCSZ2                  ((volatile BYTE_STRUCT*)&UCSRB)->bit2
inline UsartCharacterSize_ENUM get_UCSZ(){ return (UsartCharacterSize_ENUM)(_UCSZ0|(_UCSZ1 << 1)|(_UCSZ2 << 2)); }
inline void set_UCSZ(UsartCharacterSize_ENUM v){ _UCSZ0 = v; _UCSZ1 = v >> 1; _UCSZ2 = v >> 2; }
// Stop Bit Select - UsartStopBitSelect_ENUM - [bit UCSRC.USBS] Selects the number of Stop Bits to be inserted by the Transmitter. The Receiver ignores this setting.
#define	_USBS                   ((volatile BYTE_STRUCT*)&UCSRC)->bit3
// Parity Mode - UsartParityMode_ENUM - [bit field "UPM" UCSRC.(UPM0 | UPM1)] Enable and set type of parity generation and check.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__UPM             : 2;
} UPM_STRUCT;

#define	_UPM                    ((volatile UPM_STRUCT*)&UCSRC)->__UPM
// Double Transmission Speed - Enabling_ENUM - [bit UCSRA.U2X]
#define	_U2X                    ((volatile BYTE_STRUCT*)&UCSRA)->bit1
// Clock Polarity - UsartClockPolarity_ENUM - [bit UCSRC.UCPOL] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
#define	_UCPOL                  ((volatile BYTE_STRUCT*)&UCSRC)->bit0
// Multi-processor Communication Mode - Enabling_ENUM - [bit UCSRA.MPCM]
#define	_MPCM                   ((volatile BYTE_STRUCT*)&UCSRA)->bit0
// RX Complete Interrupt Enable - Enabling_ENUM - [bit UCSRB.RXCIE]
#define	_RXCIE                  ((volatile BYTE_STRUCT*)&UCSRB)->bit7
// TX Complete Interrupt Enable - Enabling_ENUM - [bit UCSRB.TXCIE]
#define	_TXCIE                  ((volatile BYTE_STRUCT*)&UCSRB)->bit6
// Data Register Empty Interrupt Enable - Enabling_ENUM - [bit UCSRB.UDRIE] Enable an interrupt when the transmit buffer (UDR) is ready to receive new data.
#define	_UDRIE                  ((volatile BYTE_STRUCT*)&UCSRB)->bit5

// other USART bit definitions
#define	_RXC                    ((volatile BYTE_STRUCT*)&UCSRA)->bit7
#define	_TXC                    ((volatile BYTE_STRUCT*)&UCSRA)->bit6
#define	_UDRE                   ((volatile BYTE_STRUCT*)&UCSRA)->bit5
#define	_FE                     ((volatile BYTE_STRUCT*)&UCSRA)->bit4
#define	_DOR                    ((volatile BYTE_STRUCT*)&UCSRA)->bit3
#define	_UPE                    ((volatile BYTE_STRUCT*)&UCSRA)->bit2
#define	_RXB8                   ((volatile BYTE_STRUCT*)&UCSRB)->bit1
#define	_TXB8                   ((volatile BYTE_STRUCT*)&UCSRB)->bit0
#define	_UPM1                   ((volatile BYTE_STRUCT*)&UCSRC)->bit5
#define	_UPM0                   ((volatile BYTE_STRUCT*)&UCSRC)->bit4

//
// WATCHDOG variable definitions
//
// Prescaler - WdtPrescale_ENUM - [bit aggregate (WDTCSR.WDP0 | WDTCSR.WDP1 | WDTCSR.WDP2 | WDTCSR.WDP3)] Sets the watchdog timeout period. Values are typical at 5v.
#define	_WDP0                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit0
#define	_WDP1                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit1
#define	_WDP2                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit2
#define	_WDP3                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit5
inline WdtPrescale_ENUM get_WDP(){ return (WdtPrescale_ENUM)(_WDP0|(_WDP1 << 1)|(_WDP2 << 2)|(_WDP3 << 3)); }
inline void set_WDP(WdtPrescale_ENUM v){ _WDP0 = v; _WDP1 = v >> 1; _WDP2 = v >> 2; _WDP3 = v >> 3; }
// Configuration - WdtMode_ENUM - [bit aggregate (WDTCSR.WDIE | WDTCSR.WDE)] Determines the action taken when a watchdog timeout occurs.
#define	_WDIE                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit6
#define	_WDE                    ((volatile BYTE_STRUCT*)&WDTCSR)->bit3
inline WdtMode_ENUM get_Mode(){ return (WdtMode_ENUM)(_WDIE|(_WDE << 1)); }
inline void set_Mode(WdtMode_ENUM v){ _WDIE = v; _WDE = v >> 1; }

// other WATCHDOG bit definitions
#define	_WDIF                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit7
#define	_WDCE                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit4

#define _AID_AT90PWM316_DEFINED_
#endif /* _AID_AT90PWM316_DEFINED_ */
