#ifndef _AID_AT90USB1287_DEFINED_

typedef enum
{
	Disabling_Enabled,                  	// Enabled
	Disabling_Disabled,                 	// Disabled
} Disabling_ENUM;

typedef enum
{
	Enabling_Disabled,                  	// Disabled
	Enabling_Enabled,                   	// Enabled
} Enabling_ENUM;

typedef enum
{
	ACIntModeSelect_OutputToggle,       	// Comparator Interrupt on Output Toggle
	ACIntModeSelect_Reserved,           	// Reserved
	ACIntModeSelect_FallingOutputEdge,  	// Comparator Interrupt on Falling Output Edge
	ACIntModeSelect_RisingOutputEdge,   	// Comparator Interrupt on Rising Output Edge
} ACIntModeSelect_ENUM;

typedef enum
{
	ACBandgapSelect_NoBandgap,          	// Use AIN0 as positive input
	ACBandgapSelect_Bandgap,            	// Use fixed bandgap reference voltage as positive input
} ACBandgapSelect_ENUM;

typedef enum
{
	SenseA_LowLevel,                    	// Low Level Generates Interrupt
	SenseA_AnyChange,                   	// Any Change Generates Interrupt
	SenseA_FallingEdge,                 	// Falling Edge Generates Interrupt
	SenseA_RisingEdge,                  	// Rising Edge Generates Interrupt
} SenseA_ENUM;

typedef enum
{
	SPIMaster_Slave,                    	// Slave Mode
	SPIMaster_Master,                   	// Master Mode
} SPIMaster_ENUM;

typedef enum
{
	SPR_DIV_4,                          	// clk / 4
	SPR_DIV_16,                         	// clk / 16
	SPR_DIV_64,                         	// clk / 64
	SPR_DIV_128,                        	// clk / 128
	SPR_DIV_2,                          	// clk / 2
	SPR_DIV_8,                          	// clk / 8
	SPR_DIV_32,                         	// clk / 32
	SPR_DIV_64b,                        	// clk / 64
} SPR_ENUM;

typedef enum
{
	SPIMode_Mode0,                      	// 0 - Leading (Rising) Edge Sample, Trailing (Falling) Edge Setup
	SPIMode_Mode1,                      	// 1 - Leading (Rising) Edge Setup, Trailing (Falling) Edge Sample
	SPIMode_Mode2,                      	// 2 - Leading (Falling) Edge Sample, Trailing (Rising) Edge Setup
	SPIMode_Mode3,                      	// 3 - Leading (Falling) Edge Setup, Trailing (Rising) Edge Sample
} SPIMode_ENUM;

typedef enum
{
	SPIDataOrder_MSBFirst,              	// Most Significant Bit First
	SPIDataOrder_LSBFirst,              	// Least Significant Bit First
} SPIDataOrder_ENUM;

typedef enum
{
	Trigger_Falling,                    	// Falling Edge Trigger
	Trigger_Rising,                     	// Rising Edge Trigger
} Trigger_ENUM;

typedef enum
{
	Prescaler_Prescaler1,               	// Prescaler 1
	Prescaler_Prescaler4,               	// Prescaler 4
	Prescaler_Prescaler16,              	// Prescaler 16
	Prescaler_Prescaler64,              	// Prescaler 64
} Prescaler_ENUM;

typedef enum
{
	UsartModeSelect_Async,              	// Asynchronous Operation
	UsartModeSelect_Sync,               	// Synchronous Operation
	UsartModeSelect_Reserved,           	// Reserved
	UsartModeSelect_MasterSPI,          	// Master SPI
} UsartModeSelect_ENUM;

typedef enum
{
	UsartCharacterSize_FiveBits,        	// 5 bits
	UsartCharacterSize_SixBits,         	// 6 bits
	UsartCharacterSize_SevenBits,       	// 7 bits
	UsartCharacterSize_EightBits,       	// 8 bits
	UsartCharacterSize_Reserved,        	// Reserved
	UsartCharacterSize_Reserved2,       	// Reserved
	UsartCharacterSize_Reserved3,       	// Reserved
	UsartCharacterSize_NineBits,        	// 9 bits
} UsartCharacterSize_ENUM;

typedef enum
{
	UsartStopBitSelect_OneStopBit,      	// 1 stop bit
	UsartStopBitSelect_TwoStopBits,     	// 2 stop bits
} UsartStopBitSelect_ENUM;

typedef enum
{
	UsartParityMode_Disabled,           	// Disabled
	UsartParityMode_Reserved,           	// Reserved
	UsartParityMode_EvenParity,         	// Even Parity
	UsartParityMode_OddParity,          	// Odd Parity
} UsartParityMode_ENUM;

typedef enum
{
	UsartClockPolarity_Normal,          	// TX Changed on Rising Edge, RX Sampled on Falling Edge
	UsartClockPolarity_Inverted,        	// TX Changed on Falling Edge, RX Sampled on Rising Edge
} UsartClockPolarity_ENUM;

typedef enum
{
	WdtPrescale_WDTO_16MS,              	// Typical Time-out 16 ms
	WdtPrescale_WDTO_32MS,              	// Typical Time-out 32 ms
	WdtPrescale_WDTO_64MS,              	// Typical Time-out 64 ms
	WdtPrescale_WDTO_125MS,             	// Typical Time-out 125 ms
	WdtPrescale_WDTO_250MS,             	// Typical Time-out 250 ms
	WdtPrescale_WDTO_500MS,             	// Typical Time-out 500 ms
	WdtPrescale_WDTO_1S,                	// Typical Time-out 1 sec
	WdtPrescale_WDTO_2S,                	// Typical Time-out 2 sec
	WdtPrescale_WDTO_4S,                	// Typical Time-out 4 sec
	WdtPrescale_WDTO_8S,                	// Typical Time-out 8 sec
	WdtPrescale_WDTO_Invalid1,          	// Invalid
	WdtPrescale_WDTO_Invalid2,          	// Invalid
	WdtPrescale_WDTO_Invalid3,          	// Invalid
	WdtPrescale_WDTO_Invalid4,          	// Invalid
	WdtPrescale_WDTO_Invalid5,          	// Invalid
	WdtPrescale_WDTO_Invalid6,          	// Invalid
} WdtPrescale_ENUM;

typedef enum
{
	WdtMode_Disabled,                   	// Disabled
	WdtMode_Interrupt,                  	// Interrupt on timeout
	WdtMode_SystemReset,                	// System reset on timeout
	WdtMode_InterruptAndSystemReset,    	// Interrupt on first timeout, system reset on next
} WdtMode_ENUM;

//
// AD_CONVERTER variable definitions
//
#define	_REFS1                  ((volatile BYTE_STRUCT*)&ADMUX)->bit7
#define	_REFS0                  ((volatile BYTE_STRUCT*)&ADMUX)->bit6
#define	_ADLAR                  ((volatile BYTE_STRUCT*)&ADMUX)->bit5
#define	_MUX4                   ((volatile BYTE_STRUCT*)&ADMUX)->bit4
#define	_MUX3                   ((volatile BYTE_STRUCT*)&ADMUX)->bit3
#define	_MUX2                   ((volatile BYTE_STRUCT*)&ADMUX)->bit2
#define	_MUX1                   ((volatile BYTE_STRUCT*)&ADMUX)->bit1
#define	_MUX0                   ((volatile BYTE_STRUCT*)&ADMUX)->bit0
#define	_ADEN                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit7
#define	_ADSC                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit6
#define	_ADATE                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit5
#define	_ADIF                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit4
#define	_ADIE                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit3
#define	_ADPS2                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit2
#define	_ADPS1                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit1
#define	_ADPS0                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit0
#define	_ADHSM                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit7
#define	_ADTS2                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit2
#define	_ADTS1                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit1
#define	_ADTS0                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit0
#define	_ADC7D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit7
#define	_ADC6D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit6
#define	_ADC5D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit5
#define	_ADC4D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit4
#define	_ADC3D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit3
#define	_ADC2D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit2
#define	_ADC1D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit1
#define	_ADC0D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit0

//
// ANALOG_COMPARATOR variable definitions
//
// Analog Comparator Disable - Disabling_ENUM - [bit ACSR.ACD] Disables the Analog Comparator.
#define	_ACD                    ((volatile BYTE_STRUCT*)&ACSR)->bit7
// Interrupt Enable - Enabling_ENUM - [bit ACSR.ACIE] When enabled and the I-bit in the Status Register is set, the Analog Comparator interrupt is activated.
#define	_ACIE                   ((volatile BYTE_STRUCT*)&ACSR)->bit3
// Interrupt Mode Select - ACIntModeSelect_ENUM - [bit field "ACIS" ACSR.(ACIS0 | ACIS1)] Determine which comparator events trigger the Analog Comparator interrupt.

typedef struct
{
	unsigned char	__ACIS            : 2;
} ACIS_STRUCT;

#define	_ACIS                   ((volatile ACIS_STRUCT*)&ACSR)->__ACIS
// Input Capture Enable - Enabling_ENUM - [bit ACSR.ACIC] Enables the input capture function in Timer/Counter1 to be triggered by the Analog Comparator.
#define	_ACIC                   ((volatile BYTE_STRUCT*)&ACSR)->bit2
// Bandgap Select - ACBandgapSelect_ENUM - [bit ACSR.ACBG] Selects a bandgap reference voltage as the positive input.
#define	_ACBG                   ((volatile BYTE_STRUCT*)&ACSR)->bit6
// Multiplexer Enable - Enabling_ENUM - [bit ADCSRB.ACME] When enabled and the ADC is switched off, the ADC multiplexer selects the negative input to the Analog Comparator. When disabled, AIN1 is applied to the negative input of the Analog Comparator.
#define	_ACME                   ((volatile BYTE_STRUCT*)&ADCSRB)->bit6
// Digital Input 0 Disable - Disabling_ENUM - [bit DIDR1.AIN0D] When disabled, the digital input buffer on the AIN0 pin is disabled.
#define	_AIN0D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit0
// Digital Input 1 Disable - Disabling_ENUM - [bit DIDR1.AIN1D] When disabled, the digital input buffer on the AIN1 pin is disabled.
#define	_AIN1D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit1

// other ANALOG_COMPARATOR bit definitions
#define	_ACO                    ((volatile BYTE_STRUCT*)&ACSR)->bit5
#define	_ACI                    ((volatile BYTE_STRUCT*)&ACSR)->bit4
#define	_ACIS1                  ((volatile BYTE_STRUCT*)&ACSR)->bit1
#define	_ACIS0                  ((volatile BYTE_STRUCT*)&ACSR)->bit0

//
// BOOT_LOAD variable definitions
//
#define	_SPMIE                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit7
#define	_RWWSB                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit6
#define	_SIGRD                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit5
#define	_RWWSRE                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit4
#define	_BLBSET                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit3
#define	_PGWRT                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit2
#define	_PGERS                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit1
#define	_SPMEN                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit0

//
// CPU variable definitions
//
#define	_JTD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit7
#define	_PUD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit4
#define	_IVSEL                  ((volatile BYTE_STRUCT*)&MCUCR)->bit1
#define	_IVCE                   ((volatile BYTE_STRUCT*)&MCUCR)->bit0
#define	_JTRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit4
#define	_WDRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit3
#define	_BORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit2
#define	_EXTRF                  ((volatile BYTE_STRUCT*)&MCUSR)->bit1
#define	_PORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit0
#define	_SRE                    ((volatile BYTE_STRUCT*)&XMCRA)->bit7
#define	_SRL2                   ((volatile BYTE_STRUCT*)&XMCRA)->bit6
#define	_SRL1                   ((volatile BYTE_STRUCT*)&XMCRA)->bit5
#define	_SRL0                   ((volatile BYTE_STRUCT*)&XMCRA)->bit4
#define	_SRW11                  ((volatile BYTE_STRUCT*)&XMCRA)->bit3
#define	_SRW10                  ((volatile BYTE_STRUCT*)&XMCRA)->bit2
#define	_SRW01                  ((volatile BYTE_STRUCT*)&XMCRA)->bit1
#define	_SRW00                  ((volatile BYTE_STRUCT*)&XMCRA)->bit0
#define	_XMBK                   ((volatile BYTE_STRUCT*)&XMCRB)->bit7
#define	_XMM2                   ((volatile BYTE_STRUCT*)&XMCRB)->bit2
#define	_XMM1                   ((volatile BYTE_STRUCT*)&XMCRB)->bit1
#define	_XMM0                   ((volatile BYTE_STRUCT*)&XMCRB)->bit0
#define	_CLKPCE                 ((volatile BYTE_STRUCT*)&CLKPR)->bit7
#define	_CLKPS3                 ((volatile BYTE_STRUCT*)&CLKPR)->bit3
#define	_CLKPS2                 ((volatile BYTE_STRUCT*)&CLKPR)->bit2
#define	_CLKPS1                 ((volatile BYTE_STRUCT*)&CLKPR)->bit1
#define	_CLKPS0                 ((volatile BYTE_STRUCT*)&CLKPR)->bit0
#define	_SM2                    ((volatile BYTE_STRUCT*)&SMCR)->bit3
#define	_SM1                    ((volatile BYTE_STRUCT*)&SMCR)->bit2
#define	_SM0                    ((volatile BYTE_STRUCT*)&SMCR)->bit1
#define	_SE                     ((volatile BYTE_STRUCT*)&SMCR)->bit0
#define	_RAMPZ0                 ((volatile BYTE_STRUCT*)&RAMPZ)->bit0
#define	_EIND0                  ((volatile BYTE_STRUCT*)&EIND)->bit0
#define	_PRUSB                  ((volatile BYTE_STRUCT*)&PRR1)->bit7
#define	_PRTIM3                 ((volatile BYTE_STRUCT*)&PRR1)->bit3
#define	_PRUSART1               ((volatile BYTE_STRUCT*)&PRR1)->bit0
#define	_PRTWI                  ((volatile BYTE_STRUCT*)&PRR0)->bit7
#define	_PRTIM2                 ((volatile BYTE_STRUCT*)&PRR0)->bit6
#define	_PRTIM0                 ((volatile BYTE_STRUCT*)&PRR0)->bit5
#define	_PRTIM1                 ((volatile BYTE_STRUCT*)&PRR0)->bit3
#define	_PRSPI                  ((volatile BYTE_STRUCT*)&PRR0)->bit2
#define	_PRADC                  ((volatile BYTE_STRUCT*)&PRR0)->bit0

//
// EEPROM variable definitions
//
#define	_EEPM1                  ((volatile BYTE_STRUCT*)&EECR)->bit5
#define	_EEPM0                  ((volatile BYTE_STRUCT*)&EECR)->bit4
#define	_EERIE                  ((volatile BYTE_STRUCT*)&EECR)->bit3
#define	_EEMPE                  ((volatile BYTE_STRUCT*)&EECR)->bit2
#define	_EEPE                   ((volatile BYTE_STRUCT*)&EECR)->bit1
#define	_EERE                   ((volatile BYTE_STRUCT*)&EECR)->bit0

//
// EXTERNAL_INTERRUPT variable definitions
//
// INT0 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT0] Enables the interrupt on the INT pin
#define	_INT0                   ((volatile BYTE_STRUCT*)&EIMSK)->bit0
// INT0 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC0" EICRA.(ISC00 | ISC01)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__ISC0            : 2;
} ISC0_STRUCT;

#define	_ISC0                   ((volatile ISC0_STRUCT*)&EICRA)->__ISC0
// INT1 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT1] Enables the interrupt on the INT pin
#define	_INT1                   ((volatile BYTE_STRUCT*)&EIMSK)->bit1
// INT1 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC1" EICRA.(ISC10 | ISC11)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__ISC1            : 2;
} ISC1_STRUCT;

#define	_ISC1                   ((volatile ISC1_STRUCT*)&EICRA)->__ISC1
// INT2 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT2] Enables the interrupt on the INT pin
#define	_INT2                   ((volatile BYTE_STRUCT*)&EIMSK)->bit2
// INT2 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC2" EICRA.(ISC20 | ISC21)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__ISC2            : 2;
} ISC2_STRUCT;

#define	_ISC2                   ((volatile ISC2_STRUCT*)&EICRA)->__ISC2
// INT3 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT3] Enables the interrupt on the INT pin
#define	_INT3                   ((volatile BYTE_STRUCT*)&EIMSK)->bit3
// INT3 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC3" EICRA.(ISC30 | ISC31)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__ISC3            : 2;
} ISC3_STRUCT;

#define	_ISC3                   ((volatile ISC3_STRUCT*)&EICRA)->__ISC3
// INT4 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT4] Enables the interrupt on the INT pin
#define	_INT4                   ((volatile BYTE_STRUCT*)&EIMSK)->bit4
// INT4 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC4" EICRB.(ISC40 | ISC41)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__ISC4            : 2;
} ISC4_STRUCT;

#define	_ISC4                   ((volatile ISC4_STRUCT*)&EICRB)->__ISC4
// INT5 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT5] Enables the interrupt on the INT pin
#define	_INT5                   ((volatile BYTE_STRUCT*)&EIMSK)->bit5
// INT5 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC5" EICRB.(ISC50 | ISC51)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__ISC5            : 2;
} ISC5_STRUCT;

#define	_ISC5                   ((volatile ISC5_STRUCT*)&EICRB)->__ISC5
// INT6 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT6] Enables the interrupt on the INT pin
#define	_INT6                   ((volatile BYTE_STRUCT*)&EIMSK)->bit6
// INT6 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC6" EICRB.(ISC60 | ISC61)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__ISC6            : 2;
} ISC6_STRUCT;

#define	_ISC6                   ((volatile ISC6_STRUCT*)&EICRB)->__ISC6
// INT7 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT7] Enables the interrupt on the INT pin
#define	_INT7                   ((volatile BYTE_STRUCT*)&EIMSK)->bit7
// INT7 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC7" EICRB.(ISC70 | ISC71)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__ISC7            : 2;
} ISC7_STRUCT;

#define	_ISC7                   ((volatile ISC7_STRUCT*)&EICRB)->__ISC7
// PCINT0 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT0] Enables interrupts on PCINT0
#define	_PCINT0                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit0
// PCINT1 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT1] Enables interrupts on PCINT1
#define	_PCINT1                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit1
// PCINT2 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT2] Enables interrupts on PCINT2
#define	_PCINT2                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit2
// PCINT3 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT3] Enables interrupts on PCINT3
#define	_PCINT3                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit3
// PCINT4 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT4] Enables interrupts on PCINT4
#define	_PCINT4                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit4
// PCINT5 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT5] Enables interrupts on PCINT5
#define	_PCINT5                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit5
// PCINT6 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT6] Enables interrupts on PCINT6
#define	_PCINT6                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit6
// PCINT7 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT7] Enables interrupts on PCINT7
#define	_PCINT7                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit7
// PCIE0 Interrupt Enable - Enabling_ENUM - [bit PCICR.PCIE0] Enables interrupts for PCINT7..0
#define	_PCIE0                  ((volatile BYTE_STRUCT*)&PCICR)->bit0

// other EXTERNAL_INTERRUPT bit definitions
#define	_ISC31                  ((volatile BYTE_STRUCT*)&EICRA)->bit7
#define	_ISC30                  ((volatile BYTE_STRUCT*)&EICRA)->bit6
#define	_ISC21                  ((volatile BYTE_STRUCT*)&EICRA)->bit5
#define	_ISC20                  ((volatile BYTE_STRUCT*)&EICRA)->bit4
#define	_ISC11                  ((volatile BYTE_STRUCT*)&EICRA)->bit3
#define	_ISC10                  ((volatile BYTE_STRUCT*)&EICRA)->bit2
#define	_ISC01                  ((volatile BYTE_STRUCT*)&EICRA)->bit1
#define	_ISC00                  ((volatile BYTE_STRUCT*)&EICRA)->bit0
#define	_ISC71                  ((volatile BYTE_STRUCT*)&EICRB)->bit7
#define	_ISC70                  ((volatile BYTE_STRUCT*)&EICRB)->bit6
#define	_ISC61                  ((volatile BYTE_STRUCT*)&EICRB)->bit5
#define	_ISC60                  ((volatile BYTE_STRUCT*)&EICRB)->bit4
#define	_ISC51                  ((volatile BYTE_STRUCT*)&EICRB)->bit3
#define	_ISC50                  ((volatile BYTE_STRUCT*)&EICRB)->bit2
#define	_ISC41                  ((volatile BYTE_STRUCT*)&EICRB)->bit1
#define	_ISC40                  ((volatile BYTE_STRUCT*)&EICRB)->bit0
#define	_INTF7                  ((volatile BYTE_STRUCT*)&EIFR)->bit7
#define	_INTF6                  ((volatile BYTE_STRUCT*)&EIFR)->bit6
#define	_INTF5                  ((volatile BYTE_STRUCT*)&EIFR)->bit5
#define	_INTF4                  ((volatile BYTE_STRUCT*)&EIFR)->bit4
#define	_INTF3                  ((volatile BYTE_STRUCT*)&EIFR)->bit3
#define	_INTF2                  ((volatile BYTE_STRUCT*)&EIFR)->bit2
#define	_INTF1                  ((volatile BYTE_STRUCT*)&EIFR)->bit1
#define	_INTF0                  ((volatile BYTE_STRUCT*)&EIFR)->bit0
#define	_PCIF0                  ((volatile BYTE_STRUCT*)&PCIFR)->bit0

//
// JTAG variable definitions
//
// JTAG Disable - Disabling_ENUM - [bit MCUCR.JTD] Disables JTAG operation.

// other JTAG bit definitions

//
// PLL variable definitions
//
#define	_PLLP2                  ((volatile BYTE_STRUCT*)&PLLCSR)->bit4
#define	_PLLP1                  ((volatile BYTE_STRUCT*)&PLLCSR)->bit3
#define	_PLLP0                  ((volatile BYTE_STRUCT*)&PLLCSR)->bit2
#define	_PLLE                   ((volatile BYTE_STRUCT*)&PLLCSR)->bit1
#define	_PLOCK                  ((volatile BYTE_STRUCT*)&PLLCSR)->bit0

//
// SPI variable definitions
//
// SPI Enable - Enabling_ENUM - [bit SPCR.SPE]
#define	_SPE                    ((volatile BYTE_STRUCT*)&SPCR)->bit6
// Master/Slave Mode - SPIMaster_ENUM - [bit SPCR.MSTR]
#define	_MSTR                   ((volatile BYTE_STRUCT*)&SPCR)->bit4
// Clock Rate Select - SPR_ENUM - [bit aggregate (SPCR.SPR0 | SPCR.SPR1 | SPSR.SPI2X)] Controls the SCK rate of the device configured as a Master.
#define	_SPR0                   ((volatile BYTE_STRUCT*)&SPCR)->bit0
#define	_SPR1                   ((volatile BYTE_STRUCT*)&SPCR)->bit1
#define	_SPI2X                  ((volatile BYTE_STRUCT*)&SPSR)->bit0
inline SPR_ENUM get_SPR(){ return (SPR_ENUM)(_SPR0|(_SPR1 << 1)|(_SPI2X << 2)); }
inline void set_SPR(SPR_ENUM v){ _SPR0 = v; _SPR1 = v >> 1; _SPI2X = v >> 2; }
// SPI Mode - SPIMode_ENUM - [bit field "MODE" SPCR.(CPHA | CPOL)] Sets the relationship between data output change and data input sample, and the synchronous clock (SCK).

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__MODE            : 2;
} MODE_STRUCT;

#define	_MODE                   ((volatile MODE_STRUCT*)&SPCR)->__MODE
// Data Order - SPIDataOrder_ENUM - [bit SPCR.DORD] Sets the order in which bits are transmitted.
#define	_DORD                   ((volatile BYTE_STRUCT*)&SPCR)->bit5
// SPI Interrupt Enable - Enabling_ENUM - [bit SPCR.SPIE]
#define	_SPIE                   ((volatile BYTE_STRUCT*)&SPCR)->bit7

// other SPI bit definitions
#define	_SPIF                   ((volatile BYTE_STRUCT*)&SPSR)->bit7
#define	_WCOL                   ((volatile BYTE_STRUCT*)&SPSR)->bit6
#define	_CPOL                   ((volatile BYTE_STRUCT*)&SPCR)->bit3
#define	_CPHA                   ((volatile BYTE_STRUCT*)&SPCR)->bit2

//
// TIMER_COUNTER_0 variable definitions
//
// Waveform Generation Mode - WGM0_WGM_ENUM - [bit aggregate (TCCR0A.WGM00 | TCCR0A.WGM01 | TCCR0B.WGM02)] Controls how the counter will cycle.
typedef enum
{
	WGM0_WGM_Normal,                    	// Normal
	WGM0_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM0_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM0_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM0_WGM_Reserved,                  	// Reserved
	WGM0_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM0_WGM_Reserved2,                 	// Reserved
	WGM0_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM0_WGM_ENUM;
#define	_WGM00                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit0
#define	_WGM01                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit1
#define	_WGM02                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit3
inline WGM0_WGM_ENUM get_WGM0(){ return (WGM0_WGM_ENUM)(_WGM00|(_WGM01 << 1)|(_WGM02 << 2)); }
inline void set_WGM0(WGM0_WGM_ENUM v){ _WGM00 = v; _WGM01 = v >> 1; _WGM02 = v >> 2; }
// Clock Select - CS0_CS_ENUM - [bit field "CS0" TCCR0B.(CS00 | CS01 | CS02)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS0_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS0_CS_DIV_1,                       	// clk (No prescaling)
	CS0_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS0_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS0_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS0_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS0_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS0_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS0_CS_ENUM;

typedef struct
{
	unsigned char	__CS0             : 3;
} CS0_STRUCT;

#define	_CS0                    ((volatile CS0_STRUCT*)&TCCR0B)->__CS0
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK0.TOIE0]
#define	_TOIE0                  ((volatile BYTE_STRUCT*)&TIMSK0)->bit0
// Compare Output Mode A - _ENUM - [bit field "COMA0" TCCR0A.(COM0A0 | COM0A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA0           : 2;
} COMA0_STRUCT;

#define	_COMA0                  ((volatile COMA0_STRUCT*)&TCCR0A)->__COMA0
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK0.OCIE0A]
#define	_OCIE0A                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB0" TCCR0A.(COM0B0 | COM0B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB0           : 2;
} COMB0_STRUCT;

#define	_COMB0                  ((volatile COMB0_STRUCT*)&TCCR0A)->__COMB0
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK0.OCIE0B]
#define	_OCIE0B                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit2

// other TIMER_COUNTER_0 bit definitions
#define	_OCF0B                  ((volatile BYTE_STRUCT*)&TIFR0)->bit2
#define	_OCF0A                  ((volatile BYTE_STRUCT*)&TIFR0)->bit1
#define	_TOV0                   ((volatile BYTE_STRUCT*)&TIFR0)->bit0
#define	_COM0A1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit7
#define	_COM0A0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit6
#define	_COM0B1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit5
#define	_COM0B0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit4
#define	_FOC0A                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit7
#define	_FOC0B                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit6
#define	_CS02                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit2
#define	_CS01                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit1
#define	_CS00                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit0
#define	_TSM                    ((volatile BYTE_STRUCT*)&GTCCR)->bit7
#define	_PSRSYNC                ((volatile BYTE_STRUCT*)&GTCCR)->bit0

//
// TIMER_COUNTER_1 variable definitions
//
// Waveform Generation Mode - WGM1_WGM_ENUM - [bit aggregate (TCCR1A.WGM10 | TCCR1A.WGM11 | TCCR1B.WGM12 | TCCR1B.WGM13)] Controls how the counter will cycle.
typedef enum
{
	WGM1_WGM_Normal,                    	// Normal
	WGM1_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM1_WGM_PWMPhaseCorrect9bit,       	// PWM Phase Correct, 9-bit TOP=0x1FF
	WGM1_WGM_PWMPhaseCorrect10bit,      	// PWM Phase Correct, 10-bit TOP=0x3FF
	WGM1_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM1_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM1_WGM_FastPWM9bit,               	// Fast PWM, 9-bit TOP=0x1FF
	WGM1_WGM_FastPWM10bit,              	// Fast PWM, 10-bit TOP=0x3FF
	WGM1_WGM_PWMPhaseFreqCorrect_ICR,   	// PWM Phase and Freq Correct, TOP=ICR
	WGM1_WGM_PWMPhaseFreqCorrect_OCR,   	// PWM Phase and Freq Correct, TOP=OCRA
	WGM1_WGM_PWMPhaseCorrect_ICR,       	// PWM Phase Correct, TOP=ICR
	WGM1_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM1_WGM_CTC_ICR,                   	// Clear Timer on Compare Match TOP=ICR
	WGM1_WGM_Reserved,                  	// Reserved
	WGM1_WGM_FastPWM_ICR,               	// Fast PWM TOP=ICR
	WGM1_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM1_WGM_ENUM;
#define	_WGM10                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit0
#define	_WGM11                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit1
#define	_WGM12                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit3
#define	_WGM13                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit4
inline WGM1_WGM_ENUM get_WGM1(){ return (WGM1_WGM_ENUM)(_WGM10|(_WGM11 << 1)|(_WGM12 << 2)|(_WGM13 << 3)); }
inline void set_WGM1(WGM1_WGM_ENUM v){ _WGM10 = v; _WGM11 = v >> 1; _WGM12 = v >> 2; _WGM13 = v >> 3; }
// Clock Select - CS1_CS_ENUM - [bit field "CS1" TCCR1B.(CS10 | CS11 | CS12)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS1_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS1_CS_DIV_1,                       	// clk (No prescaling)
	CS1_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS1_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS1_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS1_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS1_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS1_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS1_CS_ENUM;

typedef struct
{
	unsigned char	__CS1             : 3;
} CS1_STRUCT;

#define	_CS1                    ((volatile CS1_STRUCT*)&TCCR1B)->__CS1
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK1.TOIE1]
#define	_TOIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit0
// Input Capture Noise Cancel - Enabling_ENUM - [bit TCCR1B.ICNC1]
#define	_ICNC1                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit7
// Input Capture Edge Select - Trigger_ENUM - [bit TCCR1B.ICES1]
#define	_ICES1                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit6
// Input Capture Interrupt Enable - Enabling_ENUM - [bit TIMSK1.ICIE1]
#define	_ICIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit5
// Compare Output Mode A - _ENUM - [bit field "COMA1" TCCR1A.(COM1A0 | COM1A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA1           : 2;
} COMA1_STRUCT;

#define	_COMA1                  ((volatile COMA1_STRUCT*)&TCCR1A)->__COMA1
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK1.OCIE1A]
#define	_OCIE1A                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB1" TCCR1A.(COM1B0 | COM1B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB1           : 2;
} COMB1_STRUCT;

#define	_COMB1                  ((volatile COMB1_STRUCT*)&TCCR1A)->__COMB1
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK1.OCIE1B]
#define	_OCIE1B                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit2
// Compare Output Mode C - _ENUM - [bit field "COMC1" TCCR1A.(COM1C0 | COM1C1)] Controls the Output Compare pin (OCnC) behavior.

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__COMC1           : 2;
} COMC1_STRUCT;

#define	_COMC1                  ((volatile COMC1_STRUCT*)&TCCR1A)->__COMC1
// Output Compare Match Interrupt Enable C - Enabling_ENUM - [bit TIMSK1.OCIE1C]
#define	_OCIE1C                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit3

// other TIMER_COUNTER_1 bit definitions
#define	_ICF1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit5
#define	_OCF1C                  ((volatile BYTE_STRUCT*)&TIFR1)->bit3
#define	_OCF1B                  ((volatile BYTE_STRUCT*)&TIFR1)->bit2
#define	_OCF1A                  ((volatile BYTE_STRUCT*)&TIFR1)->bit1
#define	_TOV1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit0
#define	_COM1A1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit7
#define	_COM1A0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit6
#define	_COM1B1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit5
#define	_COM1B0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit4
#define	_COM1C1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit3
#define	_COM1C0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit2
#define	_CS12                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit2
#define	_CS11                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit1
#define	_CS10                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit0
#define	_FOC1A                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit7
#define	_FOC1B                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit6
#define	_FOC1C                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit5

//
// TIMER_COUNTER_2 variable definitions
//
// Waveform Generation Mode - WGM2_WGM_ENUM - [bit aggregate (TCCR2A.WGM20 | TCCR2A.WGM21 | TCCR2B.WGM22)] Controls how the counter will cycle.
typedef enum
{
	WGM2_WGM_Normal,                    	// Normal
	WGM2_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM2_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM2_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM2_WGM_Reserved,                  	// Reserved
	WGM2_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM2_WGM_Reserved2,                 	// Reserved
	WGM2_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM2_WGM_ENUM;
#define	_WGM20                  ((volatile BYTE_STRUCT*)&TCCR2A)->bit0
#define	_WGM21                  ((volatile BYTE_STRUCT*)&TCCR2A)->bit1
#define	_WGM22                  ((volatile BYTE_STRUCT*)&TCCR2B)->bit3
inline WGM2_WGM_ENUM get_WGM2(){ return (WGM2_WGM_ENUM)(_WGM20|(_WGM21 << 1)|(_WGM22 << 2)); }
inline void set_WGM2(WGM2_WGM_ENUM v){ _WGM20 = v; _WGM21 = v >> 1; _WGM22 = v >> 2; }
// Clock Select - CS2_CS_ENUM - [bit field "CS2" TCCR2B.(CS20 | CS21 | CS22)] Selects the clock divisor.
typedef enum
{
	CS2_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS2_CS_DIV_1,                       	// clk (No prescaling)
	CS2_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS2_CS_DIV_32,                      	// clk / 32 (From prescaler)
	CS2_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS2_CS_DIV_128,                     	// clk / 128 (From prescaler)
	CS2_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS2_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
} CS2_CS_ENUM;

typedef struct
{
	unsigned char	__CS2             : 3;
} CS2_STRUCT;

#define	_CS2                    ((volatile CS2_STRUCT*)&TCCR2B)->__CS2
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK2.TOIE2]
#define	_TOIE2                  ((volatile BYTE_STRUCT*)&TIMSK2)->bit0
// Compare Output Mode A - _ENUM - [bit field "COMA2" TCCR2A.(COM2A0 | COM2A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA2           : 2;
} COMA2_STRUCT;

#define	_COMA2                  ((volatile COMA2_STRUCT*)&TCCR2A)->__COMA2
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK2.OCIE2A]
#define	_OCIE2A                 ((volatile BYTE_STRUCT*)&TIMSK2)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB2" TCCR2A.(COM2B0 | COM2B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB2           : 2;
} COMB2_STRUCT;

#define	_COMB2                  ((volatile COMB2_STRUCT*)&TCCR2A)->__COMB2
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK2.OCIE2B]
#define	_OCIE2B                 ((volatile BYTE_STRUCT*)&TIMSK2)->bit2

// other TIMER_COUNTER_2 bit definitions
#define	_OCF2B                  ((volatile BYTE_STRUCT*)&TIFR2)->bit2
#define	_OCF2A                  ((volatile BYTE_STRUCT*)&TIFR2)->bit1
#define	_TOV2                   ((volatile BYTE_STRUCT*)&TIFR2)->bit0
#define	_COM2A1                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit7
#define	_COM2A0                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit6
#define	_COM2B1                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit5
#define	_COM2B0                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit4
#define	_FOC2A                  ((volatile BYTE_STRUCT*)&TCCR2B)->bit7
#define	_FOC2B                  ((volatile BYTE_STRUCT*)&TCCR2B)->bit6
#define	_CS22                   ((volatile BYTE_STRUCT*)&TCCR2B)->bit2
#define	_CS21                   ((volatile BYTE_STRUCT*)&TCCR2B)->bit1
#define	_CS20                   ((volatile BYTE_STRUCT*)&TCCR2B)->bit0
#define	_EXCLK                  ((volatile BYTE_STRUCT*)&ASSR)->bit6
#define	_AS2                    ((volatile BYTE_STRUCT*)&ASSR)->bit5
#define	_TCN2UB                 ((volatile BYTE_STRUCT*)&ASSR)->bit4
#define	_OCR2AUB                ((volatile BYTE_STRUCT*)&ASSR)->bit3
#define	_OCR2BUB                ((volatile BYTE_STRUCT*)&ASSR)->bit2
#define	_TCR2AUB                ((volatile BYTE_STRUCT*)&ASSR)->bit1
#define	_TCR2BUB                ((volatile BYTE_STRUCT*)&ASSR)->bit0
#define	_PSRASY                 ((volatile BYTE_STRUCT*)&GTCCR)->bit1

//
// TIMER_COUNTER_3 variable definitions
//
// Waveform Generation Mode - WGM3_WGM_ENUM - [bit aggregate (TCCR3A.WGM30 | TCCR3A.WGM31 | TCCR3B.WGM32 | TCCR3B.WGM33)] Controls how the counter will cycle.
typedef enum
{
	WGM3_WGM_Normal,                    	// Normal
	WGM3_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM3_WGM_PWMPhaseCorrect9bit,       	// PWM Phase Correct, 9-bit TOP=0x1FF
	WGM3_WGM_PWMPhaseCorrect10bit,      	// PWM Phase Correct, 10-bit TOP=0x3FF
	WGM3_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM3_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM3_WGM_FastPWM9bit,               	// Fast PWM, 9-bit TOP=0x1FF
	WGM3_WGM_FastPWM10bit,              	// Fast PWM, 10-bit TOP=0x3FF
	WGM3_WGM_PWMPhaseFreqCorrect_ICR,   	// PWM Phase and Freq Correct, TOP=ICR
	WGM3_WGM_PWMPhaseFreqCorrect_OCR,   	// PWM Phase and Freq Correct, TOP=OCRA
	WGM3_WGM_PWMPhaseCorrect_ICR,       	// PWM Phase Correct, TOP=ICR
	WGM3_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM3_WGM_CTC_ICR,                   	// Clear Timer on Compare Match TOP=ICR
	WGM3_WGM_Reserved,                  	// Reserved
	WGM3_WGM_FastPWM_ICR,               	// Fast PWM TOP=ICR
	WGM3_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM3_WGM_ENUM;
#define	_WGM30                  ((volatile BYTE_STRUCT*)&TCCR3A)->bit0
#define	_WGM31                  ((volatile BYTE_STRUCT*)&TCCR3A)->bit1
#define	_WGM32                  ((volatile BYTE_STRUCT*)&TCCR3B)->bit3
#define	_WGM33                  ((volatile BYTE_STRUCT*)&TCCR3B)->bit4
inline WGM3_WGM_ENUM get_WGM3(){ return (WGM3_WGM_ENUM)(_WGM30|(_WGM31 << 1)|(_WGM32 << 2)|(_WGM33 << 3)); }
inline void set_WGM3(WGM3_WGM_ENUM v){ _WGM30 = v; _WGM31 = v >> 1; _WGM32 = v >> 2; _WGM33 = v >> 3; }
// Clock Select - CS3_CS_ENUM - [bit field "CS3" TCCR3B.(CS30 | CS31 | CS32)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS3_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS3_CS_DIV_1,                       	// clk (No prescaling)
	CS3_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS3_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS3_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS3_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS3_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS3_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS3_CS_ENUM;

typedef struct
{
	unsigned char	__CS3             : 3;
} CS3_STRUCT;

#define	_CS3                    ((volatile CS3_STRUCT*)&TCCR3B)->__CS3
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK3.TOIE3]
#define	_TOIE3                  ((volatile BYTE_STRUCT*)&TIMSK3)->bit0
// Input Capture Noise Cancel - Enabling_ENUM - [bit TCCR3B.ICNC3]
#define	_ICNC3                  ((volatile BYTE_STRUCT*)&TCCR3B)->bit7
// Input Capture Edge Select - Trigger_ENUM - [bit TCCR3B.ICES3]
#define	_ICES3                  ((volatile BYTE_STRUCT*)&TCCR3B)->bit6
// Input Capture Interrupt Enable - Enabling_ENUM - [bit TIMSK3.ICIE3]
#define	_ICIE3                  ((volatile BYTE_STRUCT*)&TIMSK3)->bit5
// Compare Output Mode A - _ENUM - [bit field "COMA3" TCCR3A.(COM3A0 | COM3A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA3           : 2;
} COMA3_STRUCT;

#define	_COMA3                  ((volatile COMA3_STRUCT*)&TCCR3A)->__COMA3
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK3.OCIE3A]
#define	_OCIE3A                 ((volatile BYTE_STRUCT*)&TIMSK3)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB3" TCCR3A.(COM3B0 | COM3B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB3           : 2;
} COMB3_STRUCT;

#define	_COMB3                  ((volatile COMB3_STRUCT*)&TCCR3A)->__COMB3
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK3.OCIE3B]
#define	_OCIE3B                 ((volatile BYTE_STRUCT*)&TIMSK3)->bit2
// Compare Output Mode C - _ENUM - [bit field "COMC3" TCCR3A.(COM3C0 | COM3C1)] Controls the Output Compare pin (OCnC) behavior.

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__COMC3           : 2;
} COMC3_STRUCT;

#define	_COMC3                  ((volatile COMC3_STRUCT*)&TCCR3A)->__COMC3
// Output Compare Match Interrupt Enable C - Enabling_ENUM - [bit TIMSK3.OCIE3C]
#define	_OCIE3C                 ((volatile BYTE_STRUCT*)&TIMSK3)->bit3

// other TIMER_COUNTER_3 bit definitions
#define	_ICF3                   ((volatile BYTE_STRUCT*)&TIFR3)->bit5
#define	_OCF3C                  ((volatile BYTE_STRUCT*)&TIFR3)->bit3
#define	_OCF3B                  ((volatile BYTE_STRUCT*)&TIFR3)->bit2
#define	_OCF3A                  ((volatile BYTE_STRUCT*)&TIFR3)->bit1
#define	_TOV3                   ((volatile BYTE_STRUCT*)&TIFR3)->bit0
#define	_COM3A1                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit7
#define	_COM3A0                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit6
#define	_COM3B1                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit5
#define	_COM3B0                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit4
#define	_COM3C1                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit3
#define	_COM3C0                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit2
#define	_CS32                   ((volatile BYTE_STRUCT*)&TCCR3B)->bit2
#define	_CS31                   ((volatile BYTE_STRUCT*)&TCCR3B)->bit1
#define	_CS30                   ((volatile BYTE_STRUCT*)&TCCR3B)->bit0
#define	_FOC3A                  ((volatile BYTE_STRUCT*)&TCCR3C)->bit7
#define	_FOC3B                  ((volatile BYTE_STRUCT*)&TCCR3C)->bit6
#define	_FOC3C                  ((volatile BYTE_STRUCT*)&TCCR3C)->bit5

//
// TWI variable definitions
//
// TWI Enable - Enabling_ENUM - [bit TWCR.TWEN] Enables TWI operation and activates the TWI interface.
#define	_TWEN                   ((volatile BYTE_STRUCT*)&TWCR)->bit2
// Bit Rate Prescaler - Prescaler_ENUM - [bit field "TWPS" TWSR.(TWPS0 | TWPS1)] Selects the prescaler division factor for the divider which generates the SCL clock frequency in the Master modes.

typedef struct
{
	unsigned char	__TWPS            : 2;
} TWPS_STRUCT;

#define	_TWPS                   ((volatile TWPS_STRUCT*)&TWSR)->__TWPS
// Address Register - _ENUM - [bit field "TWAR" TWAR.(TWA0 | TWA1 | TWA2 | TWA3 | TWA4 | TWA5 | TWA6)] Address to which the TWI will respond.

typedef struct
{
	unsigned char	__Reserved        : 1;
	unsigned char	__TWAR            : 7;
} TWAR_STRUCT;

#define	_TWAR                   ((volatile TWAR_STRUCT*)&TWAR)->__TWAR
// Address Mask Register - _ENUM - [bit field "TWAM" TWAMR.(TWAM0 | TWAM1 | TWAM2 | TWAM3 | TWAM4 | TWAM5 | TWAM6)] Each bit masks (disables) the corresponding bit in the Address Register. If the mask bit is set to one then the address match logic ignores the compare between the incoming address bit and the corresponding bit in the Address Register.

typedef struct
{
	unsigned char	__Reserved        : 1;
	unsigned char	__TWAM            : 7;
} TWAM_STRUCT;

#define	_TWAM                   ((volatile TWAM_STRUCT*)&TWAMR)->__TWAM
// General Call Recognition Enable - Enabling_ENUM - [bit TWAR.TWGCE] Enables the recognition of a General Call.
#define	_TWGCE                  ((volatile BYTE_STRUCT*)&TWAR)->bit0
// Enable Acknowledge - Enabling_ENUM - [bit TWCR.TWEA] Controls the generation of the acknowledge pulse.
#define	_TWEA                   ((volatile BYTE_STRUCT*)&TWCR)->bit6
// Interrupt Enable - Enabling_ENUM - [bit TWCR.TWIE] Enables the TWI interrupt.
#define	_TWIE                   ((volatile BYTE_STRUCT*)&TWCR)->bit0

// other TWI bit definitions
#define	_TWAM6                  ((volatile BYTE_STRUCT*)&TWAMR)->bit7
#define	_TWAM5                  ((volatile BYTE_STRUCT*)&TWAMR)->bit6
#define	_TWAM4                  ((volatile BYTE_STRUCT*)&TWAMR)->bit5
#define	_TWAM3                  ((volatile BYTE_STRUCT*)&TWAMR)->bit4
#define	_TWAM2                  ((volatile BYTE_STRUCT*)&TWAMR)->bit3
#define	_TWAM1                  ((volatile BYTE_STRUCT*)&TWAMR)->bit2
#define	_TWAM0                  ((volatile BYTE_STRUCT*)&TWAMR)->bit1
#define	_TWINT                  ((volatile BYTE_STRUCT*)&TWCR)->bit7
#define	_TWSTA                  ((volatile BYTE_STRUCT*)&TWCR)->bit5
#define	_TWSTO                  ((volatile BYTE_STRUCT*)&TWCR)->bit4
#define	_TWWC                   ((volatile BYTE_STRUCT*)&TWCR)->bit3
#define	_TWS7                   ((volatile BYTE_STRUCT*)&TWSR)->bit7
#define	_TWS6                   ((volatile BYTE_STRUCT*)&TWSR)->bit6
#define	_TWS5                   ((volatile BYTE_STRUCT*)&TWSR)->bit5
#define	_TWS4                   ((volatile BYTE_STRUCT*)&TWSR)->bit4
#define	_TWS3                   ((volatile BYTE_STRUCT*)&TWSR)->bit3
#define	_TWPS1                  ((volatile BYTE_STRUCT*)&TWSR)->bit1
#define	_TWPS0                  ((volatile BYTE_STRUCT*)&TWSR)->bit0
#define	_TWA6                   ((volatile BYTE_STRUCT*)&TWAR)->bit7
#define	_TWA5                   ((volatile BYTE_STRUCT*)&TWAR)->bit6
#define	_TWA4                   ((volatile BYTE_STRUCT*)&TWAR)->bit5
#define	_TWA3                   ((volatile BYTE_STRUCT*)&TWAR)->bit4
#define	_TWA2                   ((volatile BYTE_STRUCT*)&TWAR)->bit3
#define	_TWA1                   ((volatile BYTE_STRUCT*)&TWAR)->bit2
#define	_TWA0                   ((volatile BYTE_STRUCT*)&TWAR)->bit1

//
// USART1 variable definitions
//
// Receiver Enable - Enabling_ENUM - [bit UCSR1B.RXEN1]
#define	_RXEN1                  ((volatile BYTE_STRUCT*)&UCSR1B)->bit4
// Transmitter Enable - Enabling_ENUM - [bit UCSR1B.TXEN1]
#define	_TXEN1                  ((volatile BYTE_STRUCT*)&UCSR1B)->bit3
// Mode Select - UsartModeSelect_ENUM - [bit field "UMSEL1" UCSR1C.(UMSEL10 | UMSEL11)] Select between Asynchronous and Synchronous mode of operation.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__UMSEL1          : 2;
} UMSEL1_STRUCT;

#define	_UMSEL1                 ((volatile UMSEL1_STRUCT*)&UCSR1C)->__UMSEL1
// Double Transmission Speed - Enabling_ENUM - [bit UCSR1A.U2X1]
#define	_U2X1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit1
// Character Size - UsartCharacterSize_ENUM - [bit aggregate (UCSR1C.UCSZ10 | UCSR1C.UCSZ11 | UCSR1B.UCSZ12)] Set the number of data bits in a frame the Receiver and Transmitter use.
#define	_UCSZ10                 ((volatile BYTE_STRUCT*)&UCSR1C)->bit1
#define	_UCSZ11                 ((volatile BYTE_STRUCT*)&UCSR1C)->bit2
#define	_UCSZ12                 ((volatile BYTE_STRUCT*)&UCSR1B)->bit2
inline UsartCharacterSize_ENUM get_UCSZ1(){ return (UsartCharacterSize_ENUM)(_UCSZ10|(_UCSZ11 << 1)|(_UCSZ12 << 2)); }
inline void set_UCSZ1(UsartCharacterSize_ENUM v){ _UCSZ10 = v; _UCSZ11 = v >> 1; _UCSZ12 = v >> 2; }
// Stop Bit Select - UsartStopBitSelect_ENUM - [bit UCSR1C.USBS1] Selects the number of Stop Bits to be inserted by the Transmitter. The Receiver ignores this setting.
#define	_USBS1                  ((volatile BYTE_STRUCT*)&UCSR1C)->bit3
// Parity Mode - UsartParityMode_ENUM - [bit field "UPM1" UCSR1C.(UPM10 | UPM11)] Enable and set type of parity generation and check.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__UPM1            : 2;
} UPM1_STRUCT;

#define	_UPM1                   ((volatile UPM1_STRUCT*)&UCSR1C)->__UPM1
// Clock Polarity - UsartClockPolarity_ENUM - [bit UCSR1C.UCPOL1] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
#define	_UCPOL1                 ((volatile BYTE_STRUCT*)&UCSR1C)->bit0
// Multi-processor Communication Mode - Enabling_ENUM - [bit UCSR1A.MPCM1]
#define	_MPCM1                  ((volatile BYTE_STRUCT*)&UCSR1A)->bit0
// RX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR1B.RXCIE1]
#define	_RXCIE1                 ((volatile BYTE_STRUCT*)&UCSR1B)->bit7
// Data Order - SPIDataOrder_ENUM - [bit UCSR1C.UCSZ11] Sets the order in which bits are transmitted.
// SPI Mode - SPIMode_ENUM - [bit aggregate (UCSR1C.UCSZ10 | UCSR1C.UCPOL1)] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
inline SPIMode_ENUM get_SPIMODE1(){ return (SPIMode_ENUM)(_UCSZ10|(_UCPOL1 << 1)); }
inline void set_SPIMODE1(SPIMode_ENUM v){ _UCSZ10 = v; _UCPOL1 = v >> 1; }
// TX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR1B.TXCIE1]
#define	_TXCIE1                 ((volatile BYTE_STRUCT*)&UCSR1B)->bit6
// Data Register Empty Interrupt Enable - Enabling_ENUM - [bit UCSR1B.UDRIE1] Enable an interrupt when the transmit buffer (UDR) is ready to receive new data.
#define	_UDRIE1                 ((volatile BYTE_STRUCT*)&UCSR1B)->bit5

// other USART1 bit definitions
#define	_RXC1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit7
#define	_TXC1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit6
#define	_UDRE1                  ((volatile BYTE_STRUCT*)&UCSR1A)->bit5
#define	_FE1                    ((volatile BYTE_STRUCT*)&UCSR1A)->bit4
#define	_DOR1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit3
#define	_UPE1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit2
#define	_RXB81                  ((volatile BYTE_STRUCT*)&UCSR1B)->bit1
#define	_TXB81                  ((volatile BYTE_STRUCT*)&UCSR1B)->bit0
#define	_UMSEL11                ((volatile BYTE_STRUCT*)&UCSR1C)->bit7
#define	_UMSEL10                ((volatile BYTE_STRUCT*)&UCSR1C)->bit6
#define	_UPM11                  ((volatile BYTE_STRUCT*)&UCSR1C)->bit5
#define	_UPM10                  ((volatile BYTE_STRUCT*)&UCSR1C)->bit4

//
// USB_DEVICE variable definitions
//
#define	_LSM                    ((volatile BYTE_STRUCT*)&UDCON)->bit2
#define	_RMWKUP                 ((volatile BYTE_STRUCT*)&UDCON)->bit1
#define	_DETACH                 ((volatile BYTE_STRUCT*)&UDCON)->bit0
#define	_UPRSMI                 ((volatile BYTE_STRUCT*)&UDINT)->bit6
#define	_EORSMI                 ((volatile BYTE_STRUCT*)&UDINT)->bit5
#define	_WAKEUPI                ((volatile BYTE_STRUCT*)&UDINT)->bit4
#define	_EORSTI                 ((volatile BYTE_STRUCT*)&UDINT)->bit3
#define	_SOFI                   ((volatile BYTE_STRUCT*)&UDINT)->bit2
#define	_SUSPI                  ((volatile BYTE_STRUCT*)&UDINT)->bit0
#define	_UPRSME                 ((volatile BYTE_STRUCT*)&UDIEN)->bit6
#define	_EORSME                 ((volatile BYTE_STRUCT*)&UDIEN)->bit5
#define	_WAKEUPE                ((volatile BYTE_STRUCT*)&UDIEN)->bit4
#define	_EORSTE                 ((volatile BYTE_STRUCT*)&UDIEN)->bit3
#define	_SOFE                   ((volatile BYTE_STRUCT*)&UDIEN)->bit2
#define	_SUSPE                  ((volatile BYTE_STRUCT*)&UDIEN)->bit0
#define	_ADDEN                  ((volatile BYTE_STRUCT*)&UDADDR)->bit7
#define	_UADD6                  ((volatile BYTE_STRUCT*)&UDADDR)->bit6
#define	_UADD5                  ((volatile BYTE_STRUCT*)&UDADDR)->bit5
#define	_UADD4                  ((volatile BYTE_STRUCT*)&UDADDR)->bit4
#define	_UADD3                  ((volatile BYTE_STRUCT*)&UDADDR)->bit3
#define	_UADD2                  ((volatile BYTE_STRUCT*)&UDADDR)->bit2
#define	_UADD1                  ((volatile BYTE_STRUCT*)&UDADDR)->bit1
#define	_UADD0                  ((volatile BYTE_STRUCT*)&UDADDR)->bit0
#define	_FNCERR                 ((volatile BYTE_STRUCT*)&UDMFN)->bit4
#define	_FIFOCON_UEINTX         ((volatile BYTE_STRUCT*)&UEINTX)->bit7
#define	_NAKINI                 ((volatile BYTE_STRUCT*)&UEINTX)->bit6
#define	_RWAL_UEINTX            ((volatile BYTE_STRUCT*)&UEINTX)->bit5
#define	_NAKOUTI                ((volatile BYTE_STRUCT*)&UEINTX)->bit4
#define	_RXSTPI                 ((volatile BYTE_STRUCT*)&UEINTX)->bit3
#define	_RXOUTI                 ((volatile BYTE_STRUCT*)&UEINTX)->bit2
#define	_STALLEDI               ((volatile BYTE_STRUCT*)&UEINTX)->bit1
#define	_TXINI                  ((volatile BYTE_STRUCT*)&UEINTX)->bit0
#define	_STALLRQ                ((volatile BYTE_STRUCT*)&UECONX)->bit5
#define	_STALLRQC               ((volatile BYTE_STRUCT*)&UECONX)->bit4
#define	_RSTDT_UECONX           ((volatile BYTE_STRUCT*)&UECONX)->bit3
#define	_EPEN                   ((volatile BYTE_STRUCT*)&UECONX)->bit0
#define	_EPTYPE1                ((volatile BYTE_STRUCT*)&UECFG0X)->bit7
#define	_EPTYPE0                ((volatile BYTE_STRUCT*)&UECFG0X)->bit6
#define	_EPDIR                  ((volatile BYTE_STRUCT*)&UECFG0X)->bit0
#define	_EPSIZE2                ((volatile BYTE_STRUCT*)&UECFG1X)->bit6
#define	_EPSIZE1                ((volatile BYTE_STRUCT*)&UECFG1X)->bit5
#define	_EPSIZE0                ((volatile BYTE_STRUCT*)&UECFG1X)->bit4
#define	_EPBK1                  ((volatile BYTE_STRUCT*)&UECFG1X)->bit3
#define	_EPBK0                  ((volatile BYTE_STRUCT*)&UECFG1X)->bit2
#define	_ALLOC_UECFG1X          ((volatile BYTE_STRUCT*)&UECFG1X)->bit1
#define	_CFGOK_UESTA0X          ((volatile BYTE_STRUCT*)&UESTA0X)->bit7
#define	_OVERFI_UESTA0X         ((volatile BYTE_STRUCT*)&UESTA0X)->bit6
#define	_UNDERFI_UESTA0X        ((volatile BYTE_STRUCT*)&UESTA0X)->bit5
#define	_DTSEQ1_UESTA0X         ((volatile BYTE_STRUCT*)&UESTA0X)->bit3
#define	_DTSEQ0_UESTA0X         ((volatile BYTE_STRUCT*)&UESTA0X)->bit2
#define	_NBUSYBK1               ((volatile BYTE_STRUCT*)&UESTA0X)->bit1
#define	_NBUSYBK0               ((volatile BYTE_STRUCT*)&UESTA0X)->bit0
#define	_CTRLDIR                ((volatile BYTE_STRUCT*)&UESTA1X)->bit2
#define	_CURRBK1                ((volatile BYTE_STRUCT*)&UESTA1X)->bit1
#define	_CURRBK0                ((volatile BYTE_STRUCT*)&UESTA1X)->bit0
#define	_FLERRE_UEIENX          ((volatile BYTE_STRUCT*)&UEIENX)->bit7
#define	_NAKINE                 ((volatile BYTE_STRUCT*)&UEIENX)->bit6
#define	_NAKOUTE                ((volatile BYTE_STRUCT*)&UEIENX)->bit4
#define	_RXSTPE                 ((volatile BYTE_STRUCT*)&UEIENX)->bit3
#define	_RXOUTE                 ((volatile BYTE_STRUCT*)&UEIENX)->bit2
#define	_STALLEDE               ((volatile BYTE_STRUCT*)&UEIENX)->bit1
#define	_TXINE                  ((volatile BYTE_STRUCT*)&UEIENX)->bit0

//
// USB_GLOBAL variable definitions
//
#define	_UIMOD                  ((volatile BYTE_STRUCT*)&UHWCON)->bit7
#define	_UIDE                   ((volatile BYTE_STRUCT*)&UHWCON)->bit6
#define	_UVCONE                 ((volatile BYTE_STRUCT*)&UHWCON)->bit4
#define	_UVREGE                 ((volatile BYTE_STRUCT*)&UHWCON)->bit0
#define	_USBE                   ((volatile BYTE_STRUCT*)&USBCON)->bit7
#define	_HOST                   ((volatile BYTE_STRUCT*)&USBCON)->bit6
#define	_FRZCLK                 ((volatile BYTE_STRUCT*)&USBCON)->bit5
#define	_OTGPADE                ((volatile BYTE_STRUCT*)&USBCON)->bit4
#define	_IDTE                   ((volatile BYTE_STRUCT*)&USBCON)->bit1
#define	_VBUSTE                 ((volatile BYTE_STRUCT*)&USBCON)->bit0
#define	_SPEED                  ((volatile BYTE_STRUCT*)&USBSTA)->bit3
#define	_ID                     ((volatile BYTE_STRUCT*)&USBSTA)->bit1
#define	_VBUS                   ((volatile BYTE_STRUCT*)&USBSTA)->bit0
#define	_IDTI                   ((volatile BYTE_STRUCT*)&USBINT)->bit1
#define	_VBUSTI                 ((volatile BYTE_STRUCT*)&USBINT)->bit0
#define	_OTGTCON_7              ((volatile BYTE_STRUCT*)&OTGTCON)->bit7
#define	_PAGE1                  ((volatile BYTE_STRUCT*)&OTGTCON)->bit6
#define	_PAGE0                  ((volatile BYTE_STRUCT*)&OTGTCON)->bit5
#define	_VALUE_22               ((volatile BYTE_STRUCT*)&OTGTCON)->bit2
#define	_VALUE_21               ((volatile BYTE_STRUCT*)&OTGTCON)->bit1
#define	_VALUE_20               ((volatile BYTE_STRUCT*)&OTGTCON)->bit0
#define	_HNPREQ                 ((volatile BYTE_STRUCT*)&OTGCON)->bit5
#define	_SRPREQ                 ((volatile BYTE_STRUCT*)&OTGCON)->bit4
#define	_SRPSEL                 ((volatile BYTE_STRUCT*)&OTGCON)->bit3
#define	_VBUSHWC                ((volatile BYTE_STRUCT*)&OTGCON)->bit2
#define	_VBUSREQ                ((volatile BYTE_STRUCT*)&OTGCON)->bit1
#define	_VBUSRQC                ((volatile BYTE_STRUCT*)&OTGCON)->bit0
#define	_STOE                   ((volatile BYTE_STRUCT*)&OTGIEN)->bit5
#define	_HNPERRE                ((volatile BYTE_STRUCT*)&OTGIEN)->bit4
#define	_ROLEEXE                ((volatile BYTE_STRUCT*)&OTGIEN)->bit3
#define	_BCERRE                 ((volatile BYTE_STRUCT*)&OTGIEN)->bit2
#define	_VBERRE                 ((volatile BYTE_STRUCT*)&OTGIEN)->bit1
#define	_SRPE                   ((volatile BYTE_STRUCT*)&OTGIEN)->bit0
#define	_STOI                   ((volatile BYTE_STRUCT*)&OTGINT)->bit5
#define	_HNPERRI                ((volatile BYTE_STRUCT*)&OTGINT)->bit4
#define	_ROLEEXI                ((volatile BYTE_STRUCT*)&OTGINT)->bit3
#define	_BCERRI                 ((volatile BYTE_STRUCT*)&OTGINT)->bit2
#define	_VBERRI                 ((volatile BYTE_STRUCT*)&OTGINT)->bit1
#define	_SRPI                   ((volatile BYTE_STRUCT*)&OTGINT)->bit0

//
// USB_HOST variable definitions
//
#define	_RESUME                 ((volatile BYTE_STRUCT*)&UHCON)->bit2
#define	_RESET                  ((volatile BYTE_STRUCT*)&UHCON)->bit1
#define	_SOFEN                  ((volatile BYTE_STRUCT*)&UHCON)->bit0
#define	_UHUPI                  ((volatile BYTE_STRUCT*)&UHINT)->bit6
#define	_HSOFI                  ((volatile BYTE_STRUCT*)&UHINT)->bit5
#define	_RXRSMI                 ((volatile BYTE_STRUCT*)&UHINT)->bit4
#define	_RSMEDI                 ((volatile BYTE_STRUCT*)&UHINT)->bit3
#define	_RSTI                   ((volatile BYTE_STRUCT*)&UHINT)->bit2
#define	_DDISCI                 ((volatile BYTE_STRUCT*)&UHINT)->bit1
#define	_DCONNI                 ((volatile BYTE_STRUCT*)&UHINT)->bit0
#define	_HWUPE                  ((volatile BYTE_STRUCT*)&UHIEN)->bit6
#define	_HSOFE                  ((volatile BYTE_STRUCT*)&UHIEN)->bit5
#define	_RXRSME                 ((volatile BYTE_STRUCT*)&UHIEN)->bit4
#define	_RSMEDE                 ((volatile BYTE_STRUCT*)&UHIEN)->bit3
#define	_RSTE                   ((volatile BYTE_STRUCT*)&UHIEN)->bit2
#define	_DDISCE                 ((volatile BYTE_STRUCT*)&UHIEN)->bit1
#define	_DCONNE                 ((volatile BYTE_STRUCT*)&UHIEN)->bit0
#define	_FIFOCON_UPINTX         ((volatile BYTE_STRUCT*)&UPINTX)->bit7
#define	_NAKEDI                 ((volatile BYTE_STRUCT*)&UPINTX)->bit6
#define	_RWAL_UPINTX            ((volatile BYTE_STRUCT*)&UPINTX)->bit5
#define	_PERRI                  ((volatile BYTE_STRUCT*)&UPINTX)->bit4
#define	_TXSTPI                 ((volatile BYTE_STRUCT*)&UPINTX)->bit3
#define	_TXOUTI                 ((volatile BYTE_STRUCT*)&UPINTX)->bit2
#define	_RXSTALLI               ((volatile BYTE_STRUCT*)&UPINTX)->bit1
#define	_RXINI                  ((volatile BYTE_STRUCT*)&UPINTX)->bit0
#define	_PFREEZE                ((volatile BYTE_STRUCT*)&UPCONX)->bit6
#define	_INMODE                 ((volatile BYTE_STRUCT*)&UPCONX)->bit5
#define	_RSTDT_UPCONX           ((volatile BYTE_STRUCT*)&UPCONX)->bit3
#define	_PEN                    ((volatile BYTE_STRUCT*)&UPCONX)->bit0
#define	_PTYPE1                 ((volatile BYTE_STRUCT*)&UPCFG0X)->bit7
#define	_PTYPE0                 ((volatile BYTE_STRUCT*)&UPCFG0X)->bit6
#define	_PTOKEN1                ((volatile BYTE_STRUCT*)&UPCFG0X)->bit5
#define	_PTOKEN0                ((volatile BYTE_STRUCT*)&UPCFG0X)->bit4
#define	_PEPNUM3                ((volatile BYTE_STRUCT*)&UPCFG0X)->bit3
#define	_PEPNUM2                ((volatile BYTE_STRUCT*)&UPCFG0X)->bit2
#define	_PEPNUM1                ((volatile BYTE_STRUCT*)&UPCFG0X)->bit1
#define	_PEPNUM0                ((volatile BYTE_STRUCT*)&UPCFG0X)->bit0
#define	_PSIZE2                 ((volatile BYTE_STRUCT*)&UPCFG1X)->bit6
#define	_PSIZE1                 ((volatile BYTE_STRUCT*)&UPCFG1X)->bit5
#define	_PSIZE0                 ((volatile BYTE_STRUCT*)&UPCFG1X)->bit4
#define	_PBK1                   ((volatile BYTE_STRUCT*)&UPCFG1X)->bit3
#define	_PBK0                   ((volatile BYTE_STRUCT*)&UPCFG1X)->bit2
#define	_ALLOC_UPCFG1X          ((volatile BYTE_STRUCT*)&UPCFG1X)->bit1
#define	_CFGOK_UPSTAX           ((volatile BYTE_STRUCT*)&UPSTAX)->bit7
#define	_OVERFI_UPSTAX          ((volatile BYTE_STRUCT*)&UPSTAX)->bit6
#define	_UNDERFI_UPSTAX         ((volatile BYTE_STRUCT*)&UPSTAX)->bit5
#define	_DTSEQ1_UPSTAX          ((volatile BYTE_STRUCT*)&UPSTAX)->bit3
#define	_DTSEQ0_UPSTAX          ((volatile BYTE_STRUCT*)&UPSTAX)->bit2
#define	_NBUSYK1                ((volatile BYTE_STRUCT*)&UPSTAX)->bit1
#define	_NBUSYK0                ((volatile BYTE_STRUCT*)&UPSTAX)->bit0
#define	_FLERRE_UPIENX          ((volatile BYTE_STRUCT*)&UPIENX)->bit7
#define	_NAKEDE                 ((volatile BYTE_STRUCT*)&UPIENX)->bit6
#define	_PERRE                  ((volatile BYTE_STRUCT*)&UPIENX)->bit4
#define	_TXSTPE                 ((volatile BYTE_STRUCT*)&UPIENX)->bit3
#define	_TXOUTE                 ((volatile BYTE_STRUCT*)&UPIENX)->bit2
#define	_RXSTALLE               ((volatile BYTE_STRUCT*)&UPIENX)->bit1
#define	_RXINE                  ((volatile BYTE_STRUCT*)&UPIENX)->bit0
#define	_COUNTER1               ((volatile BYTE_STRUCT*)&UPERRX)->bit6
#define	_COUNTER0               ((volatile BYTE_STRUCT*)&UPERRX)->bit5
#define	_CRC16                  ((volatile BYTE_STRUCT*)&UPERRX)->bit4
#define	_TIMEOUT                ((volatile BYTE_STRUCT*)&UPERRX)->bit3
#define	_PID                    ((volatile BYTE_STRUCT*)&UPERRX)->bit2
#define	_DATAPID                ((volatile BYTE_STRUCT*)&UPERRX)->bit1
#define	_DATATGL                ((volatile BYTE_STRUCT*)&UPERRX)->bit0

//
// WATCHDOG variable definitions
//
// Prescaler - WdtPrescale_ENUM - [bit aggregate (WDTCSR.WDP0 | WDTCSR.WDP1 | WDTCSR.WDP2 | WDTCSR.WDP3)] Sets the watchdog timeout period. Values are typical at 5v.
#define	_WDP0                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit0
#define	_WDP1                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit1
#define	_WDP2                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit2
#define	_WDP3                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit5
inline WdtPrescale_ENUM get_WDP(){ return (WdtPrescale_ENUM)(_WDP0|(_WDP1 << 1)|(_WDP2 << 2)|(_WDP3 << 3)); }
inline void set_WDP(WdtPrescale_ENUM v){ _WDP0 = v; _WDP1 = v >> 1; _WDP2 = v >> 2; _WDP3 = v >> 3; }
// Configuration - WdtMode_ENUM - [bit aggregate (WDTCSR.WDIE | WDTCSR.WDE)] Determines the action taken when a watchdog timeout occurs.
#define	_WDIE                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit6
#define	_WDE                    ((volatile BYTE_STRUCT*)&WDTCSR)->bit3
inline WdtMode_ENUM get_Mode(){ return (WdtMode_ENUM)(_WDIE|(_WDE << 1)); }
inline void set_Mode(WdtMode_ENUM v){ _WDIE = v; _WDE = v >> 1; }

// other WATCHDOG bit definitions
#define	_WDIF                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit7
#define	_WDCE                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit4

#define _AID_AT90USB1287_DEFINED_
#endif /* _AID_AT90USB1287_DEFINED_ */
