#ifndef _AID_ATmega3250_DEFINED_

typedef enum
{
	Disabling_Enabled,                  	// Enabled
	Disabling_Disabled,                 	// Disabled
} Disabling_ENUM;

typedef enum
{
	Enabling_Disabled,                  	// Disabled
	Enabling_Enabled,                   	// Enabled
} Enabling_ENUM;

typedef enum
{
	ACIntModeSelect_OutputToggle,       	// Comparator Interrupt on Output Toggle
	ACIntModeSelect_Reserved,           	// Reserved
	ACIntModeSelect_FallingOutputEdge,  	// Comparator Interrupt on Falling Output Edge
	ACIntModeSelect_RisingOutputEdge,   	// Comparator Interrupt on Rising Output Edge
} ACIntModeSelect_ENUM;

typedef enum
{
	ACBandgapSelect_NoBandgap,          	// Use AIN0 as positive input
	ACBandgapSelect_Bandgap,            	// Use fixed bandgap reference voltage as positive input
} ACBandgapSelect_ENUM;

typedef enum
{
	SenseA_LowLevel,                    	// Low Level Generates Interrupt
	SenseA_AnyChange,                   	// Any Change Generates Interrupt
	SenseA_FallingEdge,                 	// Falling Edge Generates Interrupt
	SenseA_RisingEdge,                  	// Rising Edge Generates Interrupt
} SenseA_ENUM;

typedef enum
{
	SPIMaster_Slave,                    	// Slave Mode
	SPIMaster_Master,                   	// Master Mode
} SPIMaster_ENUM;

typedef enum
{
	SPR_DIV_4,                          	// clk / 4
	SPR_DIV_16,                         	// clk / 16
	SPR_DIV_64,                         	// clk / 64
	SPR_DIV_128,                        	// clk / 128
	SPR_DIV_2,                          	// clk / 2
	SPR_DIV_8,                          	// clk / 8
	SPR_DIV_32,                         	// clk / 32
	SPR_DIV_64b,                        	// clk / 64
} SPR_ENUM;

typedef enum
{
	SPIMode_Mode0,                      	// 0 - Leading (Rising) Edge Sample, Trailing (Falling) Edge Setup
	SPIMode_Mode1,                      	// 1 - Leading (Rising) Edge Setup, Trailing (Falling) Edge Sample
	SPIMode_Mode2,                      	// 2 - Leading (Falling) Edge Sample, Trailing (Rising) Edge Setup
	SPIMode_Mode3,                      	// 3 - Leading (Falling) Edge Setup, Trailing (Rising) Edge Sample
} SPIMode_ENUM;

typedef enum
{
	SPIDataOrder_MSBFirst,              	// Most Significant Bit First
	SPIDataOrder_LSBFirst,              	// Least Significant Bit First
} SPIDataOrder_ENUM;

typedef enum
{
	Trigger_Falling,                    	// Falling Edge Trigger
	Trigger_Rising,                     	// Rising Edge Trigger
} Trigger_ENUM;

typedef enum
{
	UsartCharacterSize_FiveBits,        	// 5 bits
	UsartCharacterSize_SixBits,         	// 6 bits
	UsartCharacterSize_SevenBits,       	// 7 bits
	UsartCharacterSize_EightBits,       	// 8 bits
	UsartCharacterSize_Reserved,        	// Reserved
	UsartCharacterSize_Reserved2,       	// Reserved
	UsartCharacterSize_Reserved3,       	// Reserved
	UsartCharacterSize_NineBits,        	// 9 bits
} UsartCharacterSize_ENUM;

typedef enum
{
	UsartStopBitSelect_OneStopBit,      	// 1 stop bit
	UsartStopBitSelect_TwoStopBits,     	// 2 stop bits
} UsartStopBitSelect_ENUM;

typedef enum
{
	UsartParityMode_Disabled,           	// Disabled
	UsartParityMode_Reserved,           	// Reserved
	UsartParityMode_EvenParity,         	// Even Parity
	UsartParityMode_OddParity,          	// Odd Parity
} UsartParityMode_ENUM;

typedef enum
{
	UsartClockPolarity_Normal,          	// TX Changed on Rising Edge, RX Sampled on Falling Edge
	UsartClockPolarity_Inverted,        	// TX Changed on Falling Edge, RX Sampled on Rising Edge
} UsartClockPolarity_ENUM;

//
// AD_CONVERTER variable definitions
//
#define	_REFS1                  ((volatile BYTE_STRUCT*)&ADMUX)->bit7
#define	_REFS0                  ((volatile BYTE_STRUCT*)&ADMUX)->bit6
#define	_ADLAR                  ((volatile BYTE_STRUCT*)&ADMUX)->bit5
#define	_MUX4                   ((volatile BYTE_STRUCT*)&ADMUX)->bit4
#define	_MUX3                   ((volatile BYTE_STRUCT*)&ADMUX)->bit3
#define	_MUX2                   ((volatile BYTE_STRUCT*)&ADMUX)->bit2
#define	_MUX1                   ((volatile BYTE_STRUCT*)&ADMUX)->bit1
#define	_MUX0                   ((volatile BYTE_STRUCT*)&ADMUX)->bit0
#define	_ADEN                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit7
#define	_ADSC                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit6
#define	_ADATE                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit5
#define	_ADIF                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit4
#define	_ADIE                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit3
#define	_ADPS2                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit2
#define	_ADPS1                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit1
#define	_ADPS0                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit0
#define	_ADTS2                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit2
#define	_ADTS1                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit1
#define	_ADTS0                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit0
#define	_ADC7D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit7
#define	_ADC6D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit6
#define	_ADC5D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit5
#define	_ADC4D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit4
#define	_ADC3D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit3
#define	_ADC2D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit2
#define	_ADC1D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit1
#define	_ADC0D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit0

//
// ANALOG_COMPARATOR variable definitions
//
// Analog Comparator Disable - Disabling_ENUM - [bit ACSR.ACD] Disables the Analog Comparator.
#define	_ACD                    ((volatile BYTE_STRUCT*)&ACSR)->bit7
// Interrupt Enable - Enabling_ENUM - [bit ACSR.ACIE] When enabled and the I-bit in the Status Register is set, the Analog Comparator interrupt is activated.
#define	_ACIE                   ((volatile BYTE_STRUCT*)&ACSR)->bit3
// Interrupt Mode Select - ACIntModeSelect_ENUM - [bit field "ACIS" ACSR.(ACIS0 | ACIS1)] Determine which comparator events trigger the Analog Comparator interrupt.

typedef struct
{
	unsigned char	__ACIS            : 2;
} ACIS_STRUCT;

#define	_ACIS                   ((volatile ACIS_STRUCT*)&ACSR)->__ACIS
// Input Capture Enable - Enabling_ENUM - [bit ACSR.ACIC] Enables the input capture function in Timer/Counter1 to be triggered by the Analog Comparator.
#define	_ACIC                   ((volatile BYTE_STRUCT*)&ACSR)->bit2
// Bandgap Select - ACBandgapSelect_ENUM - [bit ACSR.ACBG] Selects a bandgap reference voltage as the positive input.
#define	_ACBG                   ((volatile BYTE_STRUCT*)&ACSR)->bit6
// Multiplexer Enable - Enabling_ENUM - [bit ADCSRB.ACME] When enabled and the ADC is switched off, the ADC multiplexer selects the negative input to the Analog Comparator. When disabled, AIN1 is applied to the negative input of the Analog Comparator.
#define	_ACME                   ((volatile BYTE_STRUCT*)&ADCSRB)->bit6
// Digital Input 0 Disable - Disabling_ENUM - [bit DIDR1.AIN0D] When disabled, the digital input buffer on the AIN0 pin is disabled.
#define	_AIN0D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit0
// Digital Input 1 Disable - Disabling_ENUM - [bit DIDR1.AIN1D] When disabled, the digital input buffer on the AIN1 pin is disabled.
#define	_AIN1D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit1

// other ANALOG_COMPARATOR bit definitions
#define	_ACO                    ((volatile BYTE_STRUCT*)&ACSR)->bit5
#define	_ACI                    ((volatile BYTE_STRUCT*)&ACSR)->bit4
#define	_ACIS1                  ((volatile BYTE_STRUCT*)&ACSR)->bit1
#define	_ACIS0                  ((volatile BYTE_STRUCT*)&ACSR)->bit0

//
// BOOT_LOAD variable definitions
//
#define	_SPMIE                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit7
#define	_RWWSB                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit6
#define	_RWWSRE                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit4
#define	_BLBSET                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit3
#define	_PGWRT                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit2
#define	_PGERS                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit1
#define	_SPMEN                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit0

//
// CPU variable definitions
//
#define	_PUD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit4
#define	_IVSEL                  ((volatile BYTE_STRUCT*)&MCUCR)->bit1
#define	_IVCE                   ((volatile BYTE_STRUCT*)&MCUCR)->bit0
#define	_JTRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit4
#define	_WDRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit3
#define	_BORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit2
#define	_EXTRF                  ((volatile BYTE_STRUCT*)&MCUSR)->bit1
#define	_PORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit0
#define	_CLKPCE                 ((volatile BYTE_STRUCT*)&CLKPR)->bit7
#define	_CLKPS3                 ((volatile BYTE_STRUCT*)&CLKPR)->bit3
#define	_CLKPS2                 ((volatile BYTE_STRUCT*)&CLKPR)->bit2
#define	_CLKPS1                 ((volatile BYTE_STRUCT*)&CLKPR)->bit1
#define	_CLKPS0                 ((volatile BYTE_STRUCT*)&CLKPR)->bit0
#define	_PRLCD                  ((volatile BYTE_STRUCT*)&PRR)->bit4
#define	_PRTIM1                 ((volatile BYTE_STRUCT*)&PRR)->bit3
#define	_PRSPI                  ((volatile BYTE_STRUCT*)&PRR)->bit2
#define	_PRUSART0               ((volatile BYTE_STRUCT*)&PRR)->bit1
#define	_PRADC                  ((volatile BYTE_STRUCT*)&PRR)->bit0
#define	_SM2                    ((volatile BYTE_STRUCT*)&SMCR)->bit3
#define	_SM1                    ((volatile BYTE_STRUCT*)&SMCR)->bit2
#define	_SM0                    ((volatile BYTE_STRUCT*)&SMCR)->bit1
#define	_SE                     ((volatile BYTE_STRUCT*)&SMCR)->bit0

//
// EEPROM variable definitions
//
#define	_EERIE                  ((volatile BYTE_STRUCT*)&EECR)->bit3
#define	_EEMWE                  ((volatile BYTE_STRUCT*)&EECR)->bit2
#define	_EEWE                   ((volatile BYTE_STRUCT*)&EECR)->bit1
#define	_EERE                   ((volatile BYTE_STRUCT*)&EECR)->bit0

//
// EXTERNAL_INTERRUPT variable definitions
//
// INT0 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT0] Enables the interrupt on the INT pin
#define	_INT0                   ((volatile BYTE_STRUCT*)&EIMSK)->bit0
// INT0 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC0" EICRA.(ISC00 | ISC01)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__ISC0            : 2;
} ISC0_STRUCT;

#define	_ISC0                   ((volatile ISC0_STRUCT*)&EICRA)->__ISC0
// PCINT0 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT0] Enables interrupts on PCINT0
#define	_PCINT0                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit0
// PCINT1 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT1] Enables interrupts on PCINT1
#define	_PCINT1                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit1
// PCINT2 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT2] Enables interrupts on PCINT2
#define	_PCINT2                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit2
// PCINT3 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT3] Enables interrupts on PCINT3
#define	_PCINT3                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit3
// PCINT4 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT4] Enables interrupts on PCINT4
#define	_PCINT4                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit4
// PCINT5 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT5] Enables interrupts on PCINT5
#define	_PCINT5                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit5
// PCINT6 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT6] Enables interrupts on PCINT6
#define	_PCINT6                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit6
// PCINT7 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT7] Enables interrupts on PCINT7
#define	_PCINT7                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit7
// PCINT8 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT8] Enables interrupts on PCINT8
#define	_PCINT8                 ((volatile BYTE_STRUCT*)&PCMSK1)->bit0
// PCINT9 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT9] Enables interrupts on PCINT9
#define	_PCINT9                 ((volatile BYTE_STRUCT*)&PCMSK1)->bit1
// PCINT10 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT10] Enables interrupts on PCINT10
#define	_PCINT10                ((volatile BYTE_STRUCT*)&PCMSK1)->bit2
// PCINT11 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT11] Enables interrupts on PCINT11
#define	_PCINT11                ((volatile BYTE_STRUCT*)&PCMSK1)->bit3
// PCINT12 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT12] Enables interrupts on PCINT12
#define	_PCINT12                ((volatile BYTE_STRUCT*)&PCMSK1)->bit4
// PCINT13 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT13] Enables interrupts on PCINT13
#define	_PCINT13                ((volatile BYTE_STRUCT*)&PCMSK1)->bit5
// PCINT14 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT14] Enables interrupts on PCINT14
#define	_PCINT14                ((volatile BYTE_STRUCT*)&PCMSK1)->bit6
// PCINT15 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT15] Enables interrupts on PCINT15
#define	_PCINT15                ((volatile BYTE_STRUCT*)&PCMSK1)->bit7
// PCINT16 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT16] Enables interrupts on PCINT16
#define	_PCINT16                ((volatile BYTE_STRUCT*)&PCMSK2)->bit0
// PCINT17 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT17] Enables interrupts on PCINT17
#define	_PCINT17                ((volatile BYTE_STRUCT*)&PCMSK2)->bit1
// PCINT18 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT18] Enables interrupts on PCINT18
#define	_PCINT18                ((volatile BYTE_STRUCT*)&PCMSK2)->bit2
// PCINT19 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT19] Enables interrupts on PCINT19
#define	_PCINT19                ((volatile BYTE_STRUCT*)&PCMSK2)->bit3
// PCINT20 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT20] Enables interrupts on PCINT20
#define	_PCINT20                ((volatile BYTE_STRUCT*)&PCMSK2)->bit4
// PCINT21 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT21] Enables interrupts on PCINT21
#define	_PCINT21                ((volatile BYTE_STRUCT*)&PCMSK2)->bit5
// PCINT22 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT22] Enables interrupts on PCINT22
#define	_PCINT22                ((volatile BYTE_STRUCT*)&PCMSK2)->bit6
// PCINT23 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT23] Enables interrupts on PCINT23
#define	_PCINT23                ((volatile BYTE_STRUCT*)&PCMSK2)->bit7
// PCINT24 Interrupt Enable - Enabling_ENUM - [bit PCMSK3.PCINT24] Enables interrupts on PCINT24
#define	_PCINT24                ((volatile BYTE_STRUCT*)&PCMSK3)->bit0
// PCINT25 Interrupt Enable - Enabling_ENUM - [bit PCMSK3.PCINT25] Enables interrupts on PCINT25
#define	_PCINT25                ((volatile BYTE_STRUCT*)&PCMSK3)->bit1
// PCINT26 Interrupt Enable - Enabling_ENUM - [bit PCMSK3.PCINT26] Enables interrupts on PCINT26
#define	_PCINT26                ((volatile BYTE_STRUCT*)&PCMSK3)->bit2
// PCINT27 Interrupt Enable - Enabling_ENUM - [bit PCMSK3.PCINT27] Enables interrupts on PCINT27
#define	_PCINT27                ((volatile BYTE_STRUCT*)&PCMSK3)->bit3
// PCINT28 Interrupt Enable - Enabling_ENUM - [bit PCMSK3.PCINT28] Enables interrupts on PCINT28
#define	_PCINT28                ((volatile BYTE_STRUCT*)&PCMSK3)->bit4
// PCINT29 Interrupt Enable - Enabling_ENUM - [bit PCMSK3.PCINT29] Enables interrupts on PCINT29
#define	_PCINT29                ((volatile BYTE_STRUCT*)&PCMSK3)->bit5
// PCINT30 Interrupt Enable - Enabling_ENUM - [bit PCMSK3.PCINT30] Enables interrupts on PCINT30
#define	_PCINT30                ((volatile BYTE_STRUCT*)&PCMSK3)->bit6

// other EXTERNAL_INTERRUPT bit definitions
#define	_ISC01                  ((volatile BYTE_STRUCT*)&EICRA)->bit1
#define	_ISC00                  ((volatile BYTE_STRUCT*)&EICRA)->bit0
#define	_PCIE3                  ((volatile BYTE_STRUCT*)&EIMSK)->bit7
#define	_PCIE2                  ((volatile BYTE_STRUCT*)&EIMSK)->bit6
#define	_PCIE1                  ((volatile BYTE_STRUCT*)&EIMSK)->bit5
#define	_PCIE0                  ((volatile BYTE_STRUCT*)&EIMSK)->bit4
#define	_PCIF3                  ((volatile BYTE_STRUCT*)&EIFR)->bit7
#define	_PCIF2                  ((volatile BYTE_STRUCT*)&EIFR)->bit6
#define	_PCIF1                  ((volatile BYTE_STRUCT*)&EIFR)->bit5
#define	_PCIF0                  ((volatile BYTE_STRUCT*)&EIFR)->bit4
#define	_INTF0                  ((volatile BYTE_STRUCT*)&EIFR)->bit0

//
// JTAG variable definitions
//
// JTAG Disable - Disabling_ENUM - [bit MCUCR.JTD] Disables JTAG operation.
#define	_JTD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit7

// other JTAG bit definitions

//
// SPI variable definitions
//
// SPI Enable - Enabling_ENUM - [bit SPCR.SPE]
#define	_SPE                    ((volatile BYTE_STRUCT*)&SPCR)->bit6
// Master/Slave Mode - SPIMaster_ENUM - [bit SPCR.MSTR]
#define	_MSTR                   ((volatile BYTE_STRUCT*)&SPCR)->bit4
// Clock Rate Select - SPR_ENUM - [bit aggregate (SPCR.SPR0 | SPCR.SPR1 | SPSR.SPI2X)] Controls the SCK rate of the device configured as a Master.
#define	_SPR0                   ((volatile BYTE_STRUCT*)&SPCR)->bit0
#define	_SPR1                   ((volatile BYTE_STRUCT*)&SPCR)->bit1
#define	_SPI2X                  ((volatile BYTE_STRUCT*)&SPSR)->bit0
inline SPR_ENUM get_SPR(){ return (SPR_ENUM)(_SPR0|(_SPR1 << 1)|(_SPI2X << 2)); }
inline void set_SPR(SPR_ENUM v){ _SPR0 = v; _SPR1 = v >> 1; _SPI2X = v >> 2; }
// SPI Mode - SPIMode_ENUM - [bit field "MODE" SPCR.(CPHA | CPOL)] Sets the relationship between data output change and data input sample, and the synchronous clock (SCK).

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__MODE            : 2;
} MODE_STRUCT;

#define	_MODE                   ((volatile MODE_STRUCT*)&SPCR)->__MODE
// Data Order - SPIDataOrder_ENUM - [bit SPCR.DORD] Sets the order in which bits are transmitted.
#define	_DORD                   ((volatile BYTE_STRUCT*)&SPCR)->bit5
// SPI Interrupt Enable - Enabling_ENUM - [bit SPCR.SPIE]
#define	_SPIE                   ((volatile BYTE_STRUCT*)&SPCR)->bit7

// other SPI bit definitions
#define	_SPIF                   ((volatile BYTE_STRUCT*)&SPSR)->bit7
#define	_WCOL                   ((volatile BYTE_STRUCT*)&SPSR)->bit6
#define	_CPOL                   ((volatile BYTE_STRUCT*)&SPCR)->bit3
#define	_CPHA                   ((volatile BYTE_STRUCT*)&SPCR)->bit2

//
// TIMER_COUNTER_0 variable definitions
//
// Waveform Generation Mode - WGM0_WGM_ENUM - [bit aggregate (TCCR0A.WGM00 | TCCR0A.WGM01)] Controls how the counter will cycle.
typedef enum
{
	WGM0_WGM_Normal,                    	// Normal
	WGM0_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM0_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM0_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
} WGM0_WGM_ENUM;
#define	_WGM00                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit6
#define	_WGM01                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit3
inline WGM0_WGM_ENUM get_WGM0(){ return (WGM0_WGM_ENUM)(_WGM00|(_WGM01 << 1)); }
inline void set_WGM0(WGM0_WGM_ENUM v){ _WGM00 = v; _WGM01 = v >> 1; }
// Clock Select - CS0_CS_ENUM - [bit field "CS0" TCCR0A.(CS00 | CS01 | CS02)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS0_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS0_CS_DIV_1,                       	// clk (No prescaling)
	CS0_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS0_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS0_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS0_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS0_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS0_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS0_CS_ENUM;

typedef struct
{
	unsigned char	__CS0             : 3;
} CS0_STRUCT;

#define	_CS0                    ((volatile CS0_STRUCT*)&TCCR0A)->__CS0
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK0.TOIE0]
#define	_TOIE0                  ((volatile BYTE_STRUCT*)&TIMSK0)->bit0
// Compare Output Mode - _ENUM - [bit field "COMA0" TCCR0A.(COM0A0 | COM0A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMA0           : 2;
} COMA0_STRUCT;

#define	_COMA0                  ((volatile COMA0_STRUCT*)&TCCR0A)->__COMA0
// Output Compare Match Interrupt Enable - Enabling_ENUM - [bit TIMSK0.OCIE0A]
#define	_OCIE0A                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit1

// other TIMER_COUNTER_0 bit definitions
#define	_FOC0A                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit7
#define	_COM0A1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit5
#define	_COM0A0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit4
#define	_CS02                   ((volatile BYTE_STRUCT*)&TCCR0A)->bit2
#define	_CS01                   ((volatile BYTE_STRUCT*)&TCCR0A)->bit1
#define	_CS00                   ((volatile BYTE_STRUCT*)&TCCR0A)->bit0
#define	_OCF0A                  ((volatile BYTE_STRUCT*)&TIFR0)->bit1
#define	_TOV0                   ((volatile BYTE_STRUCT*)&TIFR0)->bit0
#define	_TSM                    ((volatile BYTE_STRUCT*)&GTCCR)->bit7
#define	_PSR310                 ((volatile BYTE_STRUCT*)&GTCCR)->bit0

//
// TIMER_COUNTER_1 variable definitions
//
// Waveform Generation Mode - WGM1_WGM_ENUM - [bit aggregate (TCCR1A.WGM10 | TCCR1A.WGM11 | TCCR1B.WGM12 | TCCR1B.WGM13)] Controls how the counter will cycle.
typedef enum
{
	WGM1_WGM_Normal,                    	// Normal
	WGM1_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM1_WGM_PWMPhaseCorrect9bit,       	// PWM Phase Correct, 9-bit TOP=0x1FF
	WGM1_WGM_PWMPhaseCorrect10bit,      	// PWM Phase Correct, 10-bit TOP=0x3FF
	WGM1_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM1_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM1_WGM_FastPWM9bit,               	// Fast PWM, 9-bit TOP=0x1FF
	WGM1_WGM_FastPWM10bit,              	// Fast PWM, 10-bit TOP=0x3FF
	WGM1_WGM_PWMPhaseFreqCorrect_ICR,   	// PWM Phase and Freq Correct, TOP=ICR
	WGM1_WGM_PWMPhaseFreqCorrect_OCR,   	// PWM Phase and Freq Correct, TOP=OCRA
	WGM1_WGM_PWMPhaseCorrect_ICR,       	// PWM Phase Correct, TOP=ICR
	WGM1_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM1_WGM_CTC_ICR,                   	// Clear Timer on Compare Match TOP=ICR
	WGM1_WGM_Reserved,                  	// Reserved
	WGM1_WGM_FastPWM_ICR,               	// Fast PWM TOP=ICR
	WGM1_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM1_WGM_ENUM;
#define	_WGM10                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit0
#define	_WGM11                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit1
#define	_WGM12                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit3
#define	_WGM13                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit4
inline WGM1_WGM_ENUM get_WGM1(){ return (WGM1_WGM_ENUM)(_WGM10|(_WGM11 << 1)|(_WGM12 << 2)|(_WGM13 << 3)); }
inline void set_WGM1(WGM1_WGM_ENUM v){ _WGM10 = v; _WGM11 = v >> 1; _WGM12 = v >> 2; _WGM13 = v >> 3; }
// Clock Select - CS1_CS_ENUM - [bit field "CS1" TCCR1B.(CS10 | CS11 | CS12)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS1_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS1_CS_DIV_1,                       	// clk (No prescaling)
	CS1_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS1_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS1_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS1_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS1_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS1_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS1_CS_ENUM;

typedef struct
{
	unsigned char	__CS1             : 3;
} CS1_STRUCT;

#define	_CS1                    ((volatile CS1_STRUCT*)&TCCR1B)->__CS1
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK1.TOIE1]
#define	_TOIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit0
// Input Capture Noise Cancel - Enabling_ENUM - [bit TCCR1B.ICNC1]
#define	_ICNC1                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit7
// Input Capture Edge Select - Trigger_ENUM - [bit TCCR1B.ICES1]
#define	_ICES1                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit6
// Input Capture Interrupt Enable - Enabling_ENUM - [bit TIMSK1.ICIE1]
#define	_ICIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit5
// Compare Output Mode A - _ENUM - [bit field "COMA1" TCCR1A.(COM1A0 | COM1A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA1           : 2;
} COMA1_STRUCT;

#define	_COMA1                  ((volatile COMA1_STRUCT*)&TCCR1A)->__COMA1
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK1.OCIE1A]
#define	_OCIE1A                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB1" TCCR1A.(COM1B0 | COM1B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB1           : 2;
} COMB1_STRUCT;

#define	_COMB1                  ((volatile COMB1_STRUCT*)&TCCR1A)->__COMB1
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK1.OCIE1B]
#define	_OCIE1B                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit2

// other TIMER_COUNTER_1 bit definitions
#define	_ICF1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit5
#define	_OCF1B                  ((volatile BYTE_STRUCT*)&TIFR1)->bit2
#define	_OCF1A                  ((volatile BYTE_STRUCT*)&TIFR1)->bit1
#define	_TOV1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit0
#define	_COM1A1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit7
#define	_COM1A0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit6
#define	_COM1B1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit5
#define	_COM1B0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit4
#define	_CS12                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit2
#define	_CS11                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit1
#define	_CS10                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit0
#define	_FOC1A                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit7
#define	_FOC1B                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit6

//
// TIMER_COUNTER_2 variable definitions
//
// Waveform Generation Mode - WGM2_WGM_ENUM - [bit aggregate (TCCR2A.WGM20 | TCCR2A.WGM21)] Controls how the counter will cycle.
typedef enum
{
	WGM2_WGM_Normal,                    	// Normal
	WGM2_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM2_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM2_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
} WGM2_WGM_ENUM;
#define	_WGM20                  ((volatile BYTE_STRUCT*)&TCCR2A)->bit6
#define	_WGM21                  ((volatile BYTE_STRUCT*)&TCCR2A)->bit3
inline WGM2_WGM_ENUM get_WGM2(){ return (WGM2_WGM_ENUM)(_WGM20|(_WGM21 << 1)); }
inline void set_WGM2(WGM2_WGM_ENUM v){ _WGM20 = v; _WGM21 = v >> 1; }
// Clock Select - CS2_CS_ENUM - [bit field "CS2" TCCR2A.(CS20 | CS21 | CS22)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS2_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS2_CS_DIV_1,                       	// clk (No prescaling)
	CS2_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS2_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS2_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS2_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS2_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS2_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS2_CS_ENUM;

typedef struct
{
	unsigned char	__CS2             : 3;
} CS2_STRUCT;

#define	_CS2                    ((volatile CS2_STRUCT*)&TCCR2A)->__CS2
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK2.TOIE2]
#define	_TOIE2                  ((volatile BYTE_STRUCT*)&TIMSK2)->bit0
// Compare Output Mode - _ENUM - [bit field "COMA2" TCCR2A.(COM2A0 | COM2A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMA2           : 2;
} COMA2_STRUCT;

#define	_COMA2                  ((volatile COMA2_STRUCT*)&TCCR2A)->__COMA2
// Output Compare Match Interrupt Enable - Enabling_ENUM - [bit TIMSK2.OCIE2A]
#define	_OCIE2A                 ((volatile BYTE_STRUCT*)&TIMSK2)->bit1

// other TIMER_COUNTER_2 bit definitions
#define	_OCF2A                  ((volatile BYTE_STRUCT*)&TIFR2)->bit1
#define	_TOV2                   ((volatile BYTE_STRUCT*)&TIFR2)->bit0
#define	_FOC2A                  ((volatile BYTE_STRUCT*)&TCCR2A)->bit7
#define	_COM2A1                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit5
#define	_COM2A0                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit4
#define	_CS22                   ((volatile BYTE_STRUCT*)&TCCR2A)->bit2
#define	_CS21                   ((volatile BYTE_STRUCT*)&TCCR2A)->bit1
#define	_CS20                   ((volatile BYTE_STRUCT*)&TCCR2A)->bit0
#define	_PSR2                   ((volatile BYTE_STRUCT*)&GTCCR)->bit1
#define	_EXCLK                  ((volatile BYTE_STRUCT*)&ASSR)->bit4
#define	_AS2                    ((volatile BYTE_STRUCT*)&ASSR)->bit3
#define	_TCN2UB                 ((volatile BYTE_STRUCT*)&ASSR)->bit2
#define	_OCR2UB                 ((volatile BYTE_STRUCT*)&ASSR)->bit1
#define	_TCR2UB                 ((volatile BYTE_STRUCT*)&ASSR)->bit0

//
// USART0 variable definitions
//
// Receiver Enable - Enabling_ENUM - [bit UCSR0B.RXEN0]
#define	_RXEN0                  ((volatile BYTE_STRUCT*)&UCSR0B)->bit4
// Transmitter Enable - Enabling_ENUM - [bit UCSR0B.TXEN0]
#define	_TXEN0                  ((volatile BYTE_STRUCT*)&UCSR0B)->bit3
// Mode Select - UMSEL0_UsartModeSelect_ENUM - [bit UCSR0C.UMSEL0] Select between Asynchronous and Synchronous mode of operation.
typedef enum
{
	UMSEL0_UsartModeSelect_Async,       	// Asynchronous Operation
	UMSEL0_UsartModeSelect_Sync,        	// Synchronous Operation
} UMSEL0_UsartModeSelect_ENUM;
#define	_UMSEL0                 ((volatile BYTE_STRUCT*)&UCSR0C)->bit6
// Character Size - UsartCharacterSize_ENUM - [bit aggregate (UCSR0C.UCSZ00 | UCSR0C.UCSZ01 | UCSR0B.UCSZ02)] Set the number of data bits in a frame the Receiver and Transmitter use.
#define	_UCSZ00                 ((volatile BYTE_STRUCT*)&UCSR0C)->bit1
#define	_UCSZ01                 ((volatile BYTE_STRUCT*)&UCSR0C)->bit2
#define	_UCSZ02                 ((volatile BYTE_STRUCT*)&UCSR0B)->bit2
inline UsartCharacterSize_ENUM get_UCSZ0(){ return (UsartCharacterSize_ENUM)(_UCSZ00|(_UCSZ01 << 1)|(_UCSZ02 << 2)); }
inline void set_UCSZ0(UsartCharacterSize_ENUM v){ _UCSZ00 = v; _UCSZ01 = v >> 1; _UCSZ02 = v >> 2; }
// Stop Bit Select - UsartStopBitSelect_ENUM - [bit UCSR0C.USBS0] Selects the number of Stop Bits to be inserted by the Transmitter. The Receiver ignores this setting.
#define	_USBS0                  ((volatile BYTE_STRUCT*)&UCSR0C)->bit3
// Parity Mode - UsartParityMode_ENUM - [bit field "UPM0" UCSR0C.(UPM00 | UPM01)] Enable and set type of parity generation and check.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__UPM0            : 2;
} UPM0_STRUCT;

#define	_UPM0                   ((volatile UPM0_STRUCT*)&UCSR0C)->__UPM0
// Double Transmission Speed - Enabling_ENUM - [bit UCSR0A.U2X0]
#define	_U2X0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit1
// Clock Polarity - UsartClockPolarity_ENUM - [bit UCSR0C.UCPOL0] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
#define	_UCPOL0                 ((volatile BYTE_STRUCT*)&UCSR0C)->bit0
// Multi-processor Communication Mode - Enabling_ENUM - [bit UCSR0A.MPCM0]
#define	_MPCM0                  ((volatile BYTE_STRUCT*)&UCSR0A)->bit0
// RX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR0B.RXCIE0]
#define	_RXCIE0                 ((volatile BYTE_STRUCT*)&UCSR0B)->bit7
// TX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR0B.TXCIE0]
#define	_TXCIE0                 ((volatile BYTE_STRUCT*)&UCSR0B)->bit6
// Data Register Empty Interrupt Enable - Enabling_ENUM - [bit UCSR0B.UDRIE0] Enable an interrupt when the transmit buffer (UDR) is ready to receive new data.
#define	_UDRIE0                 ((volatile BYTE_STRUCT*)&UCSR0B)->bit5

// other USART0 bit definitions
#define	_RXC0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit7
#define	_TXC0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit6
#define	_UDRE0                  ((volatile BYTE_STRUCT*)&UCSR0A)->bit5
#define	_FE0                    ((volatile BYTE_STRUCT*)&UCSR0A)->bit4
#define	_DOR0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit3
#define	_UPE0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit2
#define	_RXB80                  ((volatile BYTE_STRUCT*)&UCSR0B)->bit1
#define	_TXB80                  ((volatile BYTE_STRUCT*)&UCSR0B)->bit0
#define	_UPM01                  ((volatile BYTE_STRUCT*)&UCSR0C)->bit5
#define	_UPM00                  ((volatile BYTE_STRUCT*)&UCSR0C)->bit4

//
// USI variable definitions
//
#define	_USISIF                 ((volatile BYTE_STRUCT*)&USISR)->bit7
#define	_USIOIF                 ((volatile BYTE_STRUCT*)&USISR)->bit6
#define	_USIPF                  ((volatile BYTE_STRUCT*)&USISR)->bit5
#define	_USIDC                  ((volatile BYTE_STRUCT*)&USISR)->bit4
#define	_USICNT3                ((volatile BYTE_STRUCT*)&USISR)->bit3
#define	_USICNT2                ((volatile BYTE_STRUCT*)&USISR)->bit2
#define	_USICNT1                ((volatile BYTE_STRUCT*)&USISR)->bit1
#define	_USICNT0                ((volatile BYTE_STRUCT*)&USISR)->bit0
#define	_USISIE                 ((volatile BYTE_STRUCT*)&USICR)->bit7
#define	_USIOIE                 ((volatile BYTE_STRUCT*)&USICR)->bit6
#define	_USIWM1                 ((volatile BYTE_STRUCT*)&USICR)->bit5
#define	_USIWM0                 ((volatile BYTE_STRUCT*)&USICR)->bit4
#define	_USICS1                 ((volatile BYTE_STRUCT*)&USICR)->bit3
#define	_USICS0                 ((volatile BYTE_STRUCT*)&USICR)->bit2
#define	_USICLK                 ((volatile BYTE_STRUCT*)&USICR)->bit1
#define	_USITC                  ((volatile BYTE_STRUCT*)&USICR)->bit0

//
// WATCHDOG variable definitions
//
// Prescaler - WDP_WdtPrescale_ENUM - [bit field "WDP" WDTCR.(WDP0 | WDP1 | WDP2)] Sets the watchdog timeout period. Values are typical at 5v.
typedef enum
{
	WDP_WdtPrescale_WDTO_16MS,          	// Typical Time-out 16 ms
	WDP_WdtPrescale_WDTO_32MS,          	// Typical Time-out 32 ms
	WDP_WdtPrescale_WDTO_64MS,          	// Typical Time-out 64 ms
	WDP_WdtPrescale_WDTO_125MS,         	// Typical Time-out 125 ms
	WDP_WdtPrescale_WDTO_250MS,         	// Typical Time-out 250 ms
	WDP_WdtPrescale_WDTO_500MS,         	// Typical Time-out 500 ms
	WDP_WdtPrescale_WDTO_1S,            	// Typical Time-out 1 sec
	WDP_WdtPrescale_WDTO_2S,            	// Typical Time-out 2 sec
} WDP_WdtPrescale_ENUM;

typedef struct
{
	unsigned char	__WDP             : 3;
} WDP_STRUCT;

#define	_WDP                    ((volatile WDP_STRUCT*)&WDTCR)->__WDP
// Enable - Enabling_ENUM - [bit WDTCR.WDE] Enables the watchdog timer.
#define	_WDE                    ((volatile BYTE_STRUCT*)&WDTCR)->bit3

// other WATCHDOG bit definitions
#define	_WDCE                   ((volatile BYTE_STRUCT*)&WDTCR)->bit4
#define	_WDP2                   ((volatile BYTE_STRUCT*)&WDTCR)->bit2
#define	_WDP1                   ((volatile BYTE_STRUCT*)&WDTCR)->bit1
#define	_WDP0                   ((volatile BYTE_STRUCT*)&WDTCR)->bit0

#define _AID_ATmega3250_DEFINED_
#endif /* _AID_ATmega3250_DEFINED_ */
