#ifndef _AID_ATmega406_DEFINED_

typedef enum
{
	Enabling_Disabled,                  	// Disabled
	Enabling_Enabled,                   	// Enabled
} Enabling_ENUM;

typedef enum
{
	SenseA_LowLevel,                    	// Low Level Generates Interrupt
	SenseA_AnyChange,                   	// Any Change Generates Interrupt
	SenseA_FallingEdge,                 	// Falling Edge Generates Interrupt
	SenseA_RisingEdge,                  	// Rising Edge Generates Interrupt
} SenseA_ENUM;

typedef enum
{
	Prescaler_Prescaler1,               	// Prescaler 1
	Prescaler_Prescaler4,               	// Prescaler 4
	Prescaler_Prescaler16,              	// Prescaler 16
	Prescaler_Prescaler64,              	// Prescaler 64
} Prescaler_ENUM;

typedef enum
{
	WdtPrescale_WDTO_16MS,              	// Typical Time-out 16 ms
	WdtPrescale_WDTO_32MS,              	// Typical Time-out 32 ms
	WdtPrescale_WDTO_64MS,              	// Typical Time-out 64 ms
	WdtPrescale_WDTO_125MS,             	// Typical Time-out 125 ms
	WdtPrescale_WDTO_250MS,             	// Typical Time-out 250 ms
	WdtPrescale_WDTO_500MS,             	// Typical Time-out 500 ms
	WdtPrescale_WDTO_1S,                	// Typical Time-out 1 sec
	WdtPrescale_WDTO_2S,                	// Typical Time-out 2 sec
	WdtPrescale_WDTO_4S,                	// Typical Time-out 4 sec
	WdtPrescale_WDTO_8S,                	// Typical Time-out 8 sec
	WdtPrescale_WDTO_Invalid1,          	// Invalid
	WdtPrescale_WDTO_Invalid2,          	// Invalid
	WdtPrescale_WDTO_Invalid3,          	// Invalid
	WdtPrescale_WDTO_Invalid4,          	// Invalid
	WdtPrescale_WDTO_Invalid5,          	// Invalid
	WdtPrescale_WDTO_Invalid6,          	// Invalid
} WdtPrescale_ENUM;

typedef enum
{
	WdtMode_Disabled,                   	// Disabled
	WdtMode_Interrupt,                  	// Interrupt on timeout
	WdtMode_SystemReset,                	// System reset on timeout
	WdtMode_InterruptAndSystemReset,    	// Interrupt on first timeout, system reset on next
} WdtMode_ENUM;

typedef enum
{
	Disabling_Enabled,                  	// Enabled
	Disabling_Disabled,                 	// Disabled
} Disabling_ENUM;

//
// AD_CONVERTER variable definitions
//
#define	_VADEN                  ((volatile BYTE_STRUCT*)&VADCSR)->bit3
#define	_VADSC                  ((volatile BYTE_STRUCT*)&VADCSR)->bit2
#define	_VADCCIF                ((volatile BYTE_STRUCT*)&VADCSR)->bit1
#define	_VADCCIE                ((volatile BYTE_STRUCT*)&VADCSR)->bit0

//
// BANDGAP variable definitions
//
#define	_BGD                    ((volatile BYTE_STRUCT*)&BGCCR)->bit7
#define	_BGCC5                  ((volatile BYTE_STRUCT*)&BGCCR)->bit5
#define	_BGCC4                  ((volatile BYTE_STRUCT*)&BGCCR)->bit4
#define	_BGCC3                  ((volatile BYTE_STRUCT*)&BGCCR)->bit3
#define	_BGCC2                  ((volatile BYTE_STRUCT*)&BGCCR)->bit2
#define	_BGCC1                  ((volatile BYTE_STRUCT*)&BGCCR)->bit1
#define	_BGCC0                  ((volatile BYTE_STRUCT*)&BGCCR)->bit0

//
// BATTERY_PROTECTION variable definitions
//
#define	_BPPLE                  ((volatile BYTE_STRUCT*)&BPPLR)->bit1
#define	_BPPL                   ((volatile BYTE_STRUCT*)&BPPLR)->bit0
#define	_DUVD                   ((volatile BYTE_STRUCT*)&BPCR)->bit3
#define	_SCD                    ((volatile BYTE_STRUCT*)&BPCR)->bit2
#define	_DCD                    ((volatile BYTE_STRUCT*)&BPCR)->bit1
#define	_CCD                    ((volatile BYTE_STRUCT*)&BPCR)->bit0
#define	_SCPT3                  ((volatile BYTE_STRUCT*)&CBPTR)->bit7
#define	_SCPT2                  ((volatile BYTE_STRUCT*)&CBPTR)->bit6
#define	_SCPT1                  ((volatile BYTE_STRUCT*)&CBPTR)->bit5
#define	_SCPT0                  ((volatile BYTE_STRUCT*)&CBPTR)->bit4
#define	_OCPT3                  ((volatile BYTE_STRUCT*)&CBPTR)->bit3
#define	_OCPT2                  ((volatile BYTE_STRUCT*)&CBPTR)->bit2
#define	_OCPT1                  ((volatile BYTE_STRUCT*)&CBPTR)->bit1
#define	_OCPT0                  ((volatile BYTE_STRUCT*)&CBPTR)->bit0
#define	_DCDL3                  ((volatile BYTE_STRUCT*)&BPOCD)->bit7
#define	_DCDL2                  ((volatile BYTE_STRUCT*)&BPOCD)->bit6
#define	_DCDL1                  ((volatile BYTE_STRUCT*)&BPOCD)->bit5
#define	_DCDL0                  ((volatile BYTE_STRUCT*)&BPOCD)->bit4
#define	_CCDL3                  ((volatile BYTE_STRUCT*)&BPOCD)->bit3
#define	_CCDL2                  ((volatile BYTE_STRUCT*)&BPOCD)->bit2
#define	_CCDL1                  ((volatile BYTE_STRUCT*)&BPOCD)->bit1
#define	_CCDL0                  ((volatile BYTE_STRUCT*)&BPOCD)->bit0
#define	_DUVT1                  ((volatile BYTE_STRUCT*)&BPDUV)->bit5
#define	_DUVT0                  ((volatile BYTE_STRUCT*)&BPDUV)->bit4
#define	_DUDL3                  ((volatile BYTE_STRUCT*)&BPDUV)->bit3
#define	_DUDL2                  ((volatile BYTE_STRUCT*)&BPDUV)->bit2
#define	_DUDL1                  ((volatile BYTE_STRUCT*)&BPDUV)->bit1
#define	_DUDL0                  ((volatile BYTE_STRUCT*)&BPDUV)->bit0
#define	_DUVIF                  ((volatile BYTE_STRUCT*)&BPIR)->bit7
#define	_COCIF                  ((volatile BYTE_STRUCT*)&BPIR)->bit6
#define	_DOCIF                  ((volatile BYTE_STRUCT*)&BPIR)->bit5
#define	_SCIF                   ((volatile BYTE_STRUCT*)&BPIR)->bit4
#define	_DUVIE                  ((volatile BYTE_STRUCT*)&BPIR)->bit3
#define	_COCIE                  ((volatile BYTE_STRUCT*)&BPIR)->bit2
#define	_DOCIE                  ((volatile BYTE_STRUCT*)&BPIR)->bit1
#define	_SCIE                   ((volatile BYTE_STRUCT*)&BPIR)->bit0

//
// BOOT_LOAD variable definitions
//
#define	_SPMIE                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit7
#define	_RWWSB                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit6
#define	_SIGRD                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit5
#define	_RWWSRE                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit4
#define	_BLBSET                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit3
#define	_PGWRT                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit2
#define	_PGERS                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit1
#define	_SPMEN                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit0

//
// CELL_BALANCING variable definitions
//
#define	_CBE4                   ((volatile BYTE_STRUCT*)&CBCR)->bit3
#define	_CBE3                   ((volatile BYTE_STRUCT*)&CBCR)->bit2
#define	_CBE2                   ((volatile BYTE_STRUCT*)&CBCR)->bit1
#define	_CBE1                   ((volatile BYTE_STRUCT*)&CBCR)->bit0

//
// COULOMB_COUNTER variable definitions
//
#define	_CADEN                  ((volatile BYTE_STRUCT*)&CADCSRA)->bit7
#define	_CADUB                  ((volatile BYTE_STRUCT*)&CADCSRA)->bit5
#define	_CADAS1                 ((volatile BYTE_STRUCT*)&CADCSRA)->bit4
#define	_CADAS0                 ((volatile BYTE_STRUCT*)&CADCSRA)->bit3
#define	_CADSI1                 ((volatile BYTE_STRUCT*)&CADCSRA)->bit2
#define	_CADSI0                 ((volatile BYTE_STRUCT*)&CADCSRA)->bit1
#define	_CADSE                  ((volatile BYTE_STRUCT*)&CADCSRA)->bit0
#define	_CADACIE                ((volatile BYTE_STRUCT*)&CADCSRB)->bit6
#define	_CADRCIE                ((volatile BYTE_STRUCT*)&CADCSRB)->bit5
#define	_CADICIE                ((volatile BYTE_STRUCT*)&CADCSRB)->bit4
#define	_CADACIF                ((volatile BYTE_STRUCT*)&CADCSRB)->bit2
#define	_CADRCIF                ((volatile BYTE_STRUCT*)&CADCSRB)->bit1
#define	_CADICIF                ((volatile BYTE_STRUCT*)&CADCSRB)->bit0

//
// CPU variable definitions
//
#define	_JTD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit7
#define	_PUD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit4
#define	_IVSEL                  ((volatile BYTE_STRUCT*)&MCUCR)->bit1
#define	_IVCE                   ((volatile BYTE_STRUCT*)&MCUCR)->bit0
#define	_JTRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit4
#define	_WDRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit3
#define	_BODRF                  ((volatile BYTE_STRUCT*)&MCUSR)->bit2
#define	_EXTRF                  ((volatile BYTE_STRUCT*)&MCUSR)->bit1
#define	_PORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit0
#define	_SM2                    ((volatile BYTE_STRUCT*)&SMCR)->bit3
#define	_SM1                    ((volatile BYTE_STRUCT*)&SMCR)->bit2
#define	_SM0                    ((volatile BYTE_STRUCT*)&SMCR)->bit1
#define	_SE                     ((volatile BYTE_STRUCT*)&SMCR)->bit0
#define	_XOE                    ((volatile BYTE_STRUCT*)&CCSR)->bit1
#define	_ACS                    ((volatile BYTE_STRUCT*)&CCSR)->bit0
#define	_VADC0D                 ((volatile BYTE_STRUCT*)&DIDR0)->bit0
#define	_VADC1D                 ((volatile BYTE_STRUCT*)&DIDR0)->bit1
#define	_VADC2D                 ((volatile BYTE_STRUCT*)&DIDR0)->bit2
#define	_VADC3D                 ((volatile BYTE_STRUCT*)&DIDR0)->bit3
#define	_PRTWI                  ((volatile BYTE_STRUCT*)&PRR0)->bit3
#define	_PRTIM1                 ((volatile BYTE_STRUCT*)&PRR0)->bit2
#define	_PRTIM0                 ((volatile BYTE_STRUCT*)&PRR0)->bit1
#define	_PRVADC                 ((volatile BYTE_STRUCT*)&PRR0)->bit0

//
// EEPROM variable definitions
//
#define	_EEPM1                  ((volatile BYTE_STRUCT*)&EECR)->bit5
#define	_EEPM0                  ((volatile BYTE_STRUCT*)&EECR)->bit4
#define	_EERIE                  ((volatile BYTE_STRUCT*)&EECR)->bit3
#define	_EEMPE                  ((volatile BYTE_STRUCT*)&EECR)->bit2
#define	_EEPE                   ((volatile BYTE_STRUCT*)&EECR)->bit1
#define	_EERE                   ((volatile BYTE_STRUCT*)&EECR)->bit0

//
// EXTERNAL_INTERRUPT variable definitions
//
// INT0 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT0] Enables the interrupt on the INT pin
#define	_INT0                   ((volatile BYTE_STRUCT*)&EIMSK)->bit0
// INT0 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC0" EICRA.(ISC00 | ISC01)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__ISC0            : 2;
} ISC0_STRUCT;

#define	_ISC0                   ((volatile ISC0_STRUCT*)&EICRA)->__ISC0
// INT1 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT1] Enables the interrupt on the INT pin
#define	_INT1                   ((volatile BYTE_STRUCT*)&EIMSK)->bit1
// INT1 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC1" EICRA.(ISC10 | ISC11)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__ISC1            : 2;
} ISC1_STRUCT;

#define	_ISC1                   ((volatile ISC1_STRUCT*)&EICRA)->__ISC1
// INT2 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT2] Enables the interrupt on the INT pin
#define	_INT2                   ((volatile BYTE_STRUCT*)&EIMSK)->bit2
// INT2 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC2" EICRA.(ISC20 | ISC21)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__ISC2            : 2;
} ISC2_STRUCT;

#define	_ISC2                   ((volatile ISC2_STRUCT*)&EICRA)->__ISC2
// INT3 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT3] Enables the interrupt on the INT pin
#define	_INT3                   ((volatile BYTE_STRUCT*)&EIMSK)->bit3
// INT3 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC3" EICRA.(ISC30 | ISC31)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__ISC3            : 2;
} ISC3_STRUCT;

#define	_ISC3                   ((volatile ISC3_STRUCT*)&EICRA)->__ISC3
// PCINT0 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT0] Enables interrupts on PCINT0
#define	_PCINT0                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit0
// PCINT1 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT1] Enables interrupts on PCINT1
#define	_PCINT1                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit1
// PCINT2 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT2] Enables interrupts on PCINT2
#define	_PCINT2                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit2
// PCINT3 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT3] Enables interrupts on PCINT3
#define	_PCINT3                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit3
// PCINT4 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT4] Enables interrupts on PCINT4
#define	_PCINT4                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit4
// PCINT5 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT5] Enables interrupts on PCINT5
#define	_PCINT5                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit5
// PCINT6 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT6] Enables interrupts on PCINT6
#define	_PCINT6                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit6
// PCINT7 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT7] Enables interrupts on PCINT7
#define	_PCINT7                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit7
// PCINT8 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT8] Enables interrupts on PCINT8
#define	_PCINT8                 ((volatile BYTE_STRUCT*)&PCMSK1)->bit0
// PCINT9 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT9] Enables interrupts on PCINT9
#define	_PCINT9                 ((volatile BYTE_STRUCT*)&PCMSK1)->bit1
// PCINT10 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT10] Enables interrupts on PCINT10
#define	_PCINT10                ((volatile BYTE_STRUCT*)&PCMSK1)->bit2
// PCINT11 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT11] Enables interrupts on PCINT11
#define	_PCINT11                ((volatile BYTE_STRUCT*)&PCMSK1)->bit3
// PCINT12 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT12] Enables interrupts on PCINT12
#define	_PCINT12                ((volatile BYTE_STRUCT*)&PCMSK1)->bit4
// PCINT13 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT13] Enables interrupts on PCINT13
#define	_PCINT13                ((volatile BYTE_STRUCT*)&PCMSK1)->bit5
// PCINT14 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT14] Enables interrupts on PCINT14
#define	_PCINT14                ((volatile BYTE_STRUCT*)&PCMSK1)->bit6
// PCINT15 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT15] Enables interrupts on PCINT15
#define	_PCINT15                ((volatile BYTE_STRUCT*)&PCMSK1)->bit7
// PCIE0 Interrupt Enable - Enabling_ENUM - [bit PCICR.PCIE0] Enables interrupts for PCINT7..0
#define	_PCIE0                  ((volatile BYTE_STRUCT*)&PCICR)->bit0
// PCIE1 Interrupt Enable - Enabling_ENUM - [bit PCICR.PCIE1] Enables interrupts for PCINT15..8
#define	_PCIE1                  ((volatile BYTE_STRUCT*)&PCICR)->bit1

// other EXTERNAL_INTERRUPT bit definitions
#define	_ISC31                  ((volatile BYTE_STRUCT*)&EICRA)->bit7
#define	_ISC30                  ((volatile BYTE_STRUCT*)&EICRA)->bit6
#define	_ISC21                  ((volatile BYTE_STRUCT*)&EICRA)->bit5
#define	_ISC20                  ((volatile BYTE_STRUCT*)&EICRA)->bit4
#define	_ISC11                  ((volatile BYTE_STRUCT*)&EICRA)->bit3
#define	_ISC10                  ((volatile BYTE_STRUCT*)&EICRA)->bit2
#define	_ISC01                  ((volatile BYTE_STRUCT*)&EICRA)->bit1
#define	_ISC00                  ((volatile BYTE_STRUCT*)&EICRA)->bit0
#define	_INTF3                  ((volatile BYTE_STRUCT*)&EIFR)->bit3
#define	_INTF2                  ((volatile BYTE_STRUCT*)&EIFR)->bit2
#define	_INTF1                  ((volatile BYTE_STRUCT*)&EIFR)->bit1
#define	_INTF0                  ((volatile BYTE_STRUCT*)&EIFR)->bit0
#define	_PCIF1                  ((volatile BYTE_STRUCT*)&PCIFR)->bit1
#define	_PCIF0                  ((volatile BYTE_STRUCT*)&PCIFR)->bit0

//
// FET variable definitions
//
#define	_PWMOC                  ((volatile BYTE_STRUCT*)&FCSR)->bit5
#define	_PWMOPC                 ((volatile BYTE_STRUCT*)&FCSR)->bit4
#define	_CPS                    ((volatile BYTE_STRUCT*)&FCSR)->bit3
#define	_DFE                    ((volatile BYTE_STRUCT*)&FCSR)->bit2
#define	_CFE                    ((volatile BYTE_STRUCT*)&FCSR)->bit1
#define	_PFD                    ((volatile BYTE_STRUCT*)&FCSR)->bit0

//
// TIMER_COUNTER_0 variable definitions
//
// Waveform Generation Mode - WGM0_WGM_ENUM - [bit aggregate (TCCR0A.WGM00 | TCCR0A.WGM01 | TCCR0B.WGM02)] Controls how the counter will cycle.
typedef enum
{
	WGM0_WGM_Normal,                    	// Normal
	WGM0_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM0_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM0_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM0_WGM_Reserved,                  	// Reserved
	WGM0_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM0_WGM_Reserved2,                 	// Reserved
	WGM0_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM0_WGM_ENUM;
#define	_WGM00                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit0
#define	_WGM01                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit1
#define	_WGM02                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit3
inline WGM0_WGM_ENUM get_WGM0(){ return (WGM0_WGM_ENUM)(_WGM00|(_WGM01 << 1)|(_WGM02 << 2)); }
inline void set_WGM0(WGM0_WGM_ENUM v){ _WGM00 = v; _WGM01 = v >> 1; _WGM02 = v >> 2; }
// Clock Select - CS0_CS_ENUM - [bit field "CS0" TCCR0B.(CS00 | CS01 | CS02)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS0_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS0_CS_DIV_1,                       	// clk (No prescaling)
	CS0_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS0_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS0_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS0_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS0_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS0_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS0_CS_ENUM;

typedef struct
{
	unsigned char	__CS0             : 3;
} CS0_STRUCT;

#define	_CS0                    ((volatile CS0_STRUCT*)&TCCR0B)->__CS0
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK0.TOIE0]
#define	_TOIE0                  ((volatile BYTE_STRUCT*)&TIMSK0)->bit0
// Compare Output Mode A - _ENUM - [bit field "COMA0" TCCR0A.(COM0A0 | COM0A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA0           : 2;
} COMA0_STRUCT;

#define	_COMA0                  ((volatile COMA0_STRUCT*)&TCCR0A)->__COMA0
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK0.OCIE0A]
#define	_OCIE0A                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB0" TCCR0A.(COM0B0 | COM0B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB0           : 2;
} COMB0_STRUCT;

#define	_COMB0                  ((volatile COMB0_STRUCT*)&TCCR0A)->__COMB0
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK0.OCIE0B]
#define	_OCIE0B                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit2

// other TIMER_COUNTER_0 bit definitions
#define	_COM0A1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit7
#define	_COM0A0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit6
#define	_COM0B1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit5
#define	_COM0B0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit4
#define	_FOC0A                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit7
#define	_FOC0B                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit6
#define	_CS02                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit2
#define	_CS01                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit1
#define	_CS00                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit0
#define	_OCF0B                  ((volatile BYTE_STRUCT*)&TIFR0)->bit2
#define	_OCF0A                  ((volatile BYTE_STRUCT*)&TIFR0)->bit1
#define	_TOV0                   ((volatile BYTE_STRUCT*)&TIFR0)->bit0

//
// TIMER_COUNTER_1 variable definitions
//
// Clear Timer on Compare Match - WGM1_WGM_ENUM - [bit TCCR1B.CTC1] Controls how the counter will cycle.
typedef enum
{
	WGM1_WGM_Normal,                    	// Normal
	WGM1_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
} WGM1_WGM_ENUM;
#define	_CTC1                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit3
// Clock Select - CS1_CS_ENUM - [bit field "CS1" TCCR1B.(CS10 | CS11 | CS12)] Selects the clock divisor.
typedef enum
{
	CS1_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS1_CS_DIV_1,                       	// clk (No prescaling)
	CS1_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS1_CS_DIV_32,                      	// clk / 32 (From prescaler)
	CS1_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS1_CS_DIV_128,                     	// clk / 128 (From prescaler)
	CS1_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS1_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
} CS1_CS_ENUM;

typedef struct
{
	unsigned char	__CS1             : 3;
} CS1_STRUCT;

#define	_CS1                    ((volatile CS1_STRUCT*)&TCCR1B)->__CS1
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK1.TOIE1]
#define	_TOIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit0
// Output Compare Match Interrupt Enable - Enabling_ENUM - [bit TIMSK1.OCIE1A]
#define	_OCIE1A                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit1

// other TIMER_COUNTER_1 bit definitions
#define	_CS12                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit2
#define	_CS11                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit1
#define	_CS10                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit0
#define	_OCF1A                  ((volatile BYTE_STRUCT*)&TIFR1)->bit1
#define	_TOV1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit0
#define	_TSM                    ((volatile BYTE_STRUCT*)&GTCCR)->bit7
#define	_PSRSYNC                ((volatile BYTE_STRUCT*)&GTCCR)->bit0

//
// TWI variable definitions
//
// TWI Enable - Enabling_ENUM - [bit TWCR.TWEN] Enables TWI operation and activates the TWI interface.
#define	_TWEN                   ((volatile BYTE_STRUCT*)&TWCR)->bit2
// Bit Rate Prescaler - Prescaler_ENUM - [bit field "TWPS" TWSR.(TWPS0 | TWPS1)] Selects the prescaler division factor for the divider which generates the SCL clock frequency in the Master modes.

typedef struct
{
	unsigned char	__TWPS            : 2;
} TWPS_STRUCT;

#define	_TWPS                   ((volatile TWPS_STRUCT*)&TWSR)->__TWPS
// Address Register - _ENUM - [bit field "TWAR" TWAR.(TWA0 | TWA1 | TWA2 | TWA3 | TWA4 | TWA5 | TWA6)] Address to which the TWI will respond.

typedef struct
{
	unsigned char	__Reserved        : 1;
	unsigned char	__TWAR            : 7;
} TWAR_STRUCT;

#define	_TWAR                   ((volatile TWAR_STRUCT*)&TWAR)->__TWAR
// Address Mask Register - _ENUM - [bit field "TWAM" TWAMR.(TWAM0 | TWAM1 | TWAM2 | TWAM3 | TWAM4 | TWAM5 | TWAM6)] Each bit masks (disables) the corresponding bit in the Address Register. If the mask bit is set to one then the address match logic ignores the compare between the incoming address bit and the corresponding bit in the Address Register.

typedef struct
{
	unsigned char	__Reserved        : 1;
	unsigned char	__TWAM            : 7;
} TWAM_STRUCT;

#define	_TWAM                   ((volatile TWAM_STRUCT*)&TWAMR)->__TWAM
// General Call Recognition Enable - Enabling_ENUM - [bit TWAR.TWGCE] Enables the recognition of a General Call.
#define	_TWGCE                  ((volatile BYTE_STRUCT*)&TWAR)->bit0
// Enable Acknowledge - Enabling_ENUM - [bit TWCR.TWEA] Controls the generation of the acknowledge pulse.
#define	_TWEA                   ((volatile BYTE_STRUCT*)&TWCR)->bit6
// Interrupt Enable - Enabling_ENUM - [bit TWCR.TWIE] Enables the TWI interrupt.
#define	_TWIE                   ((volatile BYTE_STRUCT*)&TWCR)->bit0

// other TWI bit definitions
#define	_TWBCIF                 ((volatile BYTE_STRUCT*)&TWBCSR)->bit7
#define	_TWBCIE                 ((volatile BYTE_STRUCT*)&TWBCSR)->bit6
#define	_TWBDT1                 ((volatile BYTE_STRUCT*)&TWBCSR)->bit2
#define	_TWBDT0                 ((volatile BYTE_STRUCT*)&TWBCSR)->bit1
#define	_TWBCIP                 ((volatile BYTE_STRUCT*)&TWBCSR)->bit0
#define	_TWAM6                  ((volatile BYTE_STRUCT*)&TWAMR)->bit7
#define	_TWAM5                  ((volatile BYTE_STRUCT*)&TWAMR)->bit6
#define	_TWAM4                  ((volatile BYTE_STRUCT*)&TWAMR)->bit5
#define	_TWAM3                  ((volatile BYTE_STRUCT*)&TWAMR)->bit4
#define	_TWAM2                  ((volatile BYTE_STRUCT*)&TWAMR)->bit3
#define	_TWAM1                  ((volatile BYTE_STRUCT*)&TWAMR)->bit2
#define	_TWAM0                  ((volatile BYTE_STRUCT*)&TWAMR)->bit1
#define	_TWINT                  ((volatile BYTE_STRUCT*)&TWCR)->bit7
#define	_TWSTA                  ((volatile BYTE_STRUCT*)&TWCR)->bit5
#define	_TWSTO                  ((volatile BYTE_STRUCT*)&TWCR)->bit4
#define	_TWWC                   ((volatile BYTE_STRUCT*)&TWCR)->bit3
#define	_TWS7                   ((volatile BYTE_STRUCT*)&TWSR)->bit7
#define	_TWS6                   ((volatile BYTE_STRUCT*)&TWSR)->bit6
#define	_TWS5                   ((volatile BYTE_STRUCT*)&TWSR)->bit5
#define	_TWS4                   ((volatile BYTE_STRUCT*)&TWSR)->bit4
#define	_TWS3                   ((volatile BYTE_STRUCT*)&TWSR)->bit3
#define	_TWPS1                  ((volatile BYTE_STRUCT*)&TWSR)->bit1
#define	_TWPS0                  ((volatile BYTE_STRUCT*)&TWSR)->bit0
#define	_TWA6                   ((volatile BYTE_STRUCT*)&TWAR)->bit7
#define	_TWA5                   ((volatile BYTE_STRUCT*)&TWAR)->bit6
#define	_TWA4                   ((volatile BYTE_STRUCT*)&TWAR)->bit5
#define	_TWA3                   ((volatile BYTE_STRUCT*)&TWAR)->bit4
#define	_TWA2                   ((volatile BYTE_STRUCT*)&TWAR)->bit3
#define	_TWA1                   ((volatile BYTE_STRUCT*)&TWAR)->bit2
#define	_TWA0                   ((volatile BYTE_STRUCT*)&TWAR)->bit1

//
// WAKEUP_TIMER variable definitions
//
#define	_WUTIF                  ((volatile BYTE_STRUCT*)&WUTCSR)->bit7
#define	_WUTIE                  ((volatile BYTE_STRUCT*)&WUTCSR)->bit6
#define	_WUTCF                  ((volatile BYTE_STRUCT*)&WUTCSR)->bit5
#define	_WUTR                   ((volatile BYTE_STRUCT*)&WUTCSR)->bit4
#define	_WUTE                   ((volatile BYTE_STRUCT*)&WUTCSR)->bit3
#define	_WUTP2                  ((volatile BYTE_STRUCT*)&WUTCSR)->bit2
#define	_WUTP1                  ((volatile BYTE_STRUCT*)&WUTCSR)->bit1
#define	_WUTP0                  ((volatile BYTE_STRUCT*)&WUTCSR)->bit0

//
// WATCHDOG variable definitions
//
// Prescaler - WdtPrescale_ENUM - [bit aggregate (WDTCSR.WDP0 | WDTCSR.WDP1 | WDTCSR.WDP2 | WDTCSR.WDP3)] Sets the watchdog timeout period. Values are typical at 5v.
#define	_WDP0                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit0
#define	_WDP1                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit1
#define	_WDP2                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit2
#define	_WDP3                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit5
inline WdtPrescale_ENUM get_WDP(){ return (WdtPrescale_ENUM)(_WDP0|(_WDP1 << 1)|(_WDP2 << 2)|(_WDP3 << 3)); }
inline void set_WDP(WdtPrescale_ENUM v){ _WDP0 = v; _WDP1 = v >> 1; _WDP2 = v >> 2; _WDP3 = v >> 3; }
// Configuration - WdtMode_ENUM - [bit aggregate (WDTCSR.WDIE | WDTCSR.WDE)] Determines the action taken when a watchdog timeout occurs.
#define	_WDIE                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit6
#define	_WDE                    ((volatile BYTE_STRUCT*)&WDTCSR)->bit3
inline WdtMode_ENUM get_Mode(){ return (WdtMode_ENUM)(_WDIE|(_WDE << 1)); }
inline void set_Mode(WdtMode_ENUM v){ _WDIE = v; _WDE = v >> 1; }

// other WATCHDOG bit definitions
#define	_WDIF                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit7
#define	_WDCE                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit4

//
// JTAG variable definitions
//
// JTAG Disable - Disabling_ENUM - [bit MCUCR.JTD] Disables JTAG operation.

// other JTAG bit definitions

#define _AID_ATmega406_DEFINED_
#endif /* _AID_ATmega406_DEFINED_ */
