#ifndef _AID_ATmega640_DEFINED_

typedef enum
{
	Disabling_Enabled,                  	// Enabled
	Disabling_Disabled,                 	// Disabled
} Disabling_ENUM;

typedef enum
{
	Enabling_Disabled,                  	// Disabled
	Enabling_Enabled,                   	// Enabled
} Enabling_ENUM;

typedef enum
{
	ACIntModeSelect_OutputToggle,       	// Comparator Interrupt on Output Toggle
	ACIntModeSelect_Reserved,           	// Reserved
	ACIntModeSelect_FallingOutputEdge,  	// Comparator Interrupt on Falling Output Edge
	ACIntModeSelect_RisingOutputEdge,   	// Comparator Interrupt on Rising Output Edge
} ACIntModeSelect_ENUM;

typedef enum
{
	ACBandgapSelect_NoBandgap,          	// Use AIN0 as positive input
	ACBandgapSelect_Bandgap,            	// Use fixed bandgap reference voltage as positive input
} ACBandgapSelect_ENUM;

typedef enum
{
	SenseA_LowLevel,                    	// Low Level Generates Interrupt
	SenseA_AnyChange,                   	// Any Change Generates Interrupt
	SenseA_FallingEdge,                 	// Falling Edge Generates Interrupt
	SenseA_RisingEdge,                  	// Rising Edge Generates Interrupt
} SenseA_ENUM;

typedef enum
{
	SPIMaster_Slave,                    	// Slave Mode
	SPIMaster_Master,                   	// Master Mode
} SPIMaster_ENUM;

typedef enum
{
	SPR_DIV_4,                          	// clk / 4
	SPR_DIV_16,                         	// clk / 16
	SPR_DIV_64,                         	// clk / 64
	SPR_DIV_128,                        	// clk / 128
	SPR_DIV_2,                          	// clk / 2
	SPR_DIV_8,                          	// clk / 8
	SPR_DIV_32,                         	// clk / 32
	SPR_DIV_64b,                        	// clk / 64
} SPR_ENUM;

typedef enum
{
	SPIMode_Mode0,                      	// 0 - Leading (Rising) Edge Sample, Trailing (Falling) Edge Setup
	SPIMode_Mode1,                      	// 1 - Leading (Rising) Edge Setup, Trailing (Falling) Edge Sample
	SPIMode_Mode2,                      	// 2 - Leading (Falling) Edge Sample, Trailing (Rising) Edge Setup
	SPIMode_Mode3,                      	// 3 - Leading (Falling) Edge Setup, Trailing (Rising) Edge Sample
} SPIMode_ENUM;

typedef enum
{
	SPIDataOrder_MSBFirst,              	// Most Significant Bit First
	SPIDataOrder_LSBFirst,              	// Least Significant Bit First
} SPIDataOrder_ENUM;

typedef enum
{
	Trigger_Falling,                    	// Falling Edge Trigger
	Trigger_Rising,                     	// Rising Edge Trigger
} Trigger_ENUM;

typedef enum
{
	Prescaler_Prescaler1,               	// Prescaler 1
	Prescaler_Prescaler4,               	// Prescaler 4
	Prescaler_Prescaler16,              	// Prescaler 16
	Prescaler_Prescaler64,              	// Prescaler 64
} Prescaler_ENUM;

typedef enum
{
	UsartModeSelect_Async,              	// Asynchronous Operation
	UsartModeSelect_Sync,               	// Synchronous Operation
	UsartModeSelect_Reserved,           	// Reserved
	UsartModeSelect_MasterSPI,          	// Master SPI
} UsartModeSelect_ENUM;

typedef enum
{
	UsartCharacterSize_FiveBits,        	// 5 bits
	UsartCharacterSize_SixBits,         	// 6 bits
	UsartCharacterSize_SevenBits,       	// 7 bits
	UsartCharacterSize_EightBits,       	// 8 bits
	UsartCharacterSize_Reserved,        	// Reserved
	UsartCharacterSize_Reserved2,       	// Reserved
	UsartCharacterSize_Reserved3,       	// Reserved
	UsartCharacterSize_NineBits,        	// 9 bits
} UsartCharacterSize_ENUM;

typedef enum
{
	UsartStopBitSelect_OneStopBit,      	// 1 stop bit
	UsartStopBitSelect_TwoStopBits,     	// 2 stop bits
} UsartStopBitSelect_ENUM;

typedef enum
{
	UsartParityMode_Disabled,           	// Disabled
	UsartParityMode_Reserved,           	// Reserved
	UsartParityMode_EvenParity,         	// Even Parity
	UsartParityMode_OddParity,          	// Odd Parity
} UsartParityMode_ENUM;

typedef enum
{
	UsartClockPolarity_Normal,          	// TX Changed on Rising Edge, RX Sampled on Falling Edge
	UsartClockPolarity_Inverted,        	// TX Changed on Falling Edge, RX Sampled on Rising Edge
} UsartClockPolarity_ENUM;

typedef enum
{
	WdtPrescale_WDTO_16MS,              	// Typical Time-out 16 ms
	WdtPrescale_WDTO_32MS,              	// Typical Time-out 32 ms
	WdtPrescale_WDTO_64MS,              	// Typical Time-out 64 ms
	WdtPrescale_WDTO_125MS,             	// Typical Time-out 125 ms
	WdtPrescale_WDTO_250MS,             	// Typical Time-out 250 ms
	WdtPrescale_WDTO_500MS,             	// Typical Time-out 500 ms
	WdtPrescale_WDTO_1S,                	// Typical Time-out 1 sec
	WdtPrescale_WDTO_2S,                	// Typical Time-out 2 sec
	WdtPrescale_WDTO_4S,                	// Typical Time-out 4 sec
	WdtPrescale_WDTO_8S,                	// Typical Time-out 8 sec
	WdtPrescale_WDTO_Invalid1,          	// Invalid
	WdtPrescale_WDTO_Invalid2,          	// Invalid
	WdtPrescale_WDTO_Invalid3,          	// Invalid
	WdtPrescale_WDTO_Invalid4,          	// Invalid
	WdtPrescale_WDTO_Invalid5,          	// Invalid
	WdtPrescale_WDTO_Invalid6,          	// Invalid
} WdtPrescale_ENUM;

typedef enum
{
	WdtMode_Disabled,                   	// Disabled
	WdtMode_Interrupt,                  	// Interrupt on timeout
	WdtMode_SystemReset,                	// System reset on timeout
	WdtMode_InterruptAndSystemReset,    	// Interrupt on first timeout, system reset on next
} WdtMode_ENUM;

//
// AD_CONVERTER variable definitions
//
#define	_REFS1                  ((volatile BYTE_STRUCT*)&ADMUX)->bit7
#define	_REFS0                  ((volatile BYTE_STRUCT*)&ADMUX)->bit6
#define	_ADLAR                  ((volatile BYTE_STRUCT*)&ADMUX)->bit5
#define	_MUX4                   ((volatile BYTE_STRUCT*)&ADMUX)->bit4
#define	_MUX3                   ((volatile BYTE_STRUCT*)&ADMUX)->bit3
#define	_MUX2                   ((volatile BYTE_STRUCT*)&ADMUX)->bit2
#define	_MUX1                   ((volatile BYTE_STRUCT*)&ADMUX)->bit1
#define	_MUX0                   ((volatile BYTE_STRUCT*)&ADMUX)->bit0
#define	_ADEN                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit7
#define	_ADSC                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit6
#define	_ADATE                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit5
#define	_ADIF                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit4
#define	_ADIE                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit3
#define	_ADPS2                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit2
#define	_ADPS1                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit1
#define	_ADPS0                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit0
#define	_ACME                   ((volatile BYTE_STRUCT*)&ADCSRB)->bit6
#define	_MUX5                   ((volatile BYTE_STRUCT*)&ADCSRB)->bit3
#define	_ADTS2                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit2
#define	_ADTS1                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit1
#define	_ADTS0                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit0
#define	_ADC7D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit7
#define	_ADC6D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit6
#define	_ADC5D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit5
#define	_ADC4D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit4
#define	_ADC3D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit3
#define	_ADC2D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit2
#define	_ADC1D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit1
#define	_ADC0D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit0
#define	_ADC15D                 ((volatile BYTE_STRUCT*)&DIDR2)->bit7
#define	_ADC14D                 ((volatile BYTE_STRUCT*)&DIDR2)->bit6
#define	_ADC13D                 ((volatile BYTE_STRUCT*)&DIDR2)->bit5
#define	_ADC12D                 ((volatile BYTE_STRUCT*)&DIDR2)->bit4
#define	_ADC11D                 ((volatile BYTE_STRUCT*)&DIDR2)->bit3
#define	_ADC10D                 ((volatile BYTE_STRUCT*)&DIDR2)->bit2
#define	_ADC9D                  ((volatile BYTE_STRUCT*)&DIDR2)->bit1
#define	_ADC8D                  ((volatile BYTE_STRUCT*)&DIDR2)->bit0

//
// ANALOG_COMPARATOR variable definitions
//
// Analog Comparator Disable - Disabling_ENUM - [bit ACSR.ACD] Disables the Analog Comparator.
#define	_ACD                    ((volatile BYTE_STRUCT*)&ACSR)->bit7
// Interrupt Enable - Enabling_ENUM - [bit ACSR.ACIE] When enabled and the I-bit in the Status Register is set, the Analog Comparator interrupt is activated.
#define	_ACIE                   ((volatile BYTE_STRUCT*)&ACSR)->bit3
// Interrupt Mode Select - ACIntModeSelect_ENUM - [bit field "ACIS" ACSR.(ACIS0 | ACIS1)] Determine which comparator events trigger the Analog Comparator interrupt.

typedef struct
{
	unsigned char	__ACIS            : 2;
} ACIS_STRUCT;

#define	_ACIS                   ((volatile ACIS_STRUCT*)&ACSR)->__ACIS
// Input Capture Enable - Enabling_ENUM - [bit ACSR.ACIC] Enables the input capture function in Timer/Counter1 to be triggered by the Analog Comparator.
#define	_ACIC                   ((volatile BYTE_STRUCT*)&ACSR)->bit2
// Bandgap Select - ACBandgapSelect_ENUM - [bit ACSR.ACBG] Selects a bandgap reference voltage as the positive input.
#define	_ACBG                   ((volatile BYTE_STRUCT*)&ACSR)->bit6
// Multiplexer Enable - Enabling_ENUM - [bit ADCSRB.ACME] When enabled and the ADC is switched off, the ADC multiplexer selects the negative input to the Analog Comparator. When disabled, AIN1 is applied to the negative input of the Analog Comparator.
// Digital Input 0 Disable - Disabling_ENUM - [bit DIDR1.AIN0D] When disabled, the digital input buffer on the AIN0 pin is disabled.
#define	_AIN0D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit0
// Digital Input 1 Disable - Disabling_ENUM - [bit DIDR1.AIN1D] When disabled, the digital input buffer on the AIN1 pin is disabled.
#define	_AIN1D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit1

// other ANALOG_COMPARATOR bit definitions
#define	_ACO                    ((volatile BYTE_STRUCT*)&ACSR)->bit5
#define	_ACI                    ((volatile BYTE_STRUCT*)&ACSR)->bit4
#define	_ACIS1                  ((volatile BYTE_STRUCT*)&ACSR)->bit1
#define	_ACIS0                  ((volatile BYTE_STRUCT*)&ACSR)->bit0

//
// BOOT_LOAD variable definitions
//
#define	_SPMIE                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit7
#define	_RWWSB                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit6
#define	_SIGRD                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit5
#define	_RWWSRE                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit4
#define	_BLBSET                 ((volatile BYTE_STRUCT*)&SPMCSR)->bit3
#define	_PGWRT                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit2
#define	_PGERS                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit1
#define	_SPMEN                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit0

//
// CPU variable definitions
//
#define	_JTD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit7
#define	_PUD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit4
#define	_IVSEL                  ((volatile BYTE_STRUCT*)&MCUCR)->bit1
#define	_IVCE                   ((volatile BYTE_STRUCT*)&MCUCR)->bit0
#define	_JTRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit4
#define	_WDRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit3
#define	_BORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit2
#define	_EXTRF                  ((volatile BYTE_STRUCT*)&MCUSR)->bit1
#define	_PORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit0
#define	_SRE                    ((volatile BYTE_STRUCT*)&XMCRA)->bit7
#define	_SRL2                   ((volatile BYTE_STRUCT*)&XMCRA)->bit6
#define	_SRL1                   ((volatile BYTE_STRUCT*)&XMCRA)->bit5
#define	_SRL0                   ((volatile BYTE_STRUCT*)&XMCRA)->bit4
#define	_SRW11                  ((volatile BYTE_STRUCT*)&XMCRA)->bit3
#define	_SRW10                  ((volatile BYTE_STRUCT*)&XMCRA)->bit2
#define	_SRW01                  ((volatile BYTE_STRUCT*)&XMCRA)->bit1
#define	_SRW00                  ((volatile BYTE_STRUCT*)&XMCRA)->bit0
#define	_XMBK                   ((volatile BYTE_STRUCT*)&XMCRB)->bit7
#define	_XMM2                   ((volatile BYTE_STRUCT*)&XMCRB)->bit2
#define	_XMM1                   ((volatile BYTE_STRUCT*)&XMCRB)->bit1
#define	_XMM0                   ((volatile BYTE_STRUCT*)&XMCRB)->bit0
#define	_CLKPCE                 ((volatile BYTE_STRUCT*)&CLKPR)->bit7
#define	_CLKPS3                 ((volatile BYTE_STRUCT*)&CLKPR)->bit3
#define	_CLKPS2                 ((volatile BYTE_STRUCT*)&CLKPR)->bit2
#define	_CLKPS1                 ((volatile BYTE_STRUCT*)&CLKPR)->bit1
#define	_CLKPS0                 ((volatile BYTE_STRUCT*)&CLKPR)->bit0
#define	_SM2                    ((volatile BYTE_STRUCT*)&SMCR)->bit3
#define	_SM1                    ((volatile BYTE_STRUCT*)&SMCR)->bit2
#define	_SM0                    ((volatile BYTE_STRUCT*)&SMCR)->bit1
#define	_SE                     ((volatile BYTE_STRUCT*)&SMCR)->bit0
#define	_EIND0                  ((volatile BYTE_STRUCT*)&EIND)->bit0
#define	_PRTIM5                 ((volatile BYTE_STRUCT*)&PRR1)->bit5
#define	_PRTIM4                 ((volatile BYTE_STRUCT*)&PRR1)->bit4
#define	_PRTIM3                 ((volatile BYTE_STRUCT*)&PRR1)->bit3
#define	_PRUSART3               ((volatile BYTE_STRUCT*)&PRR1)->bit2
#define	_PRUSART2               ((volatile BYTE_STRUCT*)&PRR1)->bit1
#define	_PRUSART1               ((volatile BYTE_STRUCT*)&PRR1)->bit0
#define	_PRTWI                  ((volatile BYTE_STRUCT*)&PRR0)->bit7
#define	_PRTIM2                 ((volatile BYTE_STRUCT*)&PRR0)->bit6
#define	_PRTIM0                 ((volatile BYTE_STRUCT*)&PRR0)->bit5
#define	_PRTIM1                 ((volatile BYTE_STRUCT*)&PRR0)->bit3
#define	_PRSPI                  ((volatile BYTE_STRUCT*)&PRR0)->bit2
#define	_PRUSART0               ((volatile BYTE_STRUCT*)&PRR0)->bit1
#define	_PRADC                  ((volatile BYTE_STRUCT*)&PRR0)->bit0

//
// EEPROM variable definitions
//
#define	_EEPM1                  ((volatile BYTE_STRUCT*)&EECR)->bit5
#define	_EEPM0                  ((volatile BYTE_STRUCT*)&EECR)->bit4
#define	_EERIE                  ((volatile BYTE_STRUCT*)&EECR)->bit3
#define	_EEMPE                  ((volatile BYTE_STRUCT*)&EECR)->bit2
#define	_EEPE                   ((volatile BYTE_STRUCT*)&EECR)->bit1
#define	_EERE                   ((volatile BYTE_STRUCT*)&EECR)->bit0

//
// EXTERNAL_INTERRUPT variable definitions
//
// INT0 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT0] Enables the interrupt on the INT pin
#define	_INT0                   ((volatile BYTE_STRUCT*)&EIMSK)->bit0
// INT0 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC0" EICRA.(ISC00 | ISC01)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__ISC0            : 2;
} ISC0_STRUCT;

#define	_ISC0                   ((volatile ISC0_STRUCT*)&EICRA)->__ISC0
// INT1 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT1] Enables the interrupt on the INT pin
#define	_INT1                   ((volatile BYTE_STRUCT*)&EIMSK)->bit1
// INT1 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC1" EICRA.(ISC10 | ISC11)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__ISC1            : 2;
} ISC1_STRUCT;

#define	_ISC1                   ((volatile ISC1_STRUCT*)&EICRA)->__ISC1
// INT2 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT2] Enables the interrupt on the INT pin
#define	_INT2                   ((volatile BYTE_STRUCT*)&EIMSK)->bit2
// INT2 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC2" EICRA.(ISC20 | ISC21)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__ISC2            : 2;
} ISC2_STRUCT;

#define	_ISC2                   ((volatile ISC2_STRUCT*)&EICRA)->__ISC2
// INT3 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT3] Enables the interrupt on the INT pin
#define	_INT3                   ((volatile BYTE_STRUCT*)&EIMSK)->bit3
// INT3 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC3" EICRA.(ISC30 | ISC31)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__ISC3            : 2;
} ISC3_STRUCT;

#define	_ISC3                   ((volatile ISC3_STRUCT*)&EICRA)->__ISC3
// INT4 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT4] Enables the interrupt on the INT pin
#define	_INT4                   ((volatile BYTE_STRUCT*)&EIMSK)->bit4
// INT4 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC4" EICRB.(ISC40 | ISC41)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__ISC4            : 2;
} ISC4_STRUCT;

#define	_ISC4                   ((volatile ISC4_STRUCT*)&EICRB)->__ISC4
// INT5 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT5] Enables the interrupt on the INT pin
#define	_INT5                   ((volatile BYTE_STRUCT*)&EIMSK)->bit5
// INT5 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC5" EICRB.(ISC50 | ISC51)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__ISC5            : 2;
} ISC5_STRUCT;

#define	_ISC5                   ((volatile ISC5_STRUCT*)&EICRB)->__ISC5
// INT6 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT6] Enables the interrupt on the INT pin
#define	_INT6                   ((volatile BYTE_STRUCT*)&EIMSK)->bit6
// INT6 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC6" EICRB.(ISC60 | ISC61)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__ISC6            : 2;
} ISC6_STRUCT;

#define	_ISC6                   ((volatile ISC6_STRUCT*)&EICRB)->__ISC6
// INT7 Interrupt Enable - Enabling_ENUM - [bit EIMSK.INT7] Enables the interrupt on the INT pin
#define	_INT7                   ((volatile BYTE_STRUCT*)&EIMSK)->bit7
// INT7 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC7" EICRB.(ISC70 | ISC71)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__ISC7            : 2;
} ISC7_STRUCT;

#define	_ISC7                   ((volatile ISC7_STRUCT*)&EICRB)->__ISC7
// PCINT0 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT0] Enables interrupts on PCINT0
#define	_PCINT0                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit0
// PCINT1 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT1] Enables interrupts on PCINT1
#define	_PCINT1                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit1
// PCINT2 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT2] Enables interrupts on PCINT2
#define	_PCINT2                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit2
// PCINT3 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT3] Enables interrupts on PCINT3
#define	_PCINT3                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit3
// PCINT4 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT4] Enables interrupts on PCINT4
#define	_PCINT4                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit4
// PCINT5 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT5] Enables interrupts on PCINT5
#define	_PCINT5                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit5
// PCINT6 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT6] Enables interrupts on PCINT6
#define	_PCINT6                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit6
// PCINT7 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT7] Enables interrupts on PCINT7
#define	_PCINT7                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit7
// PCINT8 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT8] Enables interrupts on PCINT8
#define	_PCINT8                 ((volatile BYTE_STRUCT*)&PCMSK1)->bit0
// PCINT9 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT9] Enables interrupts on PCINT9
#define	_PCINT9                 ((volatile BYTE_STRUCT*)&PCMSK1)->bit1
// PCINT10 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT10] Enables interrupts on PCINT10
#define	_PCINT10                ((volatile BYTE_STRUCT*)&PCMSK1)->bit2
// PCINT11 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT11] Enables interrupts on PCINT11
#define	_PCINT11                ((volatile BYTE_STRUCT*)&PCMSK1)->bit3
// PCINT12 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT12] Enables interrupts on PCINT12
#define	_PCINT12                ((volatile BYTE_STRUCT*)&PCMSK1)->bit4
// PCINT13 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT13] Enables interrupts on PCINT13
#define	_PCINT13                ((volatile BYTE_STRUCT*)&PCMSK1)->bit5
// PCINT14 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT14] Enables interrupts on PCINT14
#define	_PCINT14                ((volatile BYTE_STRUCT*)&PCMSK1)->bit6
// PCINT15 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT15] Enables interrupts on PCINT15
#define	_PCINT15                ((volatile BYTE_STRUCT*)&PCMSK1)->bit7
// PCINT16 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT16] Enables interrupts on PCINT16
#define	_PCINT16                ((volatile BYTE_STRUCT*)&PCMSK2)->bit0
// PCINT17 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT17] Enables interrupts on PCINT17
#define	_PCINT17                ((volatile BYTE_STRUCT*)&PCMSK2)->bit1
// PCINT18 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT18] Enables interrupts on PCINT18
#define	_PCINT18                ((volatile BYTE_STRUCT*)&PCMSK2)->bit2
// PCINT19 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT19] Enables interrupts on PCINT19
#define	_PCINT19                ((volatile BYTE_STRUCT*)&PCMSK2)->bit3
// PCINT20 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT20] Enables interrupts on PCINT20
#define	_PCINT20                ((volatile BYTE_STRUCT*)&PCMSK2)->bit4
// PCINT21 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT21] Enables interrupts on PCINT21
#define	_PCINT21                ((volatile BYTE_STRUCT*)&PCMSK2)->bit5
// PCINT22 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT22] Enables interrupts on PCINT22
#define	_PCINT22                ((volatile BYTE_STRUCT*)&PCMSK2)->bit6
// PCINT23 Interrupt Enable - Enabling_ENUM - [bit PCMSK2.PCINT23] Enables interrupts on PCINT23
#define	_PCINT23                ((volatile BYTE_STRUCT*)&PCMSK2)->bit7
// PCIE0 Interrupt Enable - Enabling_ENUM - [bit PCICR.PCIE0] Enables interrupts for PCINT7..0
#define	_PCIE0                  ((volatile BYTE_STRUCT*)&PCICR)->bit0
// PCIE1 Interrupt Enable - Enabling_ENUM - [bit PCICR.PCIE1] Enables interrupts for PCINT15..8
#define	_PCIE1                  ((volatile BYTE_STRUCT*)&PCICR)->bit1
// PCIE2 Interrupt Enable - Enabling_ENUM - [bit PCICR.PCIE2] Enables interrupts for PCINT23..16
#define	_PCIE2                  ((volatile BYTE_STRUCT*)&PCICR)->bit2

// other EXTERNAL_INTERRUPT bit definitions
#define	_ISC31                  ((volatile BYTE_STRUCT*)&EICRA)->bit7
#define	_ISC30                  ((volatile BYTE_STRUCT*)&EICRA)->bit6
#define	_ISC21                  ((volatile BYTE_STRUCT*)&EICRA)->bit5
#define	_ISC20                  ((volatile BYTE_STRUCT*)&EICRA)->bit4
#define	_ISC11                  ((volatile BYTE_STRUCT*)&EICRA)->bit3
#define	_ISC10                  ((volatile BYTE_STRUCT*)&EICRA)->bit2
#define	_ISC01                  ((volatile BYTE_STRUCT*)&EICRA)->bit1
#define	_ISC00                  ((volatile BYTE_STRUCT*)&EICRA)->bit0
#define	_ISC71                  ((volatile BYTE_STRUCT*)&EICRB)->bit7
#define	_ISC70                  ((volatile BYTE_STRUCT*)&EICRB)->bit6
#define	_ISC61                  ((volatile BYTE_STRUCT*)&EICRB)->bit5
#define	_ISC60                  ((volatile BYTE_STRUCT*)&EICRB)->bit4
#define	_ISC51                  ((volatile BYTE_STRUCT*)&EICRB)->bit3
#define	_ISC50                  ((volatile BYTE_STRUCT*)&EICRB)->bit2
#define	_ISC41                  ((volatile BYTE_STRUCT*)&EICRB)->bit1
#define	_ISC40                  ((volatile BYTE_STRUCT*)&EICRB)->bit0
#define	_INTF7                  ((volatile BYTE_STRUCT*)&EIFR)->bit7
#define	_INTF6                  ((volatile BYTE_STRUCT*)&EIFR)->bit6
#define	_INTF5                  ((volatile BYTE_STRUCT*)&EIFR)->bit5
#define	_INTF4                  ((volatile BYTE_STRUCT*)&EIFR)->bit4
#define	_INTF3                  ((volatile BYTE_STRUCT*)&EIFR)->bit3
#define	_INTF2                  ((volatile BYTE_STRUCT*)&EIFR)->bit2
#define	_INTF1                  ((volatile BYTE_STRUCT*)&EIFR)->bit1
#define	_INTF0                  ((volatile BYTE_STRUCT*)&EIFR)->bit0
#define	_PCIF2                  ((volatile BYTE_STRUCT*)&PCIFR)->bit2
#define	_PCIF1                  ((volatile BYTE_STRUCT*)&PCIFR)->bit1
#define	_PCIF0                  ((volatile BYTE_STRUCT*)&PCIFR)->bit0

//
// JTAG variable definitions
//
// JTAG Disable - Disabling_ENUM - [bit MCUCR.JTD] Disables JTAG operation.

// other JTAG bit definitions

//
// SPI variable definitions
//
// SPI Enable - Enabling_ENUM - [bit SPCR.SPE]
#define	_SPE                    ((volatile BYTE_STRUCT*)&SPCR)->bit6
// Master/Slave Mode - SPIMaster_ENUM - [bit SPCR.MSTR]
#define	_MSTR                   ((volatile BYTE_STRUCT*)&SPCR)->bit4
// Clock Rate Select - SPR_ENUM - [bit aggregate (SPCR.SPR0 | SPCR.SPR1 | SPSR.SPI2X)] Controls the SCK rate of the device configured as a Master.
#define	_SPR0                   ((volatile BYTE_STRUCT*)&SPCR)->bit0
#define	_SPR1                   ((volatile BYTE_STRUCT*)&SPCR)->bit1
#define	_SPI2X                  ((volatile BYTE_STRUCT*)&SPSR)->bit0
inline SPR_ENUM get_SPR(){ return (SPR_ENUM)(_SPR0|(_SPR1 << 1)|(_SPI2X << 2)); }
inline void set_SPR(SPR_ENUM v){ _SPR0 = v; _SPR1 = v >> 1; _SPI2X = v >> 2; }
// SPI Mode - SPIMode_ENUM - [bit field "MODE" SPCR.(CPHA | CPOL)] Sets the relationship between data output change and data input sample, and the synchronous clock (SCK).

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__MODE            : 2;
} MODE_STRUCT;

#define	_MODE                   ((volatile MODE_STRUCT*)&SPCR)->__MODE
// Data Order - SPIDataOrder_ENUM - [bit SPCR.DORD] Sets the order in which bits are transmitted.
#define	_DORD                   ((volatile BYTE_STRUCT*)&SPCR)->bit5
// SPI Interrupt Enable - Enabling_ENUM - [bit SPCR.SPIE]
#define	_SPIE                   ((volatile BYTE_STRUCT*)&SPCR)->bit7

// other SPI bit definitions
#define	_SPIF                   ((volatile BYTE_STRUCT*)&SPSR)->bit7
#define	_WCOL                   ((volatile BYTE_STRUCT*)&SPSR)->bit6
#define	_CPOL                   ((volatile BYTE_STRUCT*)&SPCR)->bit3
#define	_CPHA                   ((volatile BYTE_STRUCT*)&SPCR)->bit2

//
// TIMER_COUNTER_0 variable definitions
//
// Waveform Generation Mode - WGM0_WGM_ENUM - [bit aggregate (TCCR0A.WGM00 | TCCR0A.WGM01 | TCCR0B.WGM02)] Controls how the counter will cycle.
typedef enum
{
	WGM0_WGM_Normal,                    	// Normal
	WGM0_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM0_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM0_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM0_WGM_Reserved,                  	// Reserved
	WGM0_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM0_WGM_Reserved2,                 	// Reserved
	WGM0_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM0_WGM_ENUM;
#define	_WGM00                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit0
#define	_WGM01                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit1
#define	_WGM02                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit3
inline WGM0_WGM_ENUM get_WGM0(){ return (WGM0_WGM_ENUM)(_WGM00|(_WGM01 << 1)|(_WGM02 << 2)); }
inline void set_WGM0(WGM0_WGM_ENUM v){ _WGM00 = v; _WGM01 = v >> 1; _WGM02 = v >> 2; }
// Clock Select - CS0_CS_ENUM - [bit field "CS0" TCCR0B.(CS00 | CS01 | CS02)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS0_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS0_CS_DIV_1,                       	// clk (No prescaling)
	CS0_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS0_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS0_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS0_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS0_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS0_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS0_CS_ENUM;

typedef struct
{
	unsigned char	__CS0             : 3;
} CS0_STRUCT;

#define	_CS0                    ((volatile CS0_STRUCT*)&TCCR0B)->__CS0
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK0.TOIE0]
#define	_TOIE0                  ((volatile BYTE_STRUCT*)&TIMSK0)->bit0
// Compare Output Mode A - _ENUM - [bit field "COMA0" TCCR0A.(COM0A0 | COM0A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA0           : 2;
} COMA0_STRUCT;

#define	_COMA0                  ((volatile COMA0_STRUCT*)&TCCR0A)->__COMA0
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK0.OCIE0A]
#define	_OCIE0A                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB0" TCCR0A.(COM0B0 | COM0B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB0           : 2;
} COMB0_STRUCT;

#define	_COMB0                  ((volatile COMB0_STRUCT*)&TCCR0A)->__COMB0
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK0.OCIE0B]
#define	_OCIE0B                 ((volatile BYTE_STRUCT*)&TIMSK0)->bit2

// other TIMER_COUNTER_0 bit definitions
#define	_OCF0B                  ((volatile BYTE_STRUCT*)&TIFR0)->bit2
#define	_OCF0A                  ((volatile BYTE_STRUCT*)&TIFR0)->bit1
#define	_TOV0                   ((volatile BYTE_STRUCT*)&TIFR0)->bit0
#define	_COM0A1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit7
#define	_COM0A0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit6
#define	_COM0B1                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit5
#define	_COM0B0                 ((volatile BYTE_STRUCT*)&TCCR0A)->bit4
#define	_FOC0A                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit7
#define	_FOC0B                  ((volatile BYTE_STRUCT*)&TCCR0B)->bit6
#define	_CS02                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit2
#define	_CS01                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit1
#define	_CS00                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit0
#define	_TSM                    ((volatile BYTE_STRUCT*)&GTCCR)->bit7
#define	_PSRSYNC                ((volatile BYTE_STRUCT*)&GTCCR)->bit0

//
// TIMER_COUNTER_1 variable definitions
//
// Waveform Generation Mode - WGM1_WGM_ENUM - [bit aggregate (TCCR1A.WGM10 | TCCR1A.WGM11 | TCCR1B.WGM12 | TCCR1B.WGM13)] Controls how the counter will cycle.
typedef enum
{
	WGM1_WGM_Normal,                    	// Normal
	WGM1_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM1_WGM_PWMPhaseCorrect9bit,       	// PWM Phase Correct, 9-bit TOP=0x1FF
	WGM1_WGM_PWMPhaseCorrect10bit,      	// PWM Phase Correct, 10-bit TOP=0x3FF
	WGM1_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM1_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM1_WGM_FastPWM9bit,               	// Fast PWM, 9-bit TOP=0x1FF
	WGM1_WGM_FastPWM10bit,              	// Fast PWM, 10-bit TOP=0x3FF
	WGM1_WGM_PWMPhaseFreqCorrect_ICR,   	// PWM Phase and Freq Correct, TOP=ICR
	WGM1_WGM_PWMPhaseFreqCorrect_OCR,   	// PWM Phase and Freq Correct, TOP=OCRA
	WGM1_WGM_PWMPhaseCorrect_ICR,       	// PWM Phase Correct, TOP=ICR
	WGM1_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM1_WGM_CTC_ICR,                   	// Clear Timer on Compare Match TOP=ICR
	WGM1_WGM_Reserved,                  	// Reserved
	WGM1_WGM_FastPWM_ICR,               	// Fast PWM TOP=ICR
	WGM1_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM1_WGM_ENUM;
#define	_WGM10                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit0
#define	_WGM11                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit1
#define	_WGM12                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit3
#define	_WGM13                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit4
inline WGM1_WGM_ENUM get_WGM1(){ return (WGM1_WGM_ENUM)(_WGM10|(_WGM11 << 1)|(_WGM12 << 2)|(_WGM13 << 3)); }
inline void set_WGM1(WGM1_WGM_ENUM v){ _WGM10 = v; _WGM11 = v >> 1; _WGM12 = v >> 2; _WGM13 = v >> 3; }
// Clock Select - CS1_CS_ENUM - [bit field "CS1" TCCR1B.(CS10 | CS11 | CS12)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS1_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS1_CS_DIV_1,                       	// clk (No prescaling)
	CS1_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS1_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS1_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS1_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS1_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS1_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS1_CS_ENUM;

typedef struct
{
	unsigned char	__CS1             : 3;
} CS1_STRUCT;

#define	_CS1                    ((volatile CS1_STRUCT*)&TCCR1B)->__CS1
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK1.TOIE1]
#define	_TOIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit0
// Input Capture Noise Cancel - Enabling_ENUM - [bit TCCR1B.ICNC1]
#define	_ICNC1                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit7
// Input Capture Edge Select - Trigger_ENUM - [bit TCCR1B.ICES1]
#define	_ICES1                  ((volatile BYTE_STRUCT*)&TCCR1B)->bit6
// Input Capture Interrupt Enable - Enabling_ENUM - [bit TIMSK1.ICIE1]
#define	_ICIE1                  ((volatile BYTE_STRUCT*)&TIMSK1)->bit5
// Compare Output Mode A - _ENUM - [bit field "COMA1" TCCR1A.(COM1A0 | COM1A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA1           : 2;
} COMA1_STRUCT;

#define	_COMA1                  ((volatile COMA1_STRUCT*)&TCCR1A)->__COMA1
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK1.OCIE1A]
#define	_OCIE1A                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB1" TCCR1A.(COM1B0 | COM1B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB1           : 2;
} COMB1_STRUCT;

#define	_COMB1                  ((volatile COMB1_STRUCT*)&TCCR1A)->__COMB1
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK1.OCIE1B]
#define	_OCIE1B                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit2
// Compare Output Mode C - _ENUM - [bit field "COMC1" TCCR1A.(COM1C0 | COM1C1)] Controls the Output Compare pin (OCnC) behavior.

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__COMC1           : 2;
} COMC1_STRUCT;

#define	_COMC1                  ((volatile COMC1_STRUCT*)&TCCR1A)->__COMC1
// Output Compare Match Interrupt Enable C - Enabling_ENUM - [bit TIMSK1.OCIE1C]
#define	_OCIE1C                 ((volatile BYTE_STRUCT*)&TIMSK1)->bit3

// other TIMER_COUNTER_1 bit definitions
#define	_ICF1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit5
#define	_OCF1C                  ((volatile BYTE_STRUCT*)&TIFR1)->bit3
#define	_OCF1B                  ((volatile BYTE_STRUCT*)&TIFR1)->bit2
#define	_OCF1A                  ((volatile BYTE_STRUCT*)&TIFR1)->bit1
#define	_TOV1                   ((volatile BYTE_STRUCT*)&TIFR1)->bit0
#define	_COM1A1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit7
#define	_COM1A0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit6
#define	_COM1B1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit5
#define	_COM1B0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit4
#define	_COM1C1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit3
#define	_COM1C0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit2
#define	_CS12                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit2
#define	_CS11                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit1
#define	_CS10                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit0
#define	_FOC1A                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit7
#define	_FOC1B                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit6
#define	_FOC1C                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit5

//
// TIMER_COUNTER_2 variable definitions
//
// Waveform Generation Mode - WGM2_WGM_ENUM - [bit aggregate (TCCR2A.WGM20 | TCCR2A.WGM21 | TCCR2B.WGM22)] Controls how the counter will cycle.
typedef enum
{
	WGM2_WGM_Normal,                    	// Normal
	WGM2_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM2_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM2_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM2_WGM_Reserved,                  	// Reserved
	WGM2_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM2_WGM_Reserved2,                 	// Reserved
	WGM2_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM2_WGM_ENUM;
#define	_WGM20                  ((volatile BYTE_STRUCT*)&TCCR2A)->bit0
#define	_WGM21                  ((volatile BYTE_STRUCT*)&TCCR2A)->bit1
#define	_WGM22                  ((volatile BYTE_STRUCT*)&TCCR2B)->bit3
inline WGM2_WGM_ENUM get_WGM2(){ return (WGM2_WGM_ENUM)(_WGM20|(_WGM21 << 1)|(_WGM22 << 2)); }
inline void set_WGM2(WGM2_WGM_ENUM v){ _WGM20 = v; _WGM21 = v >> 1; _WGM22 = v >> 2; }
// Clock Select - CS2_CS_ENUM - [bit field "CS2" TCCR2B.(CS20 | CS21 | CS22)] Selects the clock divisor.
typedef enum
{
	CS2_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS2_CS_DIV_1,                       	// clk (No prescaling)
	CS2_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS2_CS_DIV_32,                      	// clk / 32 (From prescaler)
	CS2_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS2_CS_DIV_128,                     	// clk / 128 (From prescaler)
	CS2_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS2_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
} CS2_CS_ENUM;

typedef struct
{
	unsigned char	__CS2             : 3;
} CS2_STRUCT;

#define	_CS2                    ((volatile CS2_STRUCT*)&TCCR2B)->__CS2
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK2.TOIE2]
#define	_TOIE2                  ((volatile BYTE_STRUCT*)&TIMSK2)->bit0
// Compare Output Mode A - _ENUM - [bit field "COMA2" TCCR2A.(COM2A0 | COM2A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA2           : 2;
} COMA2_STRUCT;

#define	_COMA2                  ((volatile COMA2_STRUCT*)&TCCR2A)->__COMA2
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK2.OCIE2A]
#define	_OCIE2A                 ((volatile BYTE_STRUCT*)&TIMSK2)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB2" TCCR2A.(COM2B0 | COM2B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB2           : 2;
} COMB2_STRUCT;

#define	_COMB2                  ((volatile COMB2_STRUCT*)&TCCR2A)->__COMB2
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK2.OCIE2B]
#define	_OCIE2B                 ((volatile BYTE_STRUCT*)&TIMSK2)->bit2

// other TIMER_COUNTER_2 bit definitions
#define	_OCF2B                  ((volatile BYTE_STRUCT*)&TIFR2)->bit2
#define	_OCF2A                  ((volatile BYTE_STRUCT*)&TIFR2)->bit1
#define	_TOV2                   ((volatile BYTE_STRUCT*)&TIFR2)->bit0
#define	_COM2A1                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit7
#define	_COM2A0                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit6
#define	_COM2B1                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit5
#define	_COM2B0                 ((volatile BYTE_STRUCT*)&TCCR2A)->bit4
#define	_FOC2A                  ((volatile BYTE_STRUCT*)&TCCR2B)->bit7
#define	_FOC2B                  ((volatile BYTE_STRUCT*)&TCCR2B)->bit6
#define	_CS22                   ((volatile BYTE_STRUCT*)&TCCR2B)->bit2
#define	_CS21                   ((volatile BYTE_STRUCT*)&TCCR2B)->bit1
#define	_CS20                   ((volatile BYTE_STRUCT*)&TCCR2B)->bit0
#define	_EXCLK                  ((volatile BYTE_STRUCT*)&ASSR)->bit6
#define	_AS2                    ((volatile BYTE_STRUCT*)&ASSR)->bit5
#define	_TCN2UB                 ((volatile BYTE_STRUCT*)&ASSR)->bit4
#define	_OCR2AUB                ((volatile BYTE_STRUCT*)&ASSR)->bit3
#define	_OCR2BUB                ((volatile BYTE_STRUCT*)&ASSR)->bit2
#define	_TCR2AUB                ((volatile BYTE_STRUCT*)&ASSR)->bit1
#define	_TCR2BUB                ((volatile BYTE_STRUCT*)&ASSR)->bit0
#define	_PSRASY                 ((volatile BYTE_STRUCT*)&GTCCR)->bit1

//
// TIMER_COUNTER_3 variable definitions
//
// Waveform Generation Mode - WGM3_WGM_ENUM - [bit aggregate (TCCR3A.WGM30 | TCCR3A.WGM31 | TCCR3B.WGM32 | TCCR3B.WGM33)] Controls how the counter will cycle.
typedef enum
{
	WGM3_WGM_Normal,                    	// Normal
	WGM3_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM3_WGM_PWMPhaseCorrect9bit,       	// PWM Phase Correct, 9-bit TOP=0x1FF
	WGM3_WGM_PWMPhaseCorrect10bit,      	// PWM Phase Correct, 10-bit TOP=0x3FF
	WGM3_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM3_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM3_WGM_FastPWM9bit,               	// Fast PWM, 9-bit TOP=0x1FF
	WGM3_WGM_FastPWM10bit,              	// Fast PWM, 10-bit TOP=0x3FF
	WGM3_WGM_PWMPhaseFreqCorrect_ICR,   	// PWM Phase and Freq Correct, TOP=ICR
	WGM3_WGM_PWMPhaseFreqCorrect_OCR,   	// PWM Phase and Freq Correct, TOP=OCRA
	WGM3_WGM_PWMPhaseCorrect_ICR,       	// PWM Phase Correct, TOP=ICR
	WGM3_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM3_WGM_CTC_ICR,                   	// Clear Timer on Compare Match TOP=ICR
	WGM3_WGM_Reserved,                  	// Reserved
	WGM3_WGM_FastPWM_ICR,               	// Fast PWM TOP=ICR
	WGM3_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM3_WGM_ENUM;
#define	_WGM30                  ((volatile BYTE_STRUCT*)&TCCR3A)->bit0
#define	_WGM31                  ((volatile BYTE_STRUCT*)&TCCR3A)->bit1
#define	_WGM32                  ((volatile BYTE_STRUCT*)&TCCR3B)->bit3
#define	_WGM33                  ((volatile BYTE_STRUCT*)&TCCR3B)->bit4
inline WGM3_WGM_ENUM get_WGM3(){ return (WGM3_WGM_ENUM)(_WGM30|(_WGM31 << 1)|(_WGM32 << 2)|(_WGM33 << 3)); }
inline void set_WGM3(WGM3_WGM_ENUM v){ _WGM30 = v; _WGM31 = v >> 1; _WGM32 = v >> 2; _WGM33 = v >> 3; }
// Clock Select - CS3_CS_ENUM - [bit field "CS3" TCCR3B.(CS30 | CS31 | CS32)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS3_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS3_CS_DIV_1,                       	// clk (No prescaling)
	CS3_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS3_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS3_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS3_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS3_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS3_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS3_CS_ENUM;

typedef struct
{
	unsigned char	__CS3             : 3;
} CS3_STRUCT;

#define	_CS3                    ((volatile CS3_STRUCT*)&TCCR3B)->__CS3
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK3.TOIE3]
#define	_TOIE3                  ((volatile BYTE_STRUCT*)&TIMSK3)->bit0
// Input Capture Noise Cancel - Enabling_ENUM - [bit TCCR3B.ICNC3]
#define	_ICNC3                  ((volatile BYTE_STRUCT*)&TCCR3B)->bit7
// Input Capture Edge Select - Trigger_ENUM - [bit TCCR3B.ICES3]
#define	_ICES3                  ((volatile BYTE_STRUCT*)&TCCR3B)->bit6
// Input Capture Interrupt Enable - Enabling_ENUM - [bit TIMSK3.ICIE3]
#define	_ICIE3                  ((volatile BYTE_STRUCT*)&TIMSK3)->bit5
// Compare Output Mode A - _ENUM - [bit field "COMA3" TCCR3A.(COM3A0 | COM3A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA3           : 2;
} COMA3_STRUCT;

#define	_COMA3                  ((volatile COMA3_STRUCT*)&TCCR3A)->__COMA3
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK3.OCIE3A]
#define	_OCIE3A                 ((volatile BYTE_STRUCT*)&TIMSK3)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB3" TCCR3A.(COM3B0 | COM3B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB3           : 2;
} COMB3_STRUCT;

#define	_COMB3                  ((volatile COMB3_STRUCT*)&TCCR3A)->__COMB3
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK3.OCIE3B]
#define	_OCIE3B                 ((volatile BYTE_STRUCT*)&TIMSK3)->bit2
// Compare Output Mode C - _ENUM - [bit field "COMC3" TCCR3A.(COM3C0 | COM3C1)] Controls the Output Compare pin (OCnC) behavior.

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__COMC3           : 2;
} COMC3_STRUCT;

#define	_COMC3                  ((volatile COMC3_STRUCT*)&TCCR3A)->__COMC3
// Output Compare Match Interrupt Enable C - Enabling_ENUM - [bit TIMSK3.OCIE3C]
#define	_OCIE3C                 ((volatile BYTE_STRUCT*)&TIMSK3)->bit3

// other TIMER_COUNTER_3 bit definitions
#define	_ICF3                   ((volatile BYTE_STRUCT*)&TIFR3)->bit5
#define	_OCF3C                  ((volatile BYTE_STRUCT*)&TIFR3)->bit3
#define	_OCF3B                  ((volatile BYTE_STRUCT*)&TIFR3)->bit2
#define	_OCF3A                  ((volatile BYTE_STRUCT*)&TIFR3)->bit1
#define	_TOV3                   ((volatile BYTE_STRUCT*)&TIFR3)->bit0
#define	_COM3A1                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit7
#define	_COM3A0                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit6
#define	_COM3B1                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit5
#define	_COM3B0                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit4
#define	_COM3C1                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit3
#define	_COM3C0                 ((volatile BYTE_STRUCT*)&TCCR3A)->bit2
#define	_CS32                   ((volatile BYTE_STRUCT*)&TCCR3B)->bit2
#define	_CS31                   ((volatile BYTE_STRUCT*)&TCCR3B)->bit1
#define	_CS30                   ((volatile BYTE_STRUCT*)&TCCR3B)->bit0
#define	_FOC3A                  ((volatile BYTE_STRUCT*)&TCCR3C)->bit7
#define	_FOC3B                  ((volatile BYTE_STRUCT*)&TCCR3C)->bit6
#define	_FOC3C                  ((volatile BYTE_STRUCT*)&TCCR3C)->bit5

//
// TIMER_COUNTER_4 variable definitions
//
// Waveform Generation Mode - WGM4_WGM_ENUM - [bit aggregate (TCCR4A.WGM40 | TCCR4A.WGM41 | TCCR4B.WGM42 | TCCR4B.WGM43)] Controls how the counter will cycle.
typedef enum
{
	WGM4_WGM_Normal,                    	// Normal
	WGM4_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM4_WGM_PWMPhaseCorrect9bit,       	// PWM Phase Correct, 9-bit TOP=0x1FF
	WGM4_WGM_PWMPhaseCorrect10bit,      	// PWM Phase Correct, 10-bit TOP=0x3FF
	WGM4_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM4_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM4_WGM_FastPWM9bit,               	// Fast PWM, 9-bit TOP=0x1FF
	WGM4_WGM_FastPWM10bit,              	// Fast PWM, 10-bit TOP=0x3FF
	WGM4_WGM_PWMPhaseFreqCorrect_ICR,   	// PWM Phase and Freq Correct, TOP=ICR
	WGM4_WGM_PWMPhaseFreqCorrect_OCR,   	// PWM Phase and Freq Correct, TOP=OCRA
	WGM4_WGM_PWMPhaseCorrect_ICR,       	// PWM Phase Correct, TOP=ICR
	WGM4_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM4_WGM_CTC_ICR,                   	// Clear Timer on Compare Match TOP=ICR
	WGM4_WGM_Reserved,                  	// Reserved
	WGM4_WGM_FastPWM_ICR,               	// Fast PWM TOP=ICR
	WGM4_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM4_WGM_ENUM;
#define	_WGM40                  ((volatile BYTE_STRUCT*)&TCCR4A)->bit0
#define	_WGM41                  ((volatile BYTE_STRUCT*)&TCCR4A)->bit1
#define	_WGM42                  ((volatile BYTE_STRUCT*)&TCCR4B)->bit3
#define	_WGM43                  ((volatile BYTE_STRUCT*)&TCCR4B)->bit4
inline WGM4_WGM_ENUM get_WGM4(){ return (WGM4_WGM_ENUM)(_WGM40|(_WGM41 << 1)|(_WGM42 << 2)|(_WGM43 << 3)); }
inline void set_WGM4(WGM4_WGM_ENUM v){ _WGM40 = v; _WGM41 = v >> 1; _WGM42 = v >> 2; _WGM43 = v >> 3; }
// Clock Select - CS4_CS_ENUM - [bit field "CS4" TCCR4B.(CS40 | CS41 | CS42)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS4_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS4_CS_DIV_1,                       	// clk (No prescaling)
	CS4_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS4_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS4_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS4_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS4_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS4_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS4_CS_ENUM;

typedef struct
{
	unsigned char	__CS4             : 3;
} CS4_STRUCT;

#define	_CS4                    ((volatile CS4_STRUCT*)&TCCR4B)->__CS4
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK4.TOIE4]
#define	_TOIE4                  ((volatile BYTE_STRUCT*)&TIMSK4)->bit0
// Input Capture Noise Cancel - Enabling_ENUM - [bit TCCR4B.ICNC4]
#define	_ICNC4                  ((volatile BYTE_STRUCT*)&TCCR4B)->bit7
// Input Capture Edge Select - Trigger_ENUM - [bit TCCR4B.ICES4]
#define	_ICES4                  ((volatile BYTE_STRUCT*)&TCCR4B)->bit6
// Input Capture Interrupt Enable - Enabling_ENUM - [bit TIMSK4.ICIE4]
#define	_ICIE4                  ((volatile BYTE_STRUCT*)&TIMSK4)->bit5
// Compare Output Mode A - _ENUM - [bit field "COMA4" TCCR4A.(COM4A0 | COM4A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA4           : 2;
} COMA4_STRUCT;

#define	_COMA4                  ((volatile COMA4_STRUCT*)&TCCR4A)->__COMA4
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK4.OCIE4A]
#define	_OCIE4A                 ((volatile BYTE_STRUCT*)&TIMSK4)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB4" TCCR4A.(COM4B0 | COM4B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB4           : 2;
} COMB4_STRUCT;

#define	_COMB4                  ((volatile COMB4_STRUCT*)&TCCR4A)->__COMB4
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK4.OCIE4B]
#define	_OCIE4B                 ((volatile BYTE_STRUCT*)&TIMSK4)->bit2
// Compare Output Mode C - _ENUM - [bit field "COMC4" TCCR4A.(COM4C0 | COM4C1)] Controls the Output Compare pin (OCnC) behavior.

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__COMC4           : 2;
} COMC4_STRUCT;

#define	_COMC4                  ((volatile COMC4_STRUCT*)&TCCR4A)->__COMC4
// Output Compare Match Interrupt Enable C - Enabling_ENUM - [bit TIMSK4.OCIE4C]
#define	_OCIE4C                 ((volatile BYTE_STRUCT*)&TIMSK4)->bit3

// other TIMER_COUNTER_4 bit definitions
#define	_ICF4                   ((volatile BYTE_STRUCT*)&TIFR4)->bit5
#define	_OCF4C                  ((volatile BYTE_STRUCT*)&TIFR4)->bit3
#define	_OCF4B                  ((volatile BYTE_STRUCT*)&TIFR4)->bit2
#define	_OCF4A                  ((volatile BYTE_STRUCT*)&TIFR4)->bit1
#define	_TOV4                   ((volatile BYTE_STRUCT*)&TIFR4)->bit0
#define	_COM4A1                 ((volatile BYTE_STRUCT*)&TCCR4A)->bit7
#define	_COM4A0                 ((volatile BYTE_STRUCT*)&TCCR4A)->bit6
#define	_COM4B1                 ((volatile BYTE_STRUCT*)&TCCR4A)->bit5
#define	_COM4B0                 ((volatile BYTE_STRUCT*)&TCCR4A)->bit4
#define	_COM4C1                 ((volatile BYTE_STRUCT*)&TCCR4A)->bit3
#define	_COM4C0                 ((volatile BYTE_STRUCT*)&TCCR4A)->bit2
#define	_CS42                   ((volatile BYTE_STRUCT*)&TCCR4B)->bit2
#define	_CS41                   ((volatile BYTE_STRUCT*)&TCCR4B)->bit1
#define	_CS40                   ((volatile BYTE_STRUCT*)&TCCR4B)->bit0
#define	_FOC4A                  ((volatile BYTE_STRUCT*)&TCCR4C)->bit7
#define	_FOC4B                  ((volatile BYTE_STRUCT*)&TCCR4C)->bit6
#define	_FOC4C                  ((volatile BYTE_STRUCT*)&TCCR4C)->bit5

//
// TIMER_COUNTER_5 variable definitions
//
// Waveform Generation Mode - WGM5_WGM_ENUM - [bit aggregate (TCCR5A.WGM50 | TCCR5A.WGM51 | TCCR5B.WGM52 | TCCR5B.WGM53)] Controls how the counter will cycle.
typedef enum
{
	WGM5_WGM_Normal,                    	// Normal
	WGM5_WGM_PWMPhaseCorrect8bit,       	// PWM Phase Correct, 8-bit TOP=0xFF
	WGM5_WGM_PWMPhaseCorrect9bit,       	// PWM Phase Correct, 9-bit TOP=0x1FF
	WGM5_WGM_PWMPhaseCorrect10bit,      	// PWM Phase Correct, 10-bit TOP=0x3FF
	WGM5_WGM_CTC_OCR,                   	// Clear Timer on Compare Match TOP=OCRA
	WGM5_WGM_FastPWM8bit,               	// Fast PWM, 8-bit TOP=0xFF
	WGM5_WGM_FastPWM9bit,               	// Fast PWM, 9-bit TOP=0x1FF
	WGM5_WGM_FastPWM10bit,              	// Fast PWM, 10-bit TOP=0x3FF
	WGM5_WGM_PWMPhaseFreqCorrect_ICR,   	// PWM Phase and Freq Correct, TOP=ICR
	WGM5_WGM_PWMPhaseFreqCorrect_OCR,   	// PWM Phase and Freq Correct, TOP=OCRA
	WGM5_WGM_PWMPhaseCorrect_ICR,       	// PWM Phase Correct, TOP=ICR
	WGM5_WGM_PWMPhaseCorrect_OCR,       	// PWM Phase Correct, TOP=OCRA
	WGM5_WGM_CTC_ICR,                   	// Clear Timer on Compare Match TOP=ICR
	WGM5_WGM_Reserved,                  	// Reserved
	WGM5_WGM_FastPWM_ICR,               	// Fast PWM TOP=ICR
	WGM5_WGM_FastPWM_OCR,               	// Fast PWM TOP=OCRA
} WGM5_WGM_ENUM;
#define	_WGM50                  ((volatile BYTE_STRUCT*)&TCCR5A)->bit0
#define	_WGM51                  ((volatile BYTE_STRUCT*)&TCCR5A)->bit1
#define	_WGM52                  ((volatile BYTE_STRUCT*)&TCCR5B)->bit3
#define	_WGM53                  ((volatile BYTE_STRUCT*)&TCCR5B)->bit4
inline WGM5_WGM_ENUM get_WGM5(){ return (WGM5_WGM_ENUM)(_WGM50|(_WGM51 << 1)|(_WGM52 << 2)|(_WGM53 << 3)); }
inline void set_WGM5(WGM5_WGM_ENUM v){ _WGM50 = v; _WGM51 = v >> 1; _WGM52 = v >> 2; _WGM53 = v >> 3; }
// Clock Select - CS5_CS_ENUM - [bit field "CS5" TCCR5B.(CS50 | CS51 | CS52)] Selects the clock divisor or the external clock source.
typedef enum
{
	CS5_CS_None,                        	// No clock source (Timer/Counter stopped)
	CS5_CS_DIV_1,                       	// clk (No prescaling)
	CS5_CS_DIV_8,                       	// clk / 8 (From prescaler)
	CS5_CS_DIV_64,                      	// clk / 64 (From prescaler)
	CS5_CS_DIV_256,                     	// clk / 256 (From prescaler)
	CS5_CS_DIV_1024,                    	// clk / 1024 (From prescaler)
	CS5_CS_External_Falling,            	// External clock source, Clock on falling edge
	CS5_CS_External_Rising,             	// External clock source, Clock on rising edge
} CS5_CS_ENUM;

typedef struct
{
	unsigned char	__CS5             : 3;
} CS5_STRUCT;

#define	_CS5                    ((volatile CS5_STRUCT*)&TCCR5B)->__CS5
// Timer Overflow Interrupt Enable - Enabling_ENUM - [bit TIMSK5.TOIE5]
#define	_TOIE5                  ((volatile BYTE_STRUCT*)&TIMSK5)->bit0
// Input Capture Noise Cancel - Enabling_ENUM - [bit TCCR5B.ICNC5]
#define	_ICNC5                  ((volatile BYTE_STRUCT*)&TCCR5B)->bit7
// Input Capture Edge Select - Trigger_ENUM - [bit TCCR5B.ICES5]
#define	_ICES5                  ((volatile BYTE_STRUCT*)&TCCR5B)->bit6
// Input Capture Interrupt Enable - Enabling_ENUM - [bit TIMSK5.ICIE5]
#define	_ICIE5                  ((volatile BYTE_STRUCT*)&TIMSK5)->bit5
// Compare Output Mode A - _ENUM - [bit field "COMA5" TCCR5A.(COM5A0 | COM5A1)] Controls the Output Compare pin (OCnA) behavior.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__COMA5           : 2;
} COMA5_STRUCT;

#define	_COMA5                  ((volatile COMA5_STRUCT*)&TCCR5A)->__COMA5
// Output Compare Match Interrupt Enable A - Enabling_ENUM - [bit TIMSK5.OCIE5A]
#define	_OCIE5A                 ((volatile BYTE_STRUCT*)&TIMSK5)->bit1
// Compare Output Mode B - _ENUM - [bit field "COMB5" TCCR5A.(COM5B0 | COM5B1)] Controls the Output Compare pin (OCnB) behavior.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__COMB5           : 2;
} COMB5_STRUCT;

#define	_COMB5                  ((volatile COMB5_STRUCT*)&TCCR5A)->__COMB5
// Output Compare Match Interrupt Enable B - Enabling_ENUM - [bit TIMSK5.OCIE5B]
#define	_OCIE5B                 ((volatile BYTE_STRUCT*)&TIMSK5)->bit2
// Compare Output Mode C - _ENUM - [bit field "COMC5" TCCR5A.(COM5C0 | COM5C1)] Controls the Output Compare pin (OCnC) behavior.

typedef struct
{
	unsigned char	__Reserved        : 2;
	unsigned char	__COMC5           : 2;
} COMC5_STRUCT;

#define	_COMC5                  ((volatile COMC5_STRUCT*)&TCCR5A)->__COMC5
// Output Compare Match Interrupt Enable C - Enabling_ENUM - [bit TIMSK5.OCIE5C]
#define	_OCIE5C                 ((volatile BYTE_STRUCT*)&TIMSK5)->bit3

// other TIMER_COUNTER_5 bit definitions
#define	_ICF5                   ((volatile BYTE_STRUCT*)&TIFR5)->bit5
#define	_OCF5C                  ((volatile BYTE_STRUCT*)&TIFR5)->bit3
#define	_OCF5B                  ((volatile BYTE_STRUCT*)&TIFR5)->bit2
#define	_OCF5A                  ((volatile BYTE_STRUCT*)&TIFR5)->bit1
#define	_TOV5                   ((volatile BYTE_STRUCT*)&TIFR5)->bit0
#define	_COM5A1                 ((volatile BYTE_STRUCT*)&TCCR5A)->bit7
#define	_COM5A0                 ((volatile BYTE_STRUCT*)&TCCR5A)->bit6
#define	_COM5B1                 ((volatile BYTE_STRUCT*)&TCCR5A)->bit5
#define	_COM5B0                 ((volatile BYTE_STRUCT*)&TCCR5A)->bit4
#define	_COM5C1                 ((volatile BYTE_STRUCT*)&TCCR5A)->bit3
#define	_COM5C0                 ((volatile BYTE_STRUCT*)&TCCR5A)->bit2
#define	_CS52                   ((volatile BYTE_STRUCT*)&TCCR5B)->bit2
#define	_CS51                   ((volatile BYTE_STRUCT*)&TCCR5B)->bit1
#define	_CS50                   ((volatile BYTE_STRUCT*)&TCCR5B)->bit0
#define	_FOC5A                  ((volatile BYTE_STRUCT*)&TCCR5C)->bit7
#define	_FOC5B                  ((volatile BYTE_STRUCT*)&TCCR5C)->bit6
#define	_FOC5C                  ((volatile BYTE_STRUCT*)&TCCR5C)->bit5

//
// TWI variable definitions
//
// TWI Enable - Enabling_ENUM - [bit TWCR.TWEN] Enables TWI operation and activates the TWI interface.
#define	_TWEN                   ((volatile BYTE_STRUCT*)&TWCR)->bit2
// Bit Rate Prescaler - Prescaler_ENUM - [bit field "TWPS" TWSR.(TWPS0 | TWPS1)] Selects the prescaler division factor for the divider which generates the SCL clock frequency in the Master modes.

typedef struct
{
	unsigned char	__TWPS            : 2;
} TWPS_STRUCT;

#define	_TWPS                   ((volatile TWPS_STRUCT*)&TWSR)->__TWPS
// Address Register - _ENUM - [bit field "TWAR" TWAR.(TWA0 | TWA1 | TWA2 | TWA3 | TWA4 | TWA5 | TWA6)] Address to which the TWI will respond.

typedef struct
{
	unsigned char	__Reserved        : 1;
	unsigned char	__TWAR            : 7;
} TWAR_STRUCT;

#define	_TWAR                   ((volatile TWAR_STRUCT*)&TWAR)->__TWAR
// Address Mask Register - _ENUM - [bit field "TWAM" TWAMR.(TWAM0 | TWAM1 | TWAM2 | TWAM3 | TWAM4 | TWAM5 | TWAM6)] Each bit masks (disables) the corresponding bit in the Address Register. If the mask bit is set to one then the address match logic ignores the compare between the incoming address bit and the corresponding bit in the Address Register.

typedef struct
{
	unsigned char	__Reserved        : 1;
	unsigned char	__TWAM            : 7;
} TWAM_STRUCT;

#define	_TWAM                   ((volatile TWAM_STRUCT*)&TWAMR)->__TWAM
// General Call Recognition Enable - Enabling_ENUM - [bit TWAR.TWGCE] Enables the recognition of a General Call.
#define	_TWGCE                  ((volatile BYTE_STRUCT*)&TWAR)->bit0
// Enable Acknowledge - Enabling_ENUM - [bit TWCR.TWEA] Controls the generation of the acknowledge pulse.
#define	_TWEA                   ((volatile BYTE_STRUCT*)&TWCR)->bit6
// Interrupt Enable - Enabling_ENUM - [bit TWCR.TWIE] Enables the TWI interrupt.
#define	_TWIE                   ((volatile BYTE_STRUCT*)&TWCR)->bit0

// other TWI bit definitions
#define	_TWAM6                  ((volatile BYTE_STRUCT*)&TWAMR)->bit7
#define	_TWAM5                  ((volatile BYTE_STRUCT*)&TWAMR)->bit6
#define	_TWAM4                  ((volatile BYTE_STRUCT*)&TWAMR)->bit5
#define	_TWAM3                  ((volatile BYTE_STRUCT*)&TWAMR)->bit4
#define	_TWAM2                  ((volatile BYTE_STRUCT*)&TWAMR)->bit3
#define	_TWAM1                  ((volatile BYTE_STRUCT*)&TWAMR)->bit2
#define	_TWAM0                  ((volatile BYTE_STRUCT*)&TWAMR)->bit1
#define	_TWINT                  ((volatile BYTE_STRUCT*)&TWCR)->bit7
#define	_TWSTA                  ((volatile BYTE_STRUCT*)&TWCR)->bit5
#define	_TWSTO                  ((volatile BYTE_STRUCT*)&TWCR)->bit4
#define	_TWWC                   ((volatile BYTE_STRUCT*)&TWCR)->bit3
#define	_TWS7                   ((volatile BYTE_STRUCT*)&TWSR)->bit7
#define	_TWS6                   ((volatile BYTE_STRUCT*)&TWSR)->bit6
#define	_TWS5                   ((volatile BYTE_STRUCT*)&TWSR)->bit5
#define	_TWS4                   ((volatile BYTE_STRUCT*)&TWSR)->bit4
#define	_TWS3                   ((volatile BYTE_STRUCT*)&TWSR)->bit3
#define	_TWPS1                  ((volatile BYTE_STRUCT*)&TWSR)->bit1
#define	_TWPS0                  ((volatile BYTE_STRUCT*)&TWSR)->bit0
#define	_TWA6                   ((volatile BYTE_STRUCT*)&TWAR)->bit7
#define	_TWA5                   ((volatile BYTE_STRUCT*)&TWAR)->bit6
#define	_TWA4                   ((volatile BYTE_STRUCT*)&TWAR)->bit5
#define	_TWA3                   ((volatile BYTE_STRUCT*)&TWAR)->bit4
#define	_TWA2                   ((volatile BYTE_STRUCT*)&TWAR)->bit3
#define	_TWA1                   ((volatile BYTE_STRUCT*)&TWAR)->bit2
#define	_TWA0                   ((volatile BYTE_STRUCT*)&TWAR)->bit1

//
// USART0 variable definitions
//
// Receiver Enable - Enabling_ENUM - [bit UCSR0B.RXEN0]
#define	_RXEN0                  ((volatile BYTE_STRUCT*)&UCSR0B)->bit4
// Transmitter Enable - Enabling_ENUM - [bit UCSR0B.TXEN0]
#define	_TXEN0                  ((volatile BYTE_STRUCT*)&UCSR0B)->bit3
// Mode Select - UsartModeSelect_ENUM - [bit field "UMSEL0" UCSR0C.(UMSEL00 | UMSEL01)] Select between Asynchronous and Synchronous mode of operation.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__UMSEL0          : 2;
} UMSEL0_STRUCT;

#define	_UMSEL0                 ((volatile UMSEL0_STRUCT*)&UCSR0C)->__UMSEL0
// Double Transmission Speed - Enabling_ENUM - [bit UCSR0A.U2X0]
#define	_U2X0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit1
// Character Size - UsartCharacterSize_ENUM - [bit aggregate (UCSR0C.UCSZ00 | UCSR0C.UCSZ01 | UCSR0B.UCSZ02)] Set the number of data bits in a frame the Receiver and Transmitter use.
#define	_UCSZ00                 ((volatile BYTE_STRUCT*)&UCSR0C)->bit1
#define	_UCSZ01                 ((volatile BYTE_STRUCT*)&UCSR0C)->bit2
#define	_UCSZ02                 ((volatile BYTE_STRUCT*)&UCSR0B)->bit2
inline UsartCharacterSize_ENUM get_UCSZ0(){ return (UsartCharacterSize_ENUM)(_UCSZ00|(_UCSZ01 << 1)|(_UCSZ02 << 2)); }
inline void set_UCSZ0(UsartCharacterSize_ENUM v){ _UCSZ00 = v; _UCSZ01 = v >> 1; _UCSZ02 = v >> 2; }
// Stop Bit Select - UsartStopBitSelect_ENUM - [bit UCSR0C.USBS0] Selects the number of Stop Bits to be inserted by the Transmitter. The Receiver ignores this setting.
#define	_USBS0                  ((volatile BYTE_STRUCT*)&UCSR0C)->bit3
// Parity Mode - UsartParityMode_ENUM - [bit field "UPM0" UCSR0C.(UPM00 | UPM01)] Enable and set type of parity generation and check.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__UPM0            : 2;
} UPM0_STRUCT;

#define	_UPM0                   ((volatile UPM0_STRUCT*)&UCSR0C)->__UPM0
// Clock Polarity - UsartClockPolarity_ENUM - [bit UCSR0C.UCPOL0] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
#define	_UCPOL0                 ((volatile BYTE_STRUCT*)&UCSR0C)->bit0
// Multi-processor Communication Mode - Enabling_ENUM - [bit UCSR0A.MPCM0]
#define	_MPCM0                  ((volatile BYTE_STRUCT*)&UCSR0A)->bit0
// RX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR0B.RXCIE0]
#define	_RXCIE0                 ((volatile BYTE_STRUCT*)&UCSR0B)->bit7
// Data Order - SPIDataOrder_ENUM - [bit UCSR0C.UCSZ01] Sets the order in which bits are transmitted.
// SPI Mode - SPIMode_ENUM - [bit aggregate (UCSR0C.UCSZ00 | UCSR0C.UCPOL0)] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
inline SPIMode_ENUM get_SPIMODE0(){ return (SPIMode_ENUM)(_UCSZ00|(_UCPOL0 << 1)); }
inline void set_SPIMODE0(SPIMode_ENUM v){ _UCSZ00 = v; _UCPOL0 = v >> 1; }
// TX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR0B.TXCIE0]
#define	_TXCIE0                 ((volatile BYTE_STRUCT*)&UCSR0B)->bit6
// Data Register Empty Interrupt Enable - Enabling_ENUM - [bit UCSR0B.UDRIE0] Enable an interrupt when the transmit buffer (UDR) is ready to receive new data.
#define	_UDRIE0                 ((volatile BYTE_STRUCT*)&UCSR0B)->bit5

// other USART0 bit definitions
#define	_RXC0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit7
#define	_TXC0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit6
#define	_UDRE0                  ((volatile BYTE_STRUCT*)&UCSR0A)->bit5
#define	_FE0                    ((volatile BYTE_STRUCT*)&UCSR0A)->bit4
#define	_DOR0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit3
#define	_UPE0                   ((volatile BYTE_STRUCT*)&UCSR0A)->bit2
#define	_RXB80                  ((volatile BYTE_STRUCT*)&UCSR0B)->bit1
#define	_TXB80                  ((volatile BYTE_STRUCT*)&UCSR0B)->bit0
#define	_UMSEL01                ((volatile BYTE_STRUCT*)&UCSR0C)->bit7
#define	_UMSEL00                ((volatile BYTE_STRUCT*)&UCSR0C)->bit6
#define	_UPM01                  ((volatile BYTE_STRUCT*)&UCSR0C)->bit5
#define	_UPM00                  ((volatile BYTE_STRUCT*)&UCSR0C)->bit4

//
// USART1 variable definitions
//
// Receiver Enable - Enabling_ENUM - [bit UCSR1B.RXEN1]
#define	_RXEN1                  ((volatile BYTE_STRUCT*)&UCSR1B)->bit4
// Transmitter Enable - Enabling_ENUM - [bit UCSR1B.TXEN1]
#define	_TXEN1                  ((volatile BYTE_STRUCT*)&UCSR1B)->bit3
// Mode Select - UsartModeSelect_ENUM - [bit field "UMSEL1" UCSR1C.(UMSEL10 | UMSEL11)] Select between Asynchronous and Synchronous mode of operation.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__UMSEL1          : 2;
} UMSEL1_STRUCT;

#define	_UMSEL1                 ((volatile UMSEL1_STRUCT*)&UCSR1C)->__UMSEL1
// Double Transmission Speed - Enabling_ENUM - [bit UCSR1A.U2X1]
#define	_U2X1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit1
// Character Size - UsartCharacterSize_ENUM - [bit aggregate (UCSR1C.UCSZ10 | UCSR1C.UCSZ11 | UCSR1B.UCSZ12)] Set the number of data bits in a frame the Receiver and Transmitter use.
#define	_UCSZ10                 ((volatile BYTE_STRUCT*)&UCSR1C)->bit1
#define	_UCSZ11                 ((volatile BYTE_STRUCT*)&UCSR1C)->bit2
#define	_UCSZ12                 ((volatile BYTE_STRUCT*)&UCSR1B)->bit2
inline UsartCharacterSize_ENUM get_UCSZ1(){ return (UsartCharacterSize_ENUM)(_UCSZ10|(_UCSZ11 << 1)|(_UCSZ12 << 2)); }
inline void set_UCSZ1(UsartCharacterSize_ENUM v){ _UCSZ10 = v; _UCSZ11 = v >> 1; _UCSZ12 = v >> 2; }
// Stop Bit Select - UsartStopBitSelect_ENUM - [bit UCSR1C.USBS1] Selects the number of Stop Bits to be inserted by the Transmitter. The Receiver ignores this setting.
#define	_USBS1                  ((volatile BYTE_STRUCT*)&UCSR1C)->bit3
// Parity Mode - UsartParityMode_ENUM - [bit field "UPM1" UCSR1C.(UPM10 | UPM11)] Enable and set type of parity generation and check.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__UPM1            : 2;
} UPM1_STRUCT;

#define	_UPM1                   ((volatile UPM1_STRUCT*)&UCSR1C)->__UPM1
// Clock Polarity - UsartClockPolarity_ENUM - [bit UCSR1C.UCPOL1] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
#define	_UCPOL1                 ((volatile BYTE_STRUCT*)&UCSR1C)->bit0
// Multi-processor Communication Mode - Enabling_ENUM - [bit UCSR1A.MPCM1]
#define	_MPCM1                  ((volatile BYTE_STRUCT*)&UCSR1A)->bit0
// RX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR1B.RXCIE1]
#define	_RXCIE1                 ((volatile BYTE_STRUCT*)&UCSR1B)->bit7
// Data Order - SPIDataOrder_ENUM - [bit UCSR1C.UCSZ11] Sets the order in which bits are transmitted.
// SPI Mode - SPIMode_ENUM - [bit aggregate (UCSR1C.UCSZ10 | UCSR1C.UCPOL1)] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
inline SPIMode_ENUM get_SPIMODE1(){ return (SPIMode_ENUM)(_UCSZ10|(_UCPOL1 << 1)); }
inline void set_SPIMODE1(SPIMode_ENUM v){ _UCSZ10 = v; _UCPOL1 = v >> 1; }
// TX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR1B.TXCIE1]
#define	_TXCIE1                 ((volatile BYTE_STRUCT*)&UCSR1B)->bit6
// Data Register Empty Interrupt Enable - Enabling_ENUM - [bit UCSR1B.UDRIE1] Enable an interrupt when the transmit buffer (UDR) is ready to receive new data.
#define	_UDRIE1                 ((volatile BYTE_STRUCT*)&UCSR1B)->bit5

// other USART1 bit definitions
#define	_RXC1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit7
#define	_TXC1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit6
#define	_UDRE1                  ((volatile BYTE_STRUCT*)&UCSR1A)->bit5
#define	_FE1                    ((volatile BYTE_STRUCT*)&UCSR1A)->bit4
#define	_DOR1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit3
#define	_UPE1                   ((volatile BYTE_STRUCT*)&UCSR1A)->bit2
#define	_RXB81                  ((volatile BYTE_STRUCT*)&UCSR1B)->bit1
#define	_TXB81                  ((volatile BYTE_STRUCT*)&UCSR1B)->bit0
#define	_UMSEL11                ((volatile BYTE_STRUCT*)&UCSR1C)->bit7
#define	_UMSEL10                ((volatile BYTE_STRUCT*)&UCSR1C)->bit6
#define	_UPM11                  ((volatile BYTE_STRUCT*)&UCSR1C)->bit5
#define	_UPM10                  ((volatile BYTE_STRUCT*)&UCSR1C)->bit4

//
// USART2 variable definitions
//
// Receiver Enable - Enabling_ENUM - [bit UCSR2B.RXEN2]
#define	_RXEN2                  ((volatile BYTE_STRUCT*)&UCSR2B)->bit4
// Transmitter Enable - Enabling_ENUM - [bit UCSR2B.TXEN2]
#define	_TXEN2                  ((volatile BYTE_STRUCT*)&UCSR2B)->bit3
// Mode Select - UsartModeSelect_ENUM - [bit field "UMSEL2" UCSR2C.(UMSEL20 | UMSEL21)] Select between Asynchronous and Synchronous mode of operation.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__UMSEL2          : 2;
} UMSEL2_STRUCT;

#define	_UMSEL2                 ((volatile UMSEL2_STRUCT*)&UCSR2C)->__UMSEL2
// Double Transmission Speed - Enabling_ENUM - [bit UCSR2A.U2X2]
#define	_U2X2                   ((volatile BYTE_STRUCT*)&UCSR2A)->bit1
// Character Size - UsartCharacterSize_ENUM - [bit aggregate (UCSR2C.UCSZ20 | UCSR2C.UCSZ21 | UCSR2B.UCSZ22)] Set the number of data bits in a frame the Receiver and Transmitter use.
#define	_UCSZ20                 ((volatile BYTE_STRUCT*)&UCSR2C)->bit1
#define	_UCSZ21                 ((volatile BYTE_STRUCT*)&UCSR2C)->bit2
#define	_UCSZ22                 ((volatile BYTE_STRUCT*)&UCSR2B)->bit2
inline UsartCharacterSize_ENUM get_UCSZ2(){ return (UsartCharacterSize_ENUM)(_UCSZ20|(_UCSZ21 << 1)|(_UCSZ22 << 2)); }
inline void set_UCSZ2(UsartCharacterSize_ENUM v){ _UCSZ20 = v; _UCSZ21 = v >> 1; _UCSZ22 = v >> 2; }
// Stop Bit Select - UsartStopBitSelect_ENUM - [bit UCSR2C.USBS2] Selects the number of Stop Bits to be inserted by the Transmitter. The Receiver ignores this setting.
#define	_USBS2                  ((volatile BYTE_STRUCT*)&UCSR2C)->bit3
// Parity Mode - UsartParityMode_ENUM - [bit field "UPM2" UCSR2C.(UPM20 | UPM21)] Enable and set type of parity generation and check.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__UPM2            : 2;
} UPM2_STRUCT;

#define	_UPM2                   ((volatile UPM2_STRUCT*)&UCSR2C)->__UPM2
// Clock Polarity - UsartClockPolarity_ENUM - [bit UCSR2C.UCPOL2] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
#define	_UCPOL2                 ((volatile BYTE_STRUCT*)&UCSR2C)->bit0
// Multi-processor Communication Mode - Enabling_ENUM - [bit UCSR2A.MPCM2]
#define	_MPCM2                  ((volatile BYTE_STRUCT*)&UCSR2A)->bit0
// RX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR2B.RXCIE2]
#define	_RXCIE2                 ((volatile BYTE_STRUCT*)&UCSR2B)->bit7
// Data Order - SPIDataOrder_ENUM - [bit UCSR2C.UCSZ21] Sets the order in which bits are transmitted.
// SPI Mode - SPIMode_ENUM - [bit aggregate (UCSR2C.UCSZ20 | UCSR2C.UCPOL2)] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
inline SPIMode_ENUM get_SPIMODE2(){ return (SPIMode_ENUM)(_UCSZ20|(_UCPOL2 << 1)); }
inline void set_SPIMODE2(SPIMode_ENUM v){ _UCSZ20 = v; _UCPOL2 = v >> 1; }
// TX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR2B.TXCIE2]
#define	_TXCIE2                 ((volatile BYTE_STRUCT*)&UCSR2B)->bit6
// Data Register Empty Interrupt Enable - Enabling_ENUM - [bit UCSR2B.UDRIE2] Enable an interrupt when the transmit buffer (UDR) is ready to receive new data.
#define	_UDRIE2                 ((volatile BYTE_STRUCT*)&UCSR2B)->bit5

// other USART2 bit definitions
#define	_RXC2                   ((volatile BYTE_STRUCT*)&UCSR2A)->bit7
#define	_TXC2                   ((volatile BYTE_STRUCT*)&UCSR2A)->bit6
#define	_UDRE2                  ((volatile BYTE_STRUCT*)&UCSR2A)->bit5
#define	_FE2                    ((volatile BYTE_STRUCT*)&UCSR2A)->bit4
#define	_DOR2                   ((volatile BYTE_STRUCT*)&UCSR2A)->bit3
#define	_UPE2                   ((volatile BYTE_STRUCT*)&UCSR2A)->bit2
#define	_RXB82                  ((volatile BYTE_STRUCT*)&UCSR2B)->bit1
#define	_TXB82                  ((volatile BYTE_STRUCT*)&UCSR2B)->bit0
#define	_UMSEL21                ((volatile BYTE_STRUCT*)&UCSR2C)->bit7
#define	_UMSEL20                ((volatile BYTE_STRUCT*)&UCSR2C)->bit6
#define	_UPM21                  ((volatile BYTE_STRUCT*)&UCSR2C)->bit5
#define	_UPM20                  ((volatile BYTE_STRUCT*)&UCSR2C)->bit4

//
// USART3 variable definitions
//
// Receiver Enable - Enabling_ENUM - [bit UCSR3B.RXEN3]
#define	_RXEN3                  ((volatile BYTE_STRUCT*)&UCSR3B)->bit4
// Transmitter Enable - Enabling_ENUM - [bit UCSR3B.TXEN3]
#define	_TXEN3                  ((volatile BYTE_STRUCT*)&UCSR3B)->bit3
// Mode Select - UsartModeSelect_ENUM - [bit field "UMSEL3" UCSR3C.(UMSEL30 | UMSEL31)] Select between Asynchronous and Synchronous mode of operation.

typedef struct
{
	unsigned char	__Reserved        : 6;
	unsigned char	__UMSEL3          : 2;
} UMSEL3_STRUCT;

#define	_UMSEL3                 ((volatile UMSEL3_STRUCT*)&UCSR3C)->__UMSEL3
// Double Transmission Speed - Enabling_ENUM - [bit UCSR3A.U2X3]
#define	_U2X3                   ((volatile BYTE_STRUCT*)&UCSR3A)->bit1
// Character Size - UsartCharacterSize_ENUM - [bit aggregate (UCSR3C.UCSZ30 | UCSR3C.UCSZ31 | UCSR3B.UCSZ32)] Set the number of data bits in a frame the Receiver and Transmitter use.
#define	_UCSZ30                 ((volatile BYTE_STRUCT*)&UCSR3C)->bit1
#define	_UCSZ31                 ((volatile BYTE_STRUCT*)&UCSR3C)->bit2
#define	_UCSZ32                 ((volatile BYTE_STRUCT*)&UCSR3B)->bit2
inline UsartCharacterSize_ENUM get_UCSZ3(){ return (UsartCharacterSize_ENUM)(_UCSZ30|(_UCSZ31 << 1)|(_UCSZ32 << 2)); }
inline void set_UCSZ3(UsartCharacterSize_ENUM v){ _UCSZ30 = v; _UCSZ31 = v >> 1; _UCSZ32 = v >> 2; }
// Stop Bit Select - UsartStopBitSelect_ENUM - [bit UCSR3C.USBS3] Selects the number of Stop Bits to be inserted by the Transmitter. The Receiver ignores this setting.
#define	_USBS3                  ((volatile BYTE_STRUCT*)&UCSR3C)->bit3
// Parity Mode - UsartParityMode_ENUM - [bit field "UPM3" UCSR3C.(UPM30 | UPM31)] Enable and set type of parity generation and check.

typedef struct
{
	unsigned char	__Reserved        : 4;
	unsigned char	__UPM3            : 2;
} UPM3_STRUCT;

#define	_UPM3                   ((volatile UPM3_STRUCT*)&UCSR3C)->__UPM3
// Clock Polarity - UsartClockPolarity_ENUM - [bit UCSR3C.UCPOL3] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
#define	_UCPOL3                 ((volatile BYTE_STRUCT*)&UCSR3C)->bit0
// Multi-processor Communication Mode - Enabling_ENUM - [bit UCSR3A.MPCM3]
#define	_MPCM3                  ((volatile BYTE_STRUCT*)&UCSR3A)->bit0
// RX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR3B.RXCIE3]
#define	_RXCIE3                 ((volatile BYTE_STRUCT*)&UCSR3B)->bit7
// Data Order - SPIDataOrder_ENUM - [bit UCSR3C.UCSZ31] Sets the order in which bits are transmitted.
// SPI Mode - SPIMode_ENUM - [bit aggregate (UCSR3C.UCSZ30 | UCSR3C.UCPOL3)] Sets the relationship between data output change and data input sample, and the synchronous clock (XCK).
inline SPIMode_ENUM get_SPIMODE3(){ return (SPIMode_ENUM)(_UCSZ30|(_UCPOL3 << 1)); }
inline void set_SPIMODE3(SPIMode_ENUM v){ _UCSZ30 = v; _UCPOL3 = v >> 1; }
// TX Complete Interrupt Enable - Enabling_ENUM - [bit UCSR3B.TXCIE3]
#define	_TXCIE3                 ((volatile BYTE_STRUCT*)&UCSR3B)->bit6
// Data Register Empty Interrupt Enable - Enabling_ENUM - [bit UCSR3B.UDRIE3] Enable an interrupt when the transmit buffer (UDR) is ready to receive new data.
#define	_UDRIE3                 ((volatile BYTE_STRUCT*)&UCSR3B)->bit5

// other USART3 bit definitions
#define	_RXC3                   ((volatile BYTE_STRUCT*)&UCSR3A)->bit7
#define	_TXC3                   ((volatile BYTE_STRUCT*)&UCSR3A)->bit6
#define	_UDRE3                  ((volatile BYTE_STRUCT*)&UCSR3A)->bit5
#define	_FE3                    ((volatile BYTE_STRUCT*)&UCSR3A)->bit4
#define	_DOR3                   ((volatile BYTE_STRUCT*)&UCSR3A)->bit3
#define	_UPE3                   ((volatile BYTE_STRUCT*)&UCSR3A)->bit2
#define	_RXB83                  ((volatile BYTE_STRUCT*)&UCSR3B)->bit1
#define	_TXB83                  ((volatile BYTE_STRUCT*)&UCSR3B)->bit0
#define	_UMSEL31                ((volatile BYTE_STRUCT*)&UCSR3C)->bit7
#define	_UMSEL30                ((volatile BYTE_STRUCT*)&UCSR3C)->bit6
#define	_UPM31                  ((volatile BYTE_STRUCT*)&UCSR3C)->bit5
#define	_UPM30                  ((volatile BYTE_STRUCT*)&UCSR3C)->bit4

//
// WATCHDOG variable definitions
//
// Prescaler - WdtPrescale_ENUM - [bit aggregate (WDTCSR.WDP0 | WDTCSR.WDP1 | WDTCSR.WDP2 | WDTCSR.WDP3)] Sets the watchdog timeout period. Values are typical at 5v.
#define	_WDP0                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit0
#define	_WDP1                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit1
#define	_WDP2                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit2
#define	_WDP3                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit5
inline WdtPrescale_ENUM get_WDP(){ return (WdtPrescale_ENUM)(_WDP0|(_WDP1 << 1)|(_WDP2 << 2)|(_WDP3 << 3)); }
inline void set_WDP(WdtPrescale_ENUM v){ _WDP0 = v; _WDP1 = v >> 1; _WDP2 = v >> 2; _WDP3 = v >> 3; }
// Configuration - WdtMode_ENUM - [bit aggregate (WDTCSR.WDIE | WDTCSR.WDE)] Determines the action taken when a watchdog timeout occurs.
#define	_WDIE                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit6
#define	_WDE                    ((volatile BYTE_STRUCT*)&WDTCSR)->bit3
inline WdtMode_ENUM get_Mode(){ return (WdtMode_ENUM)(_WDIE|(_WDE << 1)); }
inline void set_Mode(WdtMode_ENUM v){ _WDIE = v; _WDE = v >> 1; }

// other WATCHDOG bit definitions
#define	_WDIF                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit7
#define	_WDCE                   ((volatile BYTE_STRUCT*)&WDTCSR)->bit4

#define _AID_ATmega640_DEFINED_
#endif /* _AID_ATmega640_DEFINED_ */
