#ifndef _AID_ATtiny461_DEFINED_

typedef enum
{
	Disabling_Enabled,                  	// Enabled
	Disabling_Disabled,                 	// Disabled
} Disabling_ENUM;

typedef enum
{
	Enabling_Disabled,                  	// Disabled
	Enabling_Enabled,                   	// Enabled
} Enabling_ENUM;

typedef enum
{
	ACIntModeSelect_OutputToggle,       	// Comparator Interrupt on Output Toggle
	ACIntModeSelect_Reserved,           	// Reserved
	ACIntModeSelect_FallingOutputEdge,  	// Comparator Interrupt on Falling Output Edge
	ACIntModeSelect_RisingOutputEdge,   	// Comparator Interrupt on Rising Output Edge
} ACIntModeSelect_ENUM;

typedef enum
{
	ACBandgapSelect_NoBandgap,          	// Use AIN0 as positive input
	ACBandgapSelect_Bandgap,            	// Use fixed bandgap reference voltage as positive input
} ACBandgapSelect_ENUM;

typedef enum
{
	SenseA_LowLevel,                    	// Low Level Generates Interrupt
	SenseA_AnyChange,                   	// Any Change Generates Interrupt
	SenseA_FallingEdge,                 	// Falling Edge Generates Interrupt
	SenseA_RisingEdge,                  	// Rising Edge Generates Interrupt
} SenseA_ENUM;

typedef enum
{
	WdtPrescale_WDTO_16MS,              	// Typical Time-out 16 ms
	WdtPrescale_WDTO_32MS,              	// Typical Time-out 32 ms
	WdtPrescale_WDTO_64MS,              	// Typical Time-out 64 ms
	WdtPrescale_WDTO_125MS,             	// Typical Time-out 125 ms
	WdtPrescale_WDTO_250MS,             	// Typical Time-out 250 ms
	WdtPrescale_WDTO_500MS,             	// Typical Time-out 500 ms
	WdtPrescale_WDTO_1S,                	// Typical Time-out 1 sec
	WdtPrescale_WDTO_2S,                	// Typical Time-out 2 sec
	WdtPrescale_WDTO_4S,                	// Typical Time-out 4 sec
	WdtPrescale_WDTO_8S,                	// Typical Time-out 8 sec
	WdtPrescale_WDTO_Invalid1,          	// Invalid
	WdtPrescale_WDTO_Invalid2,          	// Invalid
	WdtPrescale_WDTO_Invalid3,          	// Invalid
	WdtPrescale_WDTO_Invalid4,          	// Invalid
	WdtPrescale_WDTO_Invalid5,          	// Invalid
	WdtPrescale_WDTO_Invalid6,          	// Invalid
} WdtPrescale_ENUM;

typedef enum
{
	WdtMode_Disabled,                   	// Disabled
	WdtMode_Interrupt,                  	// Interrupt on timeout
	WdtMode_SystemReset,                	// System reset on timeout
	WdtMode_InterruptAndSystemReset,    	// Interrupt on first timeout, system reset on next
} WdtMode_ENUM;

//
// AD_CONVERTER variable definitions
//
#define	_REFS1                  ((volatile BYTE_STRUCT*)&ADMUX)->bit7
#define	_REFS0                  ((volatile BYTE_STRUCT*)&ADMUX)->bit6
#define	_ADLAR                  ((volatile BYTE_STRUCT*)&ADMUX)->bit5
#define	_MUX4                   ((volatile BYTE_STRUCT*)&ADMUX)->bit4
#define	_MUX3                   ((volatile BYTE_STRUCT*)&ADMUX)->bit3
#define	_MUX2                   ((volatile BYTE_STRUCT*)&ADMUX)->bit2
#define	_MUX1                   ((volatile BYTE_STRUCT*)&ADMUX)->bit1
#define	_MUX0                   ((volatile BYTE_STRUCT*)&ADMUX)->bit0
#define	_ADEN                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit7
#define	_ADSC                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit6
#define	_ADATE                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit5
#define	_ADIF                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit4
#define	_ADIE                   ((volatile BYTE_STRUCT*)&ADCSRA)->bit3
#define	_ADPS2                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit2
#define	_ADPS1                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit1
#define	_ADPS0                  ((volatile BYTE_STRUCT*)&ADCSRA)->bit0
#define	_BIN                    ((volatile BYTE_STRUCT*)&ADCSRB)->bit7
#define	_GSEL                   ((volatile BYTE_STRUCT*)&ADCSRB)->bit6
#define	_IPR                    ((volatile BYTE_STRUCT*)&ADCSRB)->bit5
#define	_REFS2                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit4
#define	_MUX5                   ((volatile BYTE_STRUCT*)&ADCSRB)->bit3
#define	_ADTS2                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit2
#define	_ADTS1                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit1
#define	_ADTS0                  ((volatile BYTE_STRUCT*)&ADCSRB)->bit0
#define	_ADC6D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit7
#define	_ADC5D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit6
#define	_ADC4D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit5
#define	_ADC3D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit4
#define	_AREFD                  ((volatile BYTE_STRUCT*)&DIDR0)->bit3
#define	_ADC2D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit2
#define	_ADC1D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit1
#define	_ADC0D                  ((volatile BYTE_STRUCT*)&DIDR0)->bit0
#define	_ADC10D                 ((volatile BYTE_STRUCT*)&DIDR1)->bit7
#define	_ADC9D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit6
#define	_ADC8D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit5
#define	_ADC7D                  ((volatile BYTE_STRUCT*)&DIDR1)->bit4

//
// ANALOG_COMPARATOR variable definitions
//
// Analog Comparator Disable - Disabling_ENUM - [bit ACSRA.ACD] Disables the Analog Comparator.
#define	_ACD                    ((volatile BYTE_STRUCT*)&ACSRA)->bit7
// Interrupt Enable - Enabling_ENUM - [bit ACSRA.ACIE] When enabled and the I-bit in the Status Register is set, the Analog Comparator interrupt is activated.
#define	_ACIE                   ((volatile BYTE_STRUCT*)&ACSRA)->bit3
// Interrupt Mode Select - ACIntModeSelect_ENUM - [bit field "ACIS" ACSRA.(ACIS0 | ACIS1)] Determine which comparator events trigger the Analog Comparator interrupt.

typedef struct
{
	unsigned char	__ACIS            : 2;
} ACIS_STRUCT;

#define	_ACIS                   ((volatile ACIS_STRUCT*)&ACSRA)->__ACIS
// Bandgap Select - ACBandgapSelect_ENUM - [bit ACSRA.ACBG] Selects a bandgap reference voltage as the positive input.
#define	_ACBG                   ((volatile BYTE_STRUCT*)&ACSRA)->bit6
// Multiplexer Enable - Enabling_ENUM - [bit ACSRA.ACME] When enabled and the ADC is switched off, the ADC multiplexer selects the negative input to the Analog Comparator. When disabled, AIN1 is applied to the negative input of the Analog Comparator.
#define	_ACME                   ((volatile BYTE_STRUCT*)&ACSRA)->bit2

// other ANALOG_COMPARATOR bit definitions
#define	_ACO                    ((volatile BYTE_STRUCT*)&ACSRA)->bit5
#define	_ACI                    ((volatile BYTE_STRUCT*)&ACSRA)->bit4
#define	_ACIS1                  ((volatile BYTE_STRUCT*)&ACSRA)->bit1
#define	_ACIS0                  ((volatile BYTE_STRUCT*)&ACSRA)->bit0
#define	_HSEL                   ((volatile BYTE_STRUCT*)&ACSRB)->bit7
#define	_HLEV                   ((volatile BYTE_STRUCT*)&ACSRB)->bit6
#define	_ACM2                   ((volatile BYTE_STRUCT*)&ACSRB)->bit2
#define	_ACM1                   ((volatile BYTE_STRUCT*)&ACSRB)->bit1
#define	_ACM0                   ((volatile BYTE_STRUCT*)&ACSRB)->bit0

//
// BOOT_LOAD variable definitions
//
#define	_CTPB                   ((volatile BYTE_STRUCT*)&SPMCSR)->bit4
#define	_RFLB                   ((volatile BYTE_STRUCT*)&SPMCSR)->bit3
#define	_PGWRT                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit2
#define	_PGERS                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit1
#define	_SPMEN                  ((volatile BYTE_STRUCT*)&SPMCSR)->bit0

//
// CPU variable definitions
//
#define	_PUD                    ((volatile BYTE_STRUCT*)&MCUCR)->bit6
#define	_SE                     ((volatile BYTE_STRUCT*)&MCUCR)->bit5
#define	_SM1                    ((volatile BYTE_STRUCT*)&MCUCR)->bit4
#define	_SM0                    ((volatile BYTE_STRUCT*)&MCUCR)->bit3
#define	_ISC01                  ((volatile BYTE_STRUCT*)&MCUCR)->bit1
#define	_ISC00                  ((volatile BYTE_STRUCT*)&MCUCR)->bit0
#define	_WDRF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit3
#define	_BORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit2
#define	_EXTRF                  ((volatile BYTE_STRUCT*)&MCUSR)->bit1
#define	_PORF                   ((volatile BYTE_STRUCT*)&MCUSR)->bit0
#define	_PRTIM1                 ((volatile BYTE_STRUCT*)&PRR)->bit3
#define	_PRTIM0                 ((volatile BYTE_STRUCT*)&PRR)->bit2
#define	_PRUSI                  ((volatile BYTE_STRUCT*)&PRR)->bit1
#define	_PRADC                  ((volatile BYTE_STRUCT*)&PRR)->bit0
#define	_LSM                    ((volatile BYTE_STRUCT*)&PLLCSR)->bit7
#define	_PCKE                   ((volatile BYTE_STRUCT*)&PLLCSR)->bit2
#define	_PLLE                   ((volatile BYTE_STRUCT*)&PLLCSR)->bit1
#define	_PLOCK                  ((volatile BYTE_STRUCT*)&PLLCSR)->bit0
#define	_CLKPCE                 ((volatile BYTE_STRUCT*)&CLKPR)->bit7
#define	_CLKPS3                 ((volatile BYTE_STRUCT*)&CLKPR)->bit3
#define	_CLKPS2                 ((volatile BYTE_STRUCT*)&CLKPR)->bit2
#define	_CLKPS1                 ((volatile BYTE_STRUCT*)&CLKPR)->bit1
#define	_CLKPS0                 ((volatile BYTE_STRUCT*)&CLKPR)->bit0

//
// EEPROM variable definitions
//
#define	_EEPM1                  ((volatile BYTE_STRUCT*)&EECR)->bit5
#define	_EEPM0                  ((volatile BYTE_STRUCT*)&EECR)->bit4
#define	_EERIE                  ((volatile BYTE_STRUCT*)&EECR)->bit3
#define	_EEMPE                  ((volatile BYTE_STRUCT*)&EECR)->bit2
#define	_EEPE                   ((volatile BYTE_STRUCT*)&EECR)->bit1
#define	_EERE                   ((volatile BYTE_STRUCT*)&EECR)->bit0

//
// EXTERNAL_INTERRUPT variable definitions
//
// INT0 Interrupt Enable - Enabling_ENUM - [bit GIMSK.INT0] Enables the interrupt on the INT pin
#define	_INT0                   ((volatile BYTE_STRUCT*)&GIMSK)->bit6
// INT0 Interrupt Sense Control - SenseA_ENUM - [bit field "ISC0" MCUCR.(ISC00 | ISC01)] Specifies the type of signal that will generate an interrupt

typedef struct
{
	unsigned char	__ISC0            : 2;
} ISC0_STRUCT;

#define	_ISC0                   ((volatile ISC0_STRUCT*)&MCUCR)->__ISC0
// INT1 Interrupt Enable - Enabling_ENUM - [bit GIMSK.INT1] Enables the interrupt on the INT pin
#define	_INT1                   ((volatile BYTE_STRUCT*)&GIMSK)->bit7
// PCINT0 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT0] Enables interrupts on PCINT0
#define	_PCINT0                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit0
// PCINT1 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT1] Enables interrupts on PCINT1
#define	_PCINT1                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit1
// PCINT2 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT2] Enables interrupts on PCINT2
#define	_PCINT2                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit2
// PCINT3 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT3] Enables interrupts on PCINT3
#define	_PCINT3                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit3
// PCINT4 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT4] Enables interrupts on PCINT4
#define	_PCINT4                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit4
// PCINT5 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT5] Enables interrupts on PCINT5
#define	_PCINT5                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit5
// PCINT6 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT6] Enables interrupts on PCINT6
#define	_PCINT6                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit6
// PCINT7 Interrupt Enable - Enabling_ENUM - [bit PCMSK0.PCINT7] Enables interrupts on PCINT7
#define	_PCINT7                 ((volatile BYTE_STRUCT*)&PCMSK0)->bit7
// PCINT8 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT8] Enables interrupts on PCINT8
#define	_PCINT8                 ((volatile BYTE_STRUCT*)&PCMSK1)->bit0
// PCINT9 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT9] Enables interrupts on PCINT9
#define	_PCINT9                 ((volatile BYTE_STRUCT*)&PCMSK1)->bit1
// PCINT10 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT10] Enables interrupts on PCINT10
#define	_PCINT10                ((volatile BYTE_STRUCT*)&PCMSK1)->bit2
// PCINT11 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT11] Enables interrupts on PCINT11
#define	_PCINT11                ((volatile BYTE_STRUCT*)&PCMSK1)->bit3
// PCINT12 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT12] Enables interrupts on PCINT12
#define	_PCINT12                ((volatile BYTE_STRUCT*)&PCMSK1)->bit4
// PCINT13 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT13] Enables interrupts on PCINT13
#define	_PCINT13                ((volatile BYTE_STRUCT*)&PCMSK1)->bit5
// PCINT14 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT14] Enables interrupts on PCINT14
#define	_PCINT14                ((volatile BYTE_STRUCT*)&PCMSK1)->bit6
// PCINT15 Interrupt Enable - Enabling_ENUM - [bit PCMSK1.PCINT15] Enables interrupts on PCINT15
#define	_PCINT15                ((volatile BYTE_STRUCT*)&PCMSK1)->bit7
// PCIE0 Interrupt Enable - Enabling_ENUM - [bit GIMSK.PCIE0] Enables interrupts for PCINT7..0
#define	_PCIE0                  ((volatile BYTE_STRUCT*)&GIMSK)->bit4
// PCIE1 Interrupt Enable - Enabling_ENUM - [bit GIMSK.PCIE1] Enables interrupts for PCINT15..8
#define	_PCIE1                  ((volatile BYTE_STRUCT*)&GIMSK)->bit5

// other EXTERNAL_INTERRUPT bit definitions
#define	_INTF1                  ((volatile BYTE_STRUCT*)&GIFR)->bit7
#define	_INTF0                  ((volatile BYTE_STRUCT*)&GIFR)->bit6
#define	_PCIF                   ((volatile BYTE_STRUCT*)&GIFR)->bit5

//
// TIMER_COUNTER_0 variable definitions
//
#define	_OCIE0A                 ((volatile BYTE_STRUCT*)&TIMSK)->bit4
#define	_OCIE0B                 ((volatile BYTE_STRUCT*)&TIMSK)->bit3
#define	_TOIE0                  ((volatile BYTE_STRUCT*)&TIMSK)->bit1
#define	_TICIE0                 ((volatile BYTE_STRUCT*)&TIMSK)->bit0
#define	_OCF0A                  ((volatile BYTE_STRUCT*)&TIFR)->bit4
#define	_OCF0B                  ((volatile BYTE_STRUCT*)&TIFR)->bit3
#define	_TOV0                   ((volatile BYTE_STRUCT*)&TIFR)->bit1
#define	_ICF0                   ((volatile BYTE_STRUCT*)&TIFR)->bit0
#define	_TCW0                   ((volatile BYTE_STRUCT*)&TCCR0A)->bit7
#define	_ICEN0                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit6
#define	_ICNC0                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit5
#define	_ICES0                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit4
#define	_ACIC0                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit3
#define	_WGM00                  ((volatile BYTE_STRUCT*)&TCCR0A)->bit0
#define	_TSM                    ((volatile BYTE_STRUCT*)&TCCR0B)->bit4
#define	_PSR0                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit3
#define	_CS02                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit2
#define	_CS01                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit1
#define	_CS00                   ((volatile BYTE_STRUCT*)&TCCR0B)->bit0

//
// TIMER_COUNTER_1 variable definitions
//
#define	_COM1A1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit7
#define	_COM1A0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit6
#define	_COM1B1                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit5
#define	_COM1B0                 ((volatile BYTE_STRUCT*)&TCCR1A)->bit4
#define	_FOC1A                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit3
#define	_FOC1B                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit2
#define	_PWM1A                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit1
#define	_PWM1B                  ((volatile BYTE_STRUCT*)&TCCR1A)->bit0
#define	_PSR1                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit6
#define	_DTPS11                 ((volatile BYTE_STRUCT*)&TCCR1B)->bit5
#define	_DTPS10                 ((volatile BYTE_STRUCT*)&TCCR1B)->bit4
#define	_CS13                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit3
#define	_CS12                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit2
#define	_CS11                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit1
#define	_CS10                   ((volatile BYTE_STRUCT*)&TCCR1B)->bit0
#define	_COM1A1S                ((volatile BYTE_STRUCT*)&TCCR1C)->bit7
#define	_COM1A0S                ((volatile BYTE_STRUCT*)&TCCR1C)->bit6
#define	_COM1B1S                ((volatile BYTE_STRUCT*)&TCCR1C)->bit5
#define	_COM1B0S                ((volatile BYTE_STRUCT*)&TCCR1C)->bit4
#define	_COM1D1                 ((volatile BYTE_STRUCT*)&TCCR1C)->bit3
#define	_COM1D0                 ((volatile BYTE_STRUCT*)&TCCR1C)->bit2
#define	_FOC1D                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit1
#define	_PWM1D                  ((volatile BYTE_STRUCT*)&TCCR1C)->bit0
#define	_FPIE1                  ((volatile BYTE_STRUCT*)&TCCR1D)->bit7
#define	_FPEN1                  ((volatile BYTE_STRUCT*)&TCCR1D)->bit6
#define	_FPNC1                  ((volatile BYTE_STRUCT*)&TCCR1D)->bit5
#define	_FPES1                  ((volatile BYTE_STRUCT*)&TCCR1D)->bit4
#define	_FPAC1                  ((volatile BYTE_STRUCT*)&TCCR1D)->bit3
#define	_FPF1                   ((volatile BYTE_STRUCT*)&TCCR1D)->bit2
#define	_WGM11                  ((volatile BYTE_STRUCT*)&TCCR1D)->bit1
#define	_WGM10                  ((volatile BYTE_STRUCT*)&TCCR1D)->bit0
#define	_OCIE1D                 ((volatile BYTE_STRUCT*)&TIMSK)->bit7
#define	_OCIE1A                 ((volatile BYTE_STRUCT*)&TIMSK)->bit6
#define	_OCIE1B                 ((volatile BYTE_STRUCT*)&TIMSK)->bit5
#define	_TOIE1                  ((volatile BYTE_STRUCT*)&TIMSK)->bit2
#define	_OCF1D                  ((volatile BYTE_STRUCT*)&TIFR)->bit7
#define	_OCF1A                  ((volatile BYTE_STRUCT*)&TIFR)->bit6
#define	_OCF1B                  ((volatile BYTE_STRUCT*)&TIFR)->bit5
#define	_TOV1                   ((volatile BYTE_STRUCT*)&TIFR)->bit2
#define	_DT1H0                  ((volatile BYTE_STRUCT*)&DT1)->bit4
#define	_DT1H1                  ((volatile BYTE_STRUCT*)&DT1)->bit5
#define	_DT1H2                  ((volatile BYTE_STRUCT*)&DT1)->bit6
#define	_DT1H3                  ((volatile BYTE_STRUCT*)&DT1)->bit7
#define	_DT1L0                  ((volatile BYTE_STRUCT*)&DT1)->bit0
#define	_DT1L1                  ((volatile BYTE_STRUCT*)&DT1)->bit1
#define	_DT1L2                  ((volatile BYTE_STRUCT*)&DT1)->bit2
#define	_DT1L3                  ((volatile BYTE_STRUCT*)&DT1)->bit3

//
// USI variable definitions
//
#define	_USIPOS                 ((volatile BYTE_STRUCT*)&USIPP)->bit0
#define	_USISIF                 ((volatile BYTE_STRUCT*)&USISR)->bit7
#define	_USIOIF                 ((volatile BYTE_STRUCT*)&USISR)->bit6
#define	_USIPF                  ((volatile BYTE_STRUCT*)&USISR)->bit5
#define	_USIDC                  ((volatile BYTE_STRUCT*)&USISR)->bit4
#define	_USICNT3                ((volatile BYTE_STRUCT*)&USISR)->bit3
#define	_USICNT2                ((volatile BYTE_STRUCT*)&USISR)->bit2
#define	_USICNT1                ((volatile BYTE_STRUCT*)&USISR)->bit1
#define	_USICNT0                ((volatile BYTE_STRUCT*)&USISR)->bit0
#define	_USISIE                 ((volatile BYTE_STRUCT*)&USICR)->bit7
#define	_USIOIE                 ((volatile BYTE_STRUCT*)&USICR)->bit6
#define	_USIWM1                 ((volatile BYTE_STRUCT*)&USICR)->bit5
#define	_USIWM0                 ((volatile BYTE_STRUCT*)&USICR)->bit4
#define	_USICS1                 ((volatile BYTE_STRUCT*)&USICR)->bit3
#define	_USICS0                 ((volatile BYTE_STRUCT*)&USICR)->bit2
#define	_USICLK                 ((volatile BYTE_STRUCT*)&USICR)->bit1
#define	_USITC                  ((volatile BYTE_STRUCT*)&USICR)->bit0

//
// WATCHDOG variable definitions
//
// Prescaler - WdtPrescale_ENUM - [bit aggregate (WDTCR.WDP0 | WDTCR.WDP1 | WDTCR.WDP2 | WDTCR.WDP3)] Sets the watchdog timeout period. Values are typical at 5v.
#define	_WDP0                   ((volatile BYTE_STRUCT*)&WDTCR)->bit0
#define	_WDP1                   ((volatile BYTE_STRUCT*)&WDTCR)->bit1
#define	_WDP2                   ((volatile BYTE_STRUCT*)&WDTCR)->bit2
#define	_WDP3                   ((volatile BYTE_STRUCT*)&WDTCR)->bit5
inline WdtPrescale_ENUM get_WDP(){ return (WdtPrescale_ENUM)(_WDP0|(_WDP1 << 1)|(_WDP2 << 2)|(_WDP3 << 3)); }
inline void set_WDP(WdtPrescale_ENUM v){ _WDP0 = v; _WDP1 = v >> 1; _WDP2 = v >> 2; _WDP3 = v >> 3; }
// Configuration - WdtMode_ENUM - [bit aggregate (WDTCR.WDIE | WDTCR.WDE)] Determines the action taken when a watchdog timeout occurs.
#define	_WDIE                   ((volatile BYTE_STRUCT*)&WDTCR)->bit6
#define	_WDE                    ((volatile BYTE_STRUCT*)&WDTCR)->bit3
inline WdtMode_ENUM get_Mode(){ return (WdtMode_ENUM)(_WDIE|(_WDE << 1)); }
inline void set_Mode(WdtMode_ENUM v){ _WDIE = v; _WDE = v >> 1; }

// other WATCHDOG bit definitions
#define	_WDIF                   ((volatile BYTE_STRUCT*)&WDTCR)->bit7
#define	_WDCE                   ((volatile BYTE_STRUCT*)&WDTCR)->bit4

#define _AID_ATtiny461_DEFINED_
#endif /* _AID_ATtiny461_DEFINED_ */
